#define seg_a  PORTB.5
#define seg_b  PORTB.1
#define seg_c  PORTC.3
#define seg_d  PORTC.5
#define seg_e  PORTC.4
#define seg_f  PORTB.4
#define seg_g  PORTC.2
#define seg_dp PORTD.0
   
#define digit_1  PORTC.0
#define digit_2  PORTB.3
#define digit_3  PORTB.2
#define digit_4  PORTC.1

#define rad_led PORTD.1
#define vibra PORTD.4


unsigned char data[4]; //      
unsigned int dot[4]; //       


//    7
void calculate_segments(char character)
{

    switch (character)
    {
        case 0:
        case '0':
        case 'O':
            seg_a=1;seg_b=1;seg_c=1;seg_d=1;seg_e=1;seg_f=1;seg_g=0;
            break;
        case 1:
        case '1':
        case 'l':
            seg_a=0;seg_b=1;seg_c=1;seg_d=0;seg_e=0;seg_f=0;seg_g=0;
            break;
        case 2:
        case '2':
            seg_a=1;seg_b=1;seg_c=0;seg_d=1;seg_e=1;seg_f=0;seg_g=1;
            break;
        case 3:
        case '3':
            seg_a=1;seg_b=1;seg_c=1;seg_d=1;seg_e=0;seg_f=0;seg_g=1;
            break;
        case 4:
        case '4':
            seg_a=0;seg_b=1;seg_c=1;seg_d=0;seg_e=0;seg_f=1;seg_g=1;
            break;
        case 5:
        case '5':
        case 'S':
        case 's':
            seg_a=1;seg_b=0;seg_c=1;seg_d=1;seg_e=0;seg_f=1;seg_g=1;
            break;
        case 6:
        case '6':
            seg_a=1;seg_b=0;seg_c=1;seg_d=1;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 7:
        case '7':
            seg_a=1;seg_b=1;seg_c=1;seg_d=0;seg_e=0;seg_f=0;seg_g=0;
            break;
        case 8:
        case '8':
            seg_a=1;seg_b=1;seg_c=1;seg_d=1;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 9:
        case '9':
        case 'g':
            seg_a=1;seg_b=1;seg_c=1;seg_d=1;seg_e=0;seg_f=1;seg_g=1;
            break;
        case 10:
        case 'A':
        case 'a':
            seg_a=1;seg_b=1;seg_c=1;seg_d=0;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 11:
        case 'B':
        case 'b':
            seg_a=0;seg_b=0;seg_c=1;seg_d=1;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 12:
        case 'C':
            seg_a=1;seg_b=0;seg_c=0;seg_d=1;seg_e=1;seg_f=1;seg_g=0;
            break;
        case 'c':
            seg_a=0;seg_b=0;seg_c=0;seg_d=1;seg_e=1;seg_f=0;seg_g=1;
            break;
        case 13:
        case 'D':
        case 'd':
            seg_a=0;seg_b=1;seg_c=1;seg_d=1;seg_e=1;seg_f=0;seg_g=1;
            break;
        case 14:
        case 'E':
            seg_a=1;seg_b=0;seg_c=0;seg_d=1;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 'e':
            seg_a=1;seg_b=1;seg_c=0;seg_d=1;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 15:
        case 'F':
        case 'f':
            seg_a=1;seg_b=0;seg_c=0;seg_d=0;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 'G':
            seg_a=1;seg_b=0;seg_c=1;seg_d=1;seg_e=1;seg_f=1;seg_g=0;
            break;
        case 'H':
            seg_a=0;seg_b=1;seg_c=1;seg_d=0;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 'h': 
            seg_a=0;seg_b=0;seg_c=1;seg_d=0;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 'I':
        case 'i':
            seg_a=0;seg_b=1;seg_c=1;seg_d=0;seg_e=0;seg_f=0;seg_g=0;
            break;
        case 'J':
        case 'j':
            seg_a=0;seg_b=1;seg_c=1;seg_d=1;seg_e=1;seg_f=0;seg_g=0;
            break;
        case 'L':
            seg_a=0;seg_b=0;seg_c=0;seg_d=1;seg_e=1;seg_f=1;seg_g=0;
            break;
        case 'M':
        case 'm':
            seg_a=1;seg_b=0;seg_c=1;seg_d=0;seg_e=1;seg_f=0;seg_g=1;
            break;
        case 'N':
        case 'n':
            seg_a=0;seg_b=0;seg_c=1;seg_d=0;seg_e=1;seg_f=0;seg_g=1;
            break;
        case 'o':
            seg_a=0;seg_b=0;seg_c=1;seg_d=1;seg_e=1;seg_f=0;seg_g=1;
            break;
        case 'P':
        case 'p':
            seg_a=1;seg_b=1;seg_c=0;seg_d=0;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 'Q':
        case 'q':
            seg_a=1;seg_b=1;seg_c=1;seg_d=0;seg_e=0;seg_f=1;seg_g=1;
            break;
        case 'R':
        case 'r':
            seg_a=0;seg_b=0;seg_c=0;seg_d=0;seg_e=1;seg_f=0;seg_g=1;
            break;
        case 'T':
        case 't':
            seg_a=0;seg_b=0;seg_c=0;seg_d=1;seg_e=1;seg_f=1;seg_g=1;
            break;
        case 'U':
            seg_a=0;seg_b=1;seg_c=1;seg_d=1;seg_e=1;seg_f=1;seg_g=0;
            break;
		case 'u':
            seg_a=0;seg_b=0;seg_c=1;seg_d=1;seg_e=1;seg_f=0;seg_g=0;
			break;
		case 'V':
		case 'v':
            seg_a=0;seg_b=0;seg_c=1;seg_d=1;seg_e=1;seg_f=0;seg_g=0;
			break;
		case 'W':
		case 'w':
            seg_a=1;seg_b=0;seg_c=1;seg_d=1;seg_e=1;seg_f=0;seg_g=0;
			break;
		case 'Y':
		case 'y':
            seg_a=0;seg_b=1;seg_c=1;seg_d=1;seg_e=0;seg_f=1;seg_g=1;
			break;
		case '-':
            seg_a=0;seg_b=0;seg_c=0;seg_d=0;seg_e=0;seg_f=0;seg_g=1;
			break;
		case '"':
            seg_a=0;seg_b=1;seg_c=0;seg_d=0;seg_e=0;seg_f=1;seg_g=0;
			break;
		case 0x27:	// "'"
            seg_a=0;seg_b=1;seg_c=0;seg_d=0;seg_e=0;seg_f=0;seg_g=0;
			break;
		case '_':
            seg_a=0;seg_b=0;seg_c=0;seg_d=1;seg_e=0;seg_f=0;seg_g=0;
			break;
		case '*':
            seg_a=0;seg_b=0;seg_c=0;seg_d=0;seg_e=0;seg_f=0;seg_g=0;
		default:
            seg_a=0;seg_b=0;seg_c=0;seg_d=0;seg_e=0;seg_f=0;seg_g=0;
			break;
	}

}

void clearDisplay(void)
{
	seg_a=0;seg_b=0;seg_c=0;seg_d=0;seg_e=0;seg_f=0;seg_g=0;seg_dp=0;
    digit_1=1;digit_2=1;digit_3=1;digit_4=1;  //   
}

void clearDisplayBuffer(void)
{
    data[0]='*';data[1]='*';data[2]='*';data[3]='*'; // "*"      
    dot[0]=0;dot[1]=0;dot[2]=0;dot[3]=0;

}

void show(int pos, int digit)
{	
        clearDisplay();

		calculate_segments(data[pos]);
        if (dot[pos]) seg_dp=1; else seg_dp=0;    
	//   
	switch (digit)
	{
		case 1:
        digit_1=0;          //  1 
			break;
		case 2:
        digit_2=0;          //  2 
			break;
		case 3:
        digit_3=0;          //  3 
			break;	
		case 4:
        digit_4=0;          //  4 
			break;
	}
}

void set_char_at(char c, int offset, int dotflag)
{
	data[offset] = c;
    dot[offset] = dotflag;
}


void shift_in(char c, int dotflag)
{
	data[0] = data[1];
	data[1] = data[2];
	data[2] = data[3];
	data[3] = c;

	dot[0] = dot[1];
	dot[1] = dot[2];
	dot[2] = dot[3];
	dot[3] = dotflag;
}


int multiplex_counter = 0;
void multiplex(void)
{
multiplex_counter++;
    if (multiplex_counter == 1)
		show(0, 1);
	else if (multiplex_counter == 2)
		show(1, 2);
	else if (multiplex_counter == 3)
		show(2, 3);
	else if (multiplex_counter == 4)
		show(3, 4);
    else if (multiplex_counter == 5) 
        clearDisplay(); 
        
if (multiplex_counter > 5) 
		{
multiplex_counter = 0;
		}      

}

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
    
        TCNT0 = 0xFF; 
    if (display) multiplex();
}



// //   7
