void pump();
void calc_counters();
void alarm_check();
void check_battery();
void check_sbm20();
void read_adc();
void poweroff();
void led_refresh(char command);

/***********************************************************************************************/
void poweroff()
{
	LcdClear();

	sprintf (lcd_buf, "    ");
	LcdStringInv(1,3);
    LcdUpdate();
    delay_ms(2000);

#pragma optsize-
WDTCR=0x1F;
WDTCR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei")
GICR=0x40;
MCUCR=0xA0;

DDRB=0x00;
DDRC=0x00;
DDRD=0x00;

PORTB=0x00;
PORTC=0x00;
PORTD=0x00;

TCCR0=0x00;
TCNT0=0xFF;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

TIMSK=0x00;

PORTD.2=1; //   
DDRD.2=0;
delay_ms(1);

#asm("sei")
poweroff_bit=0;
while(!poweroff_bit)
{
    #asm("sleep")
}
LcdInit();
	LcdClear();
    

	sprintf (lcd_buf, "     ");
	LcdStringInv(1,3);
    LcdUpdate();
    delay_ms(1000);


#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

while(1)
{
#asm("sleep")
}

}


/***********************************************************************************************/
bit blue_led_save=1;
bit red_led_save=1;

void led_refresh(char command)
{
if(command==OFF)
{
            blue_led_pin=0;
            red_led_pin=0;
            return;
}

if(command==ON)
{
            blue_led_pin=blue_led_save;
            red_led_pin=red_led_save;
            return;
}

    if(!power_down)
    {
        if(alarm)
        {
            blue_led_pin=0;
            blue_led_save=0;
            
            red_led_pin=1;
            red_led_save=1;
            
        } else
        {
            blue_led_pin=1;
            blue_led_save=1;
            
            red_led_pin=0;
            red_led_save=0;            
        }
    } else
    {
            blue_led_pin=0;
            blue_led_save=0;
            
            red_led_pin=0;
            red_led_save=0;
    }
}

void pump()
{
unsigned int i;

if(need_pump) 
{
    GICR=0x00;
    led_refresh(OFF);
    for(i=0;i<delay_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(10);
        #asm("wdr")
    }
    delay_us(25);
    led_refresh(ON);
    need_pump=0;
    GICR=0xC0;
}
}

//********************************************************************

void calc_counters()
{
char i;

impulse_count=0;
for(i=0;i<37;i++)impulse_count+=impulse_massive[i];
impulse_recive=0;

#asm("wdr")
 if(second>36)
 {
       check_sbm20();
       second=0;
       impulse_massive[0]=0;
//       ready=1;
 }  
        
/* if(impulse_count!=impulse_count_old)
 {
    impulse_count_old=impulse_count;
    //LcdClear();

    #asm("wdr")
       
 } 
*/
}

//********************************************************************

void alarm_check()
{
if((impulse_count>alarm_level)&(!user_cancel_alarm)&(alarm_level>0))
    {
        beep=1;
        TIMSK=0x41;
        LcdPwrOn();
        alarm=1;

    }
if((impulse_count<alarm_level)|(alarm_level==0))
    {
        if(alarm)
        {
            alarm=0;
            user_cancel_alarm=0;
        }
    }
}

//********************************************************************

void check_battery()
{
 read_adc();

impulse_pump=impulse_pump_def; // 
delay_pump=delay_pump_def; // 

if(VoltLevel>140)VoltLevel=140;
if(VoltLevel<90)VoltLevel=90;
battery_procent=(VoltLevel-90)*2;

 if(VoltLevel<95) //    0.95,  .
 {
         TIMSK=0x41;
         delay_ms(30);
         TIMSK=0x40;
         delay_ms(60);
         TIMSK=0x41;
         delay_ms(30);
         TIMSK=0x40;
         delay_ms(60);
         TIMSK=0x41;
         delay_ms(30);
         TIMSK=0x40;
         beep_pin=0;
         #asm("wdr")
 }

}
//********************************************************************

void check_sbm20()
{
if(impulse_count==0){error_count++;}
else{error_count=0;}

 if(error_count>5) //    ,  .
 {
         TIMSK=0x41;
         delay_ms(1000);
         #asm("wdr")
         TIMSK=0x40;
         delay_ms(600);
         #asm("wdr")
         TIMSK=0x41;
         delay_ms(1000);
         #asm("wdr")
         TIMSK=0x40;
         delay_ms(600);
         #asm("wdr")
         TIMSK=0x41;
         delay_ms(1000);
         #asm("wdr")
         TIMSK=0x40;
         beep_pin=0;
 }

}
//********************************************************************

void read_adc()
{       unsigned int  tmpv=0;
        unsigned char ixi=64,MCUCR_def;

        #asm("sei");        //   
	    ADMUX= 0b11100111;
		
	ADCSRA=0b10011111;
    MCUCR_def=MCUCR; 
        MCUCR=0x90;	  //    
        delay_us(125);
        TIMSK=0x00; 
        while(ixi>0)
        {
         #asm("sleep");    //   
         #asm("wdr");
	     tmpv+=VoltLevel;                   
         ixi--;
        }
	TIMSK=0x40;
    beep_pin=0; 
        MCUCR=MCUCR_def;       //   .
        ADCSRA=0x00; 
	ACSR=0x00; 
	ADMUX=0x00;   //       
            
        VoltLevel=(tmpv>>6);
}
