#define nusik_fix

#define blink_led_on_pulse //   
//#define blink_led_on_work  //   

#define impulse_pump_def 13         //              (330 )
#define delay_pump_timeout 1        //      
//#define delay_pump_def 100          //           (330 )

eeprom int delay_pump_def=140;     //           (330 )
//eeprom int volt_max=1500;          //   
eeprom int sleep_time=30;          //    
eeprom int alarm_level=50;         //     
eeprom unsigned char Vop = 80;     //  

char menu_select=1;
bit menu_active=0;

unsigned int impulse_pump;
unsigned int delay_pump;

unsigned char battery_procent=0;

unsigned int div_gpaph=10;

bit need_pump=0;
unsigned int need_pump_by_impulse=0;
unsigned char tick=0, second=0;
unsigned long impulse_count=0,doze_count=0;

unsigned char second_tick=0;
unsigned char minute_tick=0;
unsigned char hour_tick=0;
unsigned int day_tick=0;

unsigned int impulse_massive[38];
unsigned long doze_massive[25];

unsigned int key_press=0;

unsigned int VoltLevel=0;

bit alarm=0;
bit user_cancel_alarm=0;

bit impulse_recive=0;

//bit ready=0;

int display_time=0;

char error_count=0;
unsigned char beep_count=0;

bit beep=0;
bit beep_active=0;
bit poweroff_bit=0;

bit need_update=0; 

void led_refresh(char command);

#define ON  1
#define OFF  2
#define NONE  3

#define blue_led_pin  PORTD.5
#define red_led_pin   PORTD.0
#define beep_pin      PORTC.1
#define trans         PORTD.1
#define key           PIND.2 //(int0)
#define key_plus      PINC.2 //(key +)
#define impulse       PIND.3 //(int1)

#include <mega8.h>
#include <delay.h>
#include <stdio.h>

#include <n3310lcd.c>

#include <microdozik.h>
#include <display_data.h> 


//********************************************************************
void check_battery();

//--------------------------------- --------------------------//
interrupt [ADC_INT] void voidadc_isr(void)
{
	VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
}

//********************************************************************

interrupt [EXT_INT1] void ext_int1_isr(void)
{
unsigned char i;

    #asm("wdr")
    led_refresh(OFF);
    need_update=1;
    impulse_recive=1;
//    beep_pin=1; 
    trans=0; //      
    impulse_massive[second]++;
    doze_massive[hour_tick]++;
    need_pump_by_impulse++;
    tick=0;
    impulse_count++;
    for(i=0;i<impulse_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(5);
        #asm("wdr")
    }
//    beep_pin=0;
if(!power_down)
{
    beep=1;
    TIMSK=0x41;
    led_refresh(ON);

}  
    
}

//********************************************************************

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
TCNT0=0xFF;
if(!beep)
{
    TIMSK=0x40;
    beep_pin=0;
    led_refresh(ON);
}
else
{
    if(beep_count<250)
    {
        beep_count++;
        if(!beep_active)
        {
            beep_pin=0;
            led_refresh(ON);
            beep_active=1;
        }
        else
        {
            led_refresh(OFF);
            beep_pin=1;
            beep_active=0;
        }
    }
    else
    {
        
        if(alarm&(!user_cancel_alarm))
        {
            beep_count=0;
        }
        else
        {
            beep_pin=0;
            led_refresh(ON);
            beep_count=0;
            TIMSK=0x40;
            beep=0;
        }
        
    }
}
}
//********************************************************************
  
interrupt [EXT_INT0] void ext_int0_isr(void)
{
bit key2_pressed=0;
need_update=1;

if(!power_down)
  {  
    if(alarm&(!user_cancel_alarm))
    {
        user_cancel_alarm=1;
        beep=0;
        beep_pin=0;
        led_refresh(ON);
        TIMSK=0x40;
    }
    else
    {
        if(menu_active)
        {
           menu_select++;
           if(menu_select>4){menu_active=0;menu_select=1;}
        }
    }
  }    

    display_time=0;
    LcdPwrOn();
    while((!key)&(!poweroff_bit))  //    
    {
        delay_ms(100);
        #asm("wdr")
        if(!key_plus)key2_pressed=1;
        key_press++;
        if(key_press>50) //    5- ,   
        {
        poweroff_bit=1;
        GICR=0x00;
        } 
    }
    if((key_press>=10)&(key_press<=50)&key2_pressed)
    {
        if(menu_active==0)
            {
                menu_active=1;
            }
    }
    key_press=0;  

}

//********************************************************************

interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
char i;
long doze=0;
    TIFR |= (1<<TOV2);
    TCNT2=0xDF;

    need_update=1;
        
    second_tick++;
    if(second_tick>59)
    {  
        second_tick=0;
        minute_tick++;
        check_battery(); 

        for(i=0;i<24;i++)doze+=doze_massive[i]/100; // .
        doze_count=doze/100;
    }
    
    if(minute_tick>59)
    {
        minute_tick=0;
        hour_tick++;
        doze_massive[hour_tick]=0;
    }
    if(hour_tick>23)
    {
        hour_tick=0;
        doze_massive[hour_tick]=0;
        day_tick++;
    }
             
    
    #asm("wdr")

    second++;
    impulse_massive[second]=0;
    if(display_time<1000)display_time++;
    need_pump=1;
    if((display_time>sleep_time)&(!alarm))LcdPwrOff();

}

//********************************************************************
  
  void main(void)
{
long i,j;

#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif


TCCR0=0x05;
TCNT0=0xFF;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x08;
TCCR2=0x07;
TCNT2=0xDF;
OCR2=0x00;

TIMSK=0x40;


GICR=0xC0;
MCUCR=0xB0;
GIFR=0xC0;

PORTD.3=0; //   
DDRD.3=0;

PORTD.2=1; //   
DDRD.2=0;

PORTC.2=1; //    "+"
DDRC.2=0;

PORTC.1=0; // 
DDRC.1=1;

PORTD.0=0; //  
DDRD.0=1;

PORTD.5=0; //  
DDRD.5=1;

PORTD.1=0; //    .
DDRD.1=1;



LcdPwrOn();
LcdInit();

led_refresh(ON);

	LcdClear();

	sprintf (lcd_buf, "   -2   ");
	LcdStringInv(1,1);
    sprintf (lcd_buf, "        FW:1.0");
	LcdString(1,2);
    sprintf (lcd_buf, "     by Shodan");
	LcdString(1,3);
    LcdUpdate();

    delay_ms(200);

    sprintf(lcd_buf, "");
	LcdStringInv(1,5);
	LcdUpdate();

check_battery();

{
#asm("cli")
    j=0;
    
    //while(1)
    for(i=0;i<60000;i++) //  
    {
        j++;
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(40);
        #asm("wdr")
        if(j==10000)
        {
        j=0;
            sprintf (lcd_buf, ".");
	        LcdStringInv(9+(i/10000),5);
	        LcdUpdate();
        }

    }
    delay_ms(2);
} 
#asm("sei") // 

LcdClear();
///////////////////////////////////////////////////////////
while (1)
{
if(need_update)
{
    need_update=0;
    
    calc_counters();
    #asm("wdr")

    if(poweroff_bit)
    {
        TIMSK=0x40;
        beep=0;
        beep_pin=0;
        poweroff();
    }

    alarm_check();
    #asm("wdr")

    menu_modification_check();
    #asm("wdr")
    
    led_refresh(NONE);

    if(!power_down)
    {
        LcdClear_massive();
        #asm("wdr")
        if(menu_active)
        {menu();}
        else
        {main_window_draw();}
    }

}

pump();

#asm("wdr")

if(!menu_active)
{
    if(!beep)
    {
        //led_refresh(ON);
        #asm("sleep")
    }
    #asm("wdr")
}
else
{
    need_update=1;
}
    	
};
}

//-------------------------------------------