
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _impulse_pump=R4
	.DEF _delay_pump=R6
	.DEF _minute_show_pulse=R9
	.DEF _tem=R10
	.DEF _need_pump_by_impulse=R12
	.DEF _tick=R8

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _voidadc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x1
_0x11E:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _digit
	.DW  _0x3*2

	.DW  0x06
	.DW  0x08
	.DW  _0x11E*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#define blink_led_on_pulse //   
;//#define blink_led_on_work  //   
;
;#define impulse_pump_def 13        //              (330 )
;#define delay_pump_timeout 1   //      
;#define delay_pump_def 100          //          (330 )
;
;
;unsigned int impulse_pump;
;unsigned int delay_pump;
;
;unsigned char minute_show_pulse=0;
;
;eeprom unsigned int wdt_error=0;
;
;unsigned int tem;
;bit need_pump=0,show_pulse=0;
;unsigned int need_pump_by_impulse=0;
;unsigned char tick=0, second=0;
;unsigned int impulse_count=0,impulse_count_old=0;
;
;unsigned char second_tick=0;
;unsigned char minute_tick=0;
;unsigned char hour_tick=0;
;
;unsigned int impulse_massive[40];
;unsigned long doze_massive[25];
;
;unsigned int key_press=0;
;
;unsigned int VoltLevel=0;
;
;bit reset_by_wdt=0;
;
;bit alarm=0;
;bit user_cancel_alarm=0;
;
;bit ready=0;
;
;bit doze_mode=0;
;
;char display_time=0;
;
;char error_count=0;
;
;#define beep     PORTC.4
;#define trans    PORTD.1
;#define key      PIND.3 //(int1)
;#define impulse  PIND.2 //(int0)
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;
;#include <display.h>

	.DSEG

	.CSEG
_tochka:
	CBI  0x18,5
	RET
_clear_all:
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	SBI  0x15,2
	SBI  0x15,1
	SBI  0x15,0
	RET
_show_digit:
;	what_digit -> Y+0
	LD   R30,Y
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x21
	CBI  0x12,5
	CBI  0x18,0
	RJMP _0x20
_0x21:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x26
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,2
	CBI  0x18,3
	CBI  0x18,1
	RJMP _0x20
_0x26:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x31
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,2
	CBI  0x18,0
	CBI  0x18,1
	RJMP _0x20
_0x31:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x3C
	CBI  0x18,4
	CBI  0x18,2
	CBI  0x12,5
	CBI  0x18,0
	RJMP _0x20
_0x3C:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x45
	CBI  0x12,6
	CBI  0x18,4
	CBI  0x18,2
	CBI  0x18,0
	CBI  0x18,1
	RJMP _0x20
_0x45:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x50
	CBI  0x12,6
	CBI  0x18,4
	CBI  0x18,3
	CBI  0x18,1
	CBI  0x18,0
	CBI  0x18,2
	RJMP _0x20
_0x50:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x5D
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	RJMP _0x20
_0x5D:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x64
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x20
_0x64:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x73
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x20
_0x73:
	SBIW R30,0
	BREQ PC+2
	RJMP _0x80
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	RJMP _0x20
_0x80:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x8D
	CBI  0x18,2
	RJMP _0x20
_0x8D:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x90
	CBI  0x18,3
	CBI  0x18,2
	CBI  0x18,0
	RJMP _0x20
_0x90:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x97
	CBI  0x18,2
	RJMP _0x20
_0x97:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x20
	CBI  0x18,2
_0x20:
	ADIW R28,1
	RET
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	LDI  R30,LOW(255)
	OUT  0x32,R30
	SBRS R2,7
	RJMP _0x9D
	RCALL _clear_all
	LDS  R26,_digit
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x9E
	LDI  R30,LOW(999)
	LDI  R31,HIGH(999)
	CP   R30,R10
	CPC  R31,R11
	BRLO PC+2
	RJMP _0x9F
	CBI  0x15,3
	LDS  R30,_razl_1
	ST   -Y,R30
	RCALL _show_digit
_0x9F:
_0x9E:
	LDS  R26,_digit
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0xA2
	LDI  R30,LOW(99)
	LDI  R31,HIGH(99)
	CP   R30,R10
	CPC  R31,R11
	BRLO PC+2
	RJMP _0xA3
	CBI  0x15,2
	LDS  R30,_razl_2
	ST   -Y,R30
	RCALL _show_digit
_0xA3:
_0xA2:
	LDS  R26,_digit
	CPI  R26,LOW(0x3)
	BREQ PC+2
	RJMP _0xA6
	MOVW R26,R10
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RCALL __GTW12U
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,6
	LDI  R30,1
	OR   R30,R26
	BRNE PC+2
	RJMP _0xA7
	CBI  0x15,1
	LDS  R30,_razl_3
	ST   -Y,R30
	RCALL _show_digit
_0xA7:
	SBRS R2,6
	RJMP _0xAA
	CBI  0x15,1
	RCALL _tochka
_0xAA:
_0xA6:
	LDS  R26,_digit
	CPI  R26,LOW(0x4)
	BREQ PC+2
	RJMP _0xAD
	CBI  0x15,0
	LDS  R30,_razl_4
	ST   -Y,R30
	RCALL _show_digit
_0xAD:
	LDS  R30,_digit
	SUBI R30,-LOW(1)
	STS  _digit,R30
	LDS  R26,_digit
	CPI  R26,LOW(0x5)
	BRSH PC+2
	RJMP _0xB0
	LDI  R30,LOW(1)
	STS  _digit,R30
_0xB0:
_0x9D:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;#include <microdozik.h>
_pump:
	RCALL __SAVELOCR2
;	i -> R16,R17
	SBRS R2,0
	RJMP _0xB1
	LDI  R30,LOW(0)
	OUT  0x3B,R30
	__GETWRN 16,17,0
_0xB3:
	__CPWRR 16,17,6,7
	BRLO PC+2
	RJMP _0xB4
	SBI  0x12,1
	__DELAY_USB 5
	CBI  0x12,1
	__DELAY_USB 27
	wdr
_0xB2:
	__ADDWRN 16,17,1
	RJMP _0xB3
_0xB4:
	__DELAY_USB 67
	CLT
	BLD  R2,0
	LDI  R30,LOW(192)
	OUT  0x3B,R30
_0xB1:
	RCALL __LOADLOCR2P
	RET
_calc_counters:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
	ST   -Y,R17
;	doze -> Y+1
;	i -> R17
	STS  _impulse_count,R30
	STS  _impulse_count+1,R30
	LDI  R17,LOW(0)
_0xBA:
	CPI  R17,37
	BRLO PC+2
	RJMP _0xBB
	MOV  R30,R17
	LDI  R26,LOW(_impulse_massive)
	LDI  R27,HIGH(_impulse_massive)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	LDS  R26,_impulse_count
	LDS  R27,_impulse_count+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _impulse_count,R30
	STS  _impulse_count+1,R31
_0xB9:
	SUBI R17,-1
	RJMP _0xBA
_0xBB:
	SBRC R2,6
	RJMP _0xBC
	__GETWRMN 10,11,0,_impulse_count
_0xBC:
	wdr
	LDS  R26,_second
	CPI  R26,LOW(0x25)
	BRSH PC+2
	RJMP _0xBD
	RCALL _check_sbm20
	LDI  R30,LOW(0)
	STS  _impulse_count,R30
	STS  _impulse_count+1,R30
	STS  _second,R30
	STS  _impulse_massive,R30
	STS  _impulse_massive+1,R30
	SET
	BLD  R2,5
_0xBD:
	SBRC R2,6
	RJMP _0xBE
	LDS  R30,_impulse_count_old
	LDS  R31,_impulse_count_old+1
	LDS  R26,_impulse_count
	LDS  R27,_impulse_count+1
	CP   R30,R26
	CPC  R31,R27
	BRNE PC+2
	RJMP _0xBF
	LDS  R30,_impulse_count
	LDS  R31,_impulse_count+1
	STS  _impulse_count_old,R30
	STS  _impulse_count_old+1,R31
	LDI  R30,LOW(9999)
	LDI  R31,HIGH(9999)
	CP   R30,R10
	CPC  R31,R11
	BRLO PC+2
	RJMP _0xC0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	STS  _razl_1,R30
	STS  _razl_1+1,R31
	STS  _razl_2,R30
	STS  _razl_2+1,R31
	STS  _razl_3,R30
	STS  _razl_3+1,R31
	STS  _razl_4,R30
	STS  _razl_4+1,R31
	RJMP _0xC1
_0xC0:
	MOVW R26,R10
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	STS  _razl_1,R30
	STS  _razl_1+1,R31
	MOVW R26,R10
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	STS  _razl_2,R30
	STS  _razl_2+1,R31
	MOVW R26,R10
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	STS  _razl_3,R30
	STS  _razl_3+1,R31
	MOVW R26,R10
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	STS  _razl_4,R30
	STS  _razl_4+1,R31
	wdr
_0xC1:
_0xBF:
	RJMP _0xC2
_0xBE:
	LDI  R17,LOW(0)
_0xC4:
	CPI  R17,24
	BRLO PC+2
	RJMP _0xC5
	MOV  R30,R17
	LDI  R26,LOW(_doze_massive)
	LDI  R27,HIGH(_doze_massive)
	LDI  R31,0
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x64
	RCALL __DIVD21U
	__GETD2S 1
	RCALL __ADDD12
	__PUTD1S 1
_0xC3:
	SUBI R17,-1
	RJMP _0xC4
_0xC5:
	__GETD2S 1
	__GETD1N 0x64
	RCALL __DIVD21U
	MOVW R10,R30
	wdr
	LDI  R30,LOW(9999)
	LDI  R31,HIGH(9999)
	CP   R30,R10
	CPC  R31,R11
	BRLO PC+2
	RJMP _0xC6
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	STS  _razl_1,R30
	STS  _razl_1+1,R31
	STS  _razl_2,R30
	STS  _razl_2+1,R31
	STS  _razl_3,R30
	STS  _razl_3+1,R31
	STS  _razl_4,R30
	STS  _razl_4+1,R31
	RJMP _0xC7
_0xC6:
	MOVW R26,R10
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	STS  _razl_1,R30
	STS  _razl_1+1,R31
	MOVW R26,R10
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	STS  _razl_2,R30
	STS  _razl_2+1,R31
	MOVW R26,R10
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	STS  _razl_3,R30
	STS  _razl_3+1,R31
	MOVW R26,R10
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	STS  _razl_4,R30
	STS  _razl_4+1,R31
	wdr
_0xC7:
_0xC2:
	LDD  R17,Y+0
	ADIW R28,5
	RET
_alarm_check:
	LDS  R26,_impulse_count
	LDS  R27,_impulse_count+1
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RCALL __GTW12U
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,4
	LDI  R30,1
	AND  R30,R26
	BRNE PC+2
	RJMP _0xC8
	SBI  0x15,4
	SET
	BLD  R2,7
	BLD  R2,3
_0xC8:
	LDS  R26,_impulse_count
	LDS  R27,_impulse_count+1
	SBIW R26,60
	BRLO PC+2
	RJMP _0xCB
	CBI  0x15,4
	CLT
	BLD  R2,3
	BLD  R2,4
_0xCB:
	RET
_check_battery:
	RCALL __SAVELOCR2
;	pump_multipiller -> R16,R17
	__GETWRN 16,17,100
	RCALL _read_adc
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	CPI  R26,LOW(0x1A4)
	LDI  R30,HIGH(0x1A4)
	CPC  R27,R30
	BRLO PC+2
	RJMP _0xCE
	LDI  R30,LOW(420)
	LDI  R31,HIGH(420)
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	RCALL __MULW12U
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	RCALL __MULW12U
	MOVW R26,R30
	LDI  R30,LOW(420)
	LDI  R31,HIGH(420)
	RCALL __DIVW21U
	MOVW R16,R30
	__MULBNWRU 16,17,13
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	ADIW R30,13
	MOVW R4,R30
	__MULBNWRU 16,17,100
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	SUBI R30,LOW(-100)
	SBCI R31,HIGH(-100)
	MOVW R6,R30
	wdr
	RJMP _0xCF
_0xCE:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	MOVW R4,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	MOVW R6,R30
_0xCF:
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	CPI  R26,LOW(0x14A)
	LDI  R30,HIGH(0x14A)
	CPC  R27,R30
	BRLO PC+2
	RJMP _0xD0
	SBI  0x15,4
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	SBI  0x15,4
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	SBI  0x15,4
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
	wdr
_0xD0:
	RCALL __LOADLOCR2P
	RET
_check_sbm20:
	LDS  R30,_impulse_count
	LDS  R31,_impulse_count+1
	SBIW R30,0
	BREQ PC+2
	RJMP _0xDD
	LDS  R30,_error_count
	SUBI R30,-LOW(1)
	STS  _error_count,R30
	RJMP _0xDE
_0xDD:
	LDI  R30,LOW(0)
	STS  _error_count,R30
_0xDE:
	LDS  R26,_error_count
	CPI  R26,LOW(0x6)
	BRSH PC+2
	RJMP _0xDF
	SBI  0x15,4
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	CBI  0x15,4
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	SBI  0x15,4
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	CBI  0x15,4
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	SBI  0x15,4
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	CBI  0x15,4
_0xDF:
	RET
_read_adc:
	RCALL __SAVELOCR4
;	tmpv -> R16,R17
;	ixi -> R19
;	MCUCR_def -> R18
	__GETWRN 16,17,0
	LDI  R19,64
	sei
	LDI  R30,LOW(231)
	OUT  0x7,R30
	LDI  R30,LOW(159)
	OUT  0x6,R30
	IN   R18,53
	LDI  R30,LOW(144)
	OUT  0x35,R30
	__DELAY_USW 250
	LDI  R30,LOW(0)
	OUT  0x39,R30
_0xEC:
	CPI  R19,1
	BRSH PC+2
	RJMP _0xEE
	sleep
	wdr
	LDS  R30,_VoltLevel
	LDS  R31,_VoltLevel+1
	__ADDWRR 16,17,30,31
	SUBI R19,1
	RJMP _0xEC
_0xEE:
	LDI  R30,LOW(65)
	OUT  0x39,R30
	OUT  0x35,R18
	LDI  R30,LOW(0)
	OUT  0x6,R30
	OUT  0x8,R30
	OUT  0x7,R30
	MOVW R26,R16
	LDI  R30,LOW(6)
	RCALL __LSRW12
	STS  _VoltLevel,R30
	STS  _VoltLevel+1,R31
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;
;
;//********************************************************************
;void check_battery();
;
;//--------------------------------- --------------------------//
;interrupt [ADC_INT] void voidadc_isr(void)
; 0000 0040 {
_voidadc_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0041 	VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
	IN   R30,0x5
	LDI  R31,0
	SBIW R30,1
	LSL  R30
	ROL  R31
	STS  _VoltLevel,R30
	STS  _VoltLevel+1,R31
; 0000 0042     //VoltLevel=1023;
; 0000 0043 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;//********************************************************************
;
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0048 {
_ext_int0_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0049 unsigned char i;
; 0000 004A 
; 0000 004B     #asm("wdr")
	ST   -Y,R17
;	i -> R17
	wdr
; 0000 004C     if(minute_show_pulse<5)show_pulse=1;
	LDI  R30,LOW(5)
	CP   R9,R30
	BRLO PC+2
	RJMP _0xEF
	SET
	BLD  R2,1
; 0000 004D     impulse_massive[second]++;
_0xEF:
	LDS  R30,_second
	LDI  R26,LOW(_impulse_massive)
	LDI  R27,HIGH(_impulse_massive)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 004E     doze_massive[hour_tick]++;
	LDS  R30,_hour_tick
	LDI  R26,LOW(_doze_massive)
	LDI  R27,HIGH(_doze_massive)
	LDI  R31,0
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
; 0000 004F     need_pump_by_impulse++;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
; 0000 0050     tick=0;
	CLR  R8
; 0000 0051     impulse_count++;
	LDI  R26,LOW(_impulse_count)
	LDI  R27,HIGH(_impulse_count)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0052     for(i=0;i<impulse_pump;i++)
	LDI  R17,LOW(0)
_0xF1:
	MOVW R30,R4
	MOV  R26,R17
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRLO PC+2
	RJMP _0xF2
; 0000 0053     {
; 0000 0054         trans=1;
	SBI  0x12,1
; 0000 0055         delay_us(2);
	__DELAY_USB 5
; 0000 0056         trans=0;
	CBI  0x12,1
; 0000 0057         delay_us(5);
	__DELAY_USB 13
; 0000 0058         #asm("wdr")
	wdr
; 0000 0059     }
_0xF0:
	SUBI R17,-1
	RJMP _0xF1
_0xF2:
; 0000 005A     delay_us(25);
	__DELAY_USB 67
; 0000 005B 
; 0000 005C }
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;
;//********************************************************************
;
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 0061 {
_ext_int1_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0062     display_time=0;
	LDI  R30,LOW(0)
	STS  _display_time,R30
; 0000 0063     display=1;
	SET
	BLD  R2,7
; 0000 0064     beep=0;
	CBI  0x15,4
; 0000 0065 
; 0000 0066     minute_show_pulse=0;
	CLR  R9
; 0000 0067 
; 0000 0068     clear_all();
	RCALL _clear_all
; 0000 0069     digit_3=0;
	CBI  0x15,1
; 0000 006A     tochka();
	RCALL _tochka
; 0000 006B 
; 0000 006C     if(doze_mode)doze_mode=0;
	SBRS R2,6
	RJMP _0xFB
	CLT
	BLD  R2,6
; 0000 006D 
; 0000 006E     while(!key)  //    
_0xFB:
_0xFC:
	SBIC 0x10,3
	RJMP _0xFE
; 0000 006F     {
; 0000 0070         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0071         key_press++;
	LDI  R26,LOW(_key_press)
	LDI  R27,HIGH(_key_press)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0072         if(key_press>20) //    2 ,     
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	SBIW R26,21
	BRSH PC+2
	RJMP _0xFF
; 0000 0073         {
; 0000 0074             beep=1;
	SBI  0x15,4
; 0000 0075             delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0076             beep=0;
	CBI  0x15,4
; 0000 0077             delay_ms(700);
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0078             doze_mode=1; //  
	SET
	BLD  R2,6
; 0000 0079         }
; 0000 007A     }
_0xFF:
	RJMP _0xFC
_0xFE:
; 0000 007B     key_press=0;
	LDI  R30,LOW(0)
	STS  _key_press,R30
	STS  _key_press+1,R30
; 0000 007C     clear_all();
	RCALL _clear_all
; 0000 007D 
; 0000 007E     if(alarm)user_cancel_alarm=1;
	SBRS R2,3
	RJMP _0x104
	SET
	BLD  R2,4
; 0000 007F }
_0x104:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;//********************************************************************
;
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0084 {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0085 //char i;
; 0000 0086     TIFR |= (1<<TOV2);
	IN   R30,0x38
	ORI  R30,0x40
	OUT  0x38,R30
; 0000 0087     TCNT2=0xDF;
	LDI  R30,LOW(223)
	OUT  0x24,R30
; 0000 0088 
; 0000 0089     second_tick++;
	LDS  R30,_second_tick
	SUBI R30,-LOW(1)
	STS  _second_tick,R30
; 0000 008A     if(second_tick>59)
	LDS  R26,_second_tick
	CPI  R26,LOW(0x3C)
	BRSH PC+2
	RJMP _0x105
; 0000 008B     {
; 0000 008C         second_tick=0;
	LDI  R30,LOW(0)
	STS  _second_tick,R30
; 0000 008D         minute_tick++;
	LDS  R30,_minute_tick
	SUBI R30,-LOW(1)
	STS  _minute_tick,R30
; 0000 008E         if(minute_show_pulse<10)minute_show_pulse++;
	LDI  R30,LOW(10)
	CP   R9,R30
	BRLO PC+2
	RJMP _0x106
	INC  R9
; 0000 008F         check_battery();
_0x106:
	RCALL _check_battery
; 0000 0090     }
; 0000 0091 
; 0000 0092     if(minute_tick>59)
_0x105:
	LDS  R26,_minute_tick
	CPI  R26,LOW(0x3C)
	BRSH PC+2
	RJMP _0x107
; 0000 0093     {
; 0000 0094         minute_tick=0;
	LDI  R30,LOW(0)
	STS  _minute_tick,R30
; 0000 0095         hour_tick++;
	LDS  R30,_hour_tick
	SUBI R30,-LOW(1)
	STS  _hour_tick,R30
; 0000 0096         doze_massive[hour_tick]=0;
	LDI  R26,LOW(_doze_massive)
	LDI  R27,HIGH(_doze_massive)
	LDI  R31,0
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	__GETD1N 0x0
	RCALL __PUTDP1
; 0000 0097     }
; 0000 0098     if(hour_tick>23)
_0x107:
	LDS  R26,_hour_tick
	CPI  R26,LOW(0x18)
	BRSH PC+2
	RJMP _0x108
; 0000 0099     {
; 0000 009A         hour_tick=0;
	LDI  R30,LOW(0)
	STS  _hour_tick,R30
; 0000 009B         doze_massive[hour_tick]=0;
	LDI  R26,LOW(_doze_massive)
	LDI  R27,HIGH(_doze_massive)
	LDI  R31,0
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	__GETD1N 0x0
	RCALL __PUTDP1
; 0000 009C     }
; 0000 009D 
; 0000 009E 
; 0000 009F     //#asm("wdr")
; 0000 00A0 //    tick++;
; 0000 00A1     //little_second
; 0000 00A2     second++;
_0x108:
	LDS  R30,_second
	SUBI R30,-LOW(1)
	STS  _second,R30
; 0000 00A3     impulse_massive[second]=0;
	LDI  R26,LOW(_impulse_massive)
	LDI  R27,HIGH(_impulse_massive)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
; 0000 00A4     if(display_time<100)display_time++;
	LDS  R26,_display_time
	CPI  R26,LOW(0x64)
	BRLO PC+2
	RJMP _0x109
	LDS  R30,_display_time
	SUBI R30,-LOW(1)
	STS  _display_time,R30
; 0000 00A5 //    if (tick>delay_pump_timeout)
; 0000 00A6 //    {
; 0000 00A7 //        tick=0;
; 0000 00A8         need_pump=1;
_0x109:
	SET
	BLD  R2,0
; 0000 00A9 //    }
; 0000 00AA }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;//********************************************************************
;
;void main(void)
; 0000 00AF {
_main:
; 0000 00B0 unsigned long i=0;
; 0000 00B1 
; 0000 00B2 #pragma optsize-
; 0000 00B3 
; 0000 00B4 if (MCUCSR & 0x08)    //0000 1000
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
;	i -> Y+0
	IN   R30,0x34
	SBRS R30,3
	RJMP _0x10A
; 0000 00B5    {
; 0000 00B6    // Watchdog Reset
; 0000 00B7    reset_by_wdt = 1;
	SET
	BLD  R2,2
; 0000 00B8    wdt_error++;
	LDI  R26,LOW(_wdt_error)
	LDI  R27,HIGH(_wdt_error)
	RCALL __EEPROMRDW
	ADIW R30,1
	RCALL __EEPROMWRW
	SBIW R30,1
; 0000 00B9    MCUCSR=0;
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 00BA    }
; 0000 00BB MCUCSR=0;
_0x10A:
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 00BC 
; 0000 00BD WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 00BE WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 00BF #ifdef _OPTIMIZE_SIZE_
; 0000 00C0 #pragma optsize+
; 0000 00C1 #endif
; 0000 00C2 
; 0000 00C3 
; 0000 00C4 PORTB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x18,R30
; 0000 00C5 DDRB=0x3F;
	OUT  0x17,R30
; 0000 00C6 PORTC=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
; 0000 00C7 DDRC=0x1F;
	LDI  R30,LOW(31)
	OUT  0x14,R30
; 0000 00C8 PORTD=0x6C;
	LDI  R30,LOW(108)
	OUT  0x12,R30
; 0000 00C9 DDRD=0x62;
	LDI  R30,LOW(98)
	OUT  0x11,R30
; 0000 00CA 
; 0000 00CB TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 00CC TCNT0=0xFF;
	LDI  R30,LOW(255)
	OUT  0x32,R30
; 0000 00CD 
; 0000 00CE TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 00CF TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00D0 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00D1 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00D2 ICR1H=0x00;
	OUT  0x27,R30
; 0000 00D3 ICR1L=0x00;
	OUT  0x26,R30
; 0000 00D4 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00D5 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00D6 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00D7 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00D8 
; 0000 00D9 ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 00DA TCCR2=0x07;
	LDI  R30,LOW(7)
	OUT  0x25,R30
; 0000 00DB TCNT2=0xDF;
	LDI  R30,LOW(223)
	OUT  0x24,R30
; 0000 00DC OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 00DD 
; 0000 00DE GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 00DF MCUCR=0xB0;
	LDI  R30,LOW(176)
	OUT  0x35,R30
; 0000 00E0 GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 00E1 
; 0000 00E2 TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 00E3 
; 0000 00E4 delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00E5 
; 0000 00E6 if(!key) //     ,    .
	SBIC 0x10,3
	RJMP _0x10B
; 0000 00E7 {
; 0000 00E8 DDRC.4=0;
	CBI  0x14,4
; 0000 00E9 }
; 0000 00EA 
; 0000 00EB check_battery();
_0x10B:
	RCALL _check_battery
; 0000 00EC 
; 0000 00ED {
; 0000 00EE     GICR=0x00;
	LDI  R30,LOW(0)
	OUT  0x3B,R30
; 0000 00EF     tem=99;
	LDI  R30,LOW(99)
	LDI  R31,HIGH(99)
	MOVW R10,R30
; 0000 00F0     razl_3=0;
	LDI  R30,LOW(0)
	STS  _razl_3,R30
	STS  _razl_3+1,R30
; 0000 00F1     razl_4=11;
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	STS  _razl_4,R30
	STS  _razl_4+1,R31
; 0000 00F2 
; 0000 00F3     for(i=0;i<100000;i++)
	LDI  R30,LOW(0)
	RCALL __CLRD1S0
_0x10F:
	RCALL __GETD2S0
	__CPD2N 0x186A0
	BRLO PC+2
	RJMP _0x110
; 0000 00F4     {
; 0000 00F5         i++;
	RCALL __GETD1S0
	__SUBD1N -1
	RCALL __PUTD1S0
; 0000 00F6         trans=1;
	SBI  0x12,1
; 0000 00F7         delay_us(2);
	__DELAY_USB 5
; 0000 00F8         trans=0;
	CBI  0x12,1
; 0000 00F9         delay_us(8);
	__DELAY_USB 21
; 0000 00FA         #asm("wdr")
	wdr
; 0000 00FB     }
_0x10E:
	RCALL __GETD1S0
	__SUBD1N -1
	RCALL __PUTD1S0
	RJMP _0x10F
_0x110:
; 0000 00FC     tem=0;
	CLR  R10
	CLR  R11
; 0000 00FD     GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 00FE     delay_ms(2);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00FF }
; 0000 0100 #asm("sei") // 
	sei
; 0000 0101 
; 0000 0102 
; 0000 0103 while (1)
_0x115:
; 0000 0104  {
; 0000 0105  calc_counters();
	RCALL _calc_counters
; 0000 0106  #asm("wdr")
	wdr
; 0000 0107  if((display_time>20)&(!alarm))
	LDS  R26,_display_time
	LDI  R30,LOW(20)
	RCALL __GTB12U
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,3
	LDI  R30,1
	AND  R30,R26
	BRNE PC+2
	RJMP _0x118
; 0000 0108  {display=0;clear_all();doze_mode=0;}
	CLT
	BLD  R2,7
	RCALL _clear_all
	CLT
	BLD  R2,6
; 0000 0109 
; 0000 010A #ifdef blink_led_on_pulse
; 0000 010B  if(show_pulse&(!display))
_0x118:
	LDI  R26,0
	SBRC R2,1
	LDI  R26,1
	LDI  R30,0
	SBRS R2,7
	LDI  R30,1
	AND  R30,R26
	BRNE PC+2
	RJMP _0x119
; 0000 010C     {
; 0000 010D         #asm("wdr")
	wdr
; 0000 010E         digit_2=0;
	CBI  0x15,2
; 0000 010F         tochka();
	RCALL _tochka
; 0000 0110         delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0111         clear_all();
	RCALL _clear_all
; 0000 0112         show_pulse=0;
	CLT
	BLD  R2,1
; 0000 0113     }
; 0000 0114 #endif
; 0000 0115 
; 0000 0116     #asm("wdr")
_0x119:
	wdr
; 0000 0117 
; 0000 0118     pump();
	RCALL _pump
; 0000 0119 
; 0000 011A     #asm("wdr")
	wdr
; 0000 011B 
; 0000 011C     alarm_check();
	RCALL _alarm_check
; 0000 011D 
; 0000 011E     if(!display)
	SBRC R2,7
	RJMP _0x11C
; 0000 011F     {
; 0000 0120 #ifdef blink_led_on_work
; 0000 0121         digit_4=0;
; 0000 0122         tochka();
; 0000 0123         delay_ms(1);
; 0000 0124         clear_all();
; 0000 0125 #endif
; 0000 0126         #asm("wdr");
	wdr
; 0000 0127         #asm("sleep");
	sleep
; 0000 0128     }
; 0000 0129  }
_0x11C:
	RJMP _0x115
_0x117:
; 0000 012A }
	ADIW R28,4
_0x11D:
	RJMP _0x11D
;
;//-------------------------------------------
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.ESEG
_wdt_error:
	.DW  0x0

	.DSEG
_second:
	.BYTE 0x1
_impulse_count:
	.BYTE 0x2
_impulse_count_old:
	.BYTE 0x2
_second_tick:
	.BYTE 0x1
_minute_tick:
	.BYTE 0x1
_hour_tick:
	.BYTE 0x1
_impulse_massive:
	.BYTE 0x50
_doze_massive:
	.BYTE 0x64
_key_press:
	.BYTE 0x2
_VoltLevel:
	.BYTE 0x2
_display_time:
	.BYTE 0x1
_error_count:
	.BYTE 0x1
_digit:
	.BYTE 0x1
_razl_1:
	.BYTE 0x2
_razl_2:
	.BYTE 0x2
_razl_3:
	.BYTE 0x2
_razl_4:
	.BYTE 0x2

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

	.equ __w1_port=0x12
	.equ __w1_bit=0x02

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__GTW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLO __GTW12UT
	CLR  R30
__GTW12UT:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__CLRD1S0:
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
