#define blink_led_on_pulse //   
//#define blink_led_on_work  //   

#define impulse_pump_def 13        //              (330 )
#define delay_pump_timeout 1   //      
#define delay_pump_def 100          //          (330 )


unsigned int impulse_pump;
unsigned int delay_pump;

unsigned char minute_show_pulse=0;

eeprom unsigned int wdt_error=0;  

unsigned int tem;
bit need_pump=0,show_pulse=0;
unsigned int need_pump_by_impulse=0;
unsigned char tick=0, second=0;
unsigned int impulse_count=0,impulse_count_old=0;

unsigned char second_tick=0;
unsigned char minute_tick=0;
unsigned char hour_tick=0;

unsigned int impulse_massive[40];
unsigned long doze_massive[25];

unsigned int key_press=0;

unsigned int VoltLevel=0;

bit reset_by_wdt=0;

bit alarm=0;
bit user_cancel_alarm=0;

bit ready=0;

bit doze_mode=0;

char display_time=0;

char error_count=0; 

#define beep     PORTC.4
#define trans    PORTD.1
#define key      PIND.3 //(int1)
#define impulse  PIND.2 //(int0)

#include <mega8.h>
#include <delay.h>
#include <stdio.h>

#include <display.h> 
#include <microdozik.h> 


//********************************************************************
void check_battery();

//--------------------------------- --------------------------//
interrupt [ADC_INT] void voidadc_isr(void)
{
	VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
    //VoltLevel=1023;
}

//********************************************************************

interrupt [EXT_INT0] void ext_int0_isr(void)
{
unsigned char i;

    #asm("wdr")
    if(minute_show_pulse<5)show_pulse=1;
    impulse_massive[second]++;
    doze_massive[hour_tick]++;
    need_pump_by_impulse++;
    tick=0;
    impulse_count++;
    for(i=0;i<impulse_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(5);
        #asm("wdr")
    }
    delay_us(25);

}

//********************************************************************
  
interrupt [EXT_INT1] void ext_int1_isr(void)
{
    display_time=0;
    display=1;
    beep=0;

    minute_show_pulse=0;
        
    clear_all();
    digit_3=0;
    tochka();

    if(doze_mode)doze_mode=0;

    while(!key)  //    
    {
        delay_ms(100);
        key_press++;
        if(key_press>20) //    2 ,     
        {
            beep=1;
            delay_ms(100);
            beep=0;
            delay_ms(700);
            doze_mode=1; //  
        }
    }
    key_press=0;
    clear_all();  

    if(alarm)user_cancel_alarm=1;
}

//********************************************************************

interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
//char i;
    TIFR |= (1<<TOV2);
    TCNT2=0xDF;
    
    second_tick++;
    if(second_tick>59)
    {   
        second_tick=0;
        minute_tick++;
        if(minute_show_pulse<10)minute_show_pulse++;
        check_battery();
    }
    
    if(minute_tick>59)
    {
        minute_tick=0;
        hour_tick++;
        doze_massive[hour_tick]=0;
    }
    if(hour_tick>23)
    {
        hour_tick=0;
        doze_massive[hour_tick]=0;
    }
             
    
    //#asm("wdr")
//    tick++;
    //little_second
    second++;
    impulse_massive[second]=0;
    if(display_time<100)display_time++;
//    if (tick>delay_pump_timeout)
//    {
//        tick=0;
        need_pump=1;
//    }
}

//********************************************************************

void main(void)
{
unsigned long i=0;

#pragma optsize-

if (MCUCSR & 0x08)    //0000 1000 
   { 
   // Watchdog Reset 
   reset_by_wdt = 1;
   wdt_error++; 
   MCUCSR=0; 
   }
MCUCSR=0;
   
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
 

PORTB=0x3F;
DDRB=0x3F;
PORTC=0x0F;
DDRC=0x1F;
PORTD=0x6C;
DDRD=0x62;

TCCR0=0x05;
TCNT0=0xFF;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x08;
TCCR2=0x07;
TCNT2=0xDF;
OCR2=0x00;

GICR=0xC0;
MCUCR=0xB0;
GIFR=0xC0;

TIMSK=0x41;

delay_ms(10);

if(!key) //     ,    .
{
DDRC.4=0;
}

check_battery();

{
    GICR=0x00;
    tem=99;
    razl_3=0;
    razl_4=11;
    
    for(i=0;i<100000;i++)
    {
        i++;
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(8);
        #asm("wdr")
    }
    tem=0;
    GICR=0xC0;  
    delay_ms(2);
} 
#asm("sei") // 


while (1)
 {
 calc_counters();
 #asm("wdr")
 if((display_time>20)&(!alarm))
 {display=0;clear_all();doze_mode=0;}

#ifdef blink_led_on_pulse  
 if(show_pulse&(!display))
    {
        #asm("wdr")
        digit_2=0;
        tochka();
        delay_ms(1);
        clear_all();  
        show_pulse=0;
    }
#endif

    #asm("wdr")

    pump();

    #asm("wdr")

    alarm_check();

    if(!display)
    {
#ifdef blink_led_on_work
        digit_4=0;
        tochka();
        delay_ms(1);
        clear_all();  
#endif
        #asm("wdr");
        #asm("sleep");
    }
 }       
}

//-------------------------------------------