void calc_counters();
void alarm_check();
void check_battery();
//void check_sbm20();
void alarm_sound();
void read_adc();
void poweroff();
void led_refresh(char command);

/***********************************************************************************************/
#define nop() {#asm("nop");}
 
void poweroff()
{
	LcdClear();

	sprintf (lcd_buf, "    ");
	LcdStringInv(1,3);
    LcdUpdate();
    delay_ms(2000); 
    LcdPwrOff();

#pragma optsize-
WDTCR=0x1F;
WDTCR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei")
GICR=0x40;
MCUCR=0xA0;

DDRB=0x00;
DDRC=0x00;
DDRD=0x00;

PORTB=0x00;
PORTC=0x00;
PORTD=0x04;

TCCR0=0x00;
//TCNT0=0xFF;

ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

TIMSK=0x00;

//PORTD.2=1; //   
//DDRD.2=0;

#asm("sei")
poweroff_bit=0;
while(!poweroff_bit)
{
    #asm("sleep")
}

#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

while(1)
{
#asm("sleep")
}

}


/***********************************************************************************************/
bit blue_led_save=1;
bit red_led_save=1;

void led_refresh(unsigned char command)
{
if(power_down)command=0;

if(command==0)
{
            blue_led_pin=0;
            red_led_pin=0;
            return;
}

if(command==1)
{
            blue_led_pin=blue_led_save;
            red_led_pin=red_led_save;
            return;
}

if(command==2)
{
        if(alarm)
        {
            blue_led_pin=0;
            blue_led_save=0;
            
            red_led_pin=1;
            red_led_save=1;
            
        } else
        { 
            if(black_light_enable)
            {
                blue_led_pin=1;
                blue_led_save=1;
                            
                red_led_pin=0;
                red_led_save=0;
            }
            else
            {
                blue_led_pin=0;
                blue_led_save=0;
                            
                red_led_pin=0;
                red_led_save=0;
            
            }            
        }
}
}


//********************************************************************

void calc_counters()
{
unsigned char i;
unsigned int impulse_count=0;

for(i=0;i<36;i++)impulse_count+=impulse_massive[i];
impulse_recive=0;

#asm("wdr")
 if(second>36)
 {
       
        { // 
        if(impulse_count==0){error_count++;}
        else{error_count=0;}
        
        if(error_count>5) //    ,  .
            {
                 alarm_sound();                                        //    - 1 
            }
        }

       second=0;
 }  
        
}

//********************************************************************

void alarm_check()
{
unsigned int impulse_count=0;
char i;

for(i=0;i<36;i++)impulse_count+=impulse_massive[i];

if((impulse_count>alarm_level)&(!user_cancel_alarm)&(alarm_level>0))
    {
        beep=1;
        TIMSK=0x41;
        LcdPwrOn();
        alarm=1;

    }
if((impulse_count<alarm_level)|(alarm_level==0))
    {
        if(alarm)
        {
            alarm=0;
            user_cancel_alarm=0;
        }
    }
}

//********************************************************************

void check_battery()
{
#ifdef lithium 
#ifdef irlml
unsigned int pump_v=10, pump_mf;
 read_adc();


if(VoltLevel<420) //    4.2,   .
{
pump_mf = ((420-VoltLevel)/10)*pump_v;  


impulse_pump=impulse_pump_def+pump_mf;
delay_pump=delay_pump_def+pump_mf;
}
else
{
impulse_pump=impulse_pump_def;
delay_pump=delay_pump_def;
}
#else
unsigned int  pump_multipiller=100;
 read_adc();


if(VoltLevel<420) //    4.2,   .
{
pump_multipiller=(((420-VoltLevel)*100)*3)/400;
impulse_pump=impulse_pump_def+((impulse_pump_def*pump_multipiller)/100);
delay_pump=delay_pump_def+((delay_pump_def*pump_multipiller)/100);
#asm("wdr")
}
else
{
impulse_pump=impulse_pump_def;
delay_pump=delay_pump_def;
}
#endif

if ((VoltLevel>299)&(VoltLevel<401)) battery_procent=VoltLevel-300;
else if (VoltLevel<300) battery_procent=1;
else battery_procent=100;

 if(VoltLevel<360) //    3.6,  .
 {
         alarm_sound();
         delay_ms(50);
         alarm_sound();                                            //    - 3 
         delay_ms(50);
         alarm_sound();
 }
#else //lithium
 read_adc();
impulse_pump=impulse_pump_def; // 
//delay_pump=delay_pump_def; // 

if(VoltLevel>150)VoltLevel=150;
if(VoltLevel<100)VoltLevel=100;
battery_procent=(VoltLevel-100)*2;

 if(VoltLevel<110) //    1.1,  .
 {
         alarm_sound();
         delay_ms(50);
         alarm_sound(); 
         delay_ms(50);
         alarm_sound();
 }
#endif // lithium

}


void alarm_sound()                                                 //     
{
int i;

  for(i=100;i>0;i--)
  {
   led_refresh(0);
   beep_pin=1;
   delay_us(50);                                                   //
   beep_pin=0;                                                     //     
   delay_us(1200);                                                 //
  } 
beep_pin=0; 
           
}
//********************************************************************

void read_adc()
{       unsigned int  tmpv=0;
        unsigned char ixi=64,MCUCR_def;

        #asm("sei");        //   

#ifdef lithium 
ADCSRA |=	(1 << ADEN) // 
			|(0 << ADSC) //  
			|(0 << ADFR) //  
			|(1 << ADIE) //  
			|(1 << ADPS2)|(1 << ADPS1)|(0 << ADPS0); //   64 (  125kHz   8mHz)

ADMUX |= (0 << REFS1)|(1 << REFS0) //  AVCC
		|(1 << ADLAR) //     , ADCL  
		|(0 << MUX0)|(1 << MUX1)|(1 << MUX2)|(1 << MUX3); //  ADC14, .. . 
#else
    ADMUX= 0b11100111;
    ADCSRA=0b10011111;
#endif

    MCUCR_def=MCUCR; 
        MCUCR=0x90;	  //    
        delay_us(125);
        TIMSK=0x00; 
        while(ixi>0)
        {
         #asm("sleep");    //   
         #asm("wdr");
	     tmpv+=VoltLevel;                   
         ixi--;
        }
	TIMSK=0x40;
    beep_pin=0; 
    MCUCR=MCUCR_def;       //   .
    ADCSRA=0x00; 
	ACSR=0x00; 
	ADMUX=0x00;   //       
            
        VoltLevel=(tmpv>>6);
}
