
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : No
;8 bit enums              : No
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: No
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rad_interval=R4
	.DEF _rad=R6
	.DEF _rad_fon=R8
	.DEF _rad_hour=R10
	.DEF _rad_cnt=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _voidadc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0804

_0x3:
	.DB  0x0,0x0,0x0,0x0
_0x4:
	.DB  0x0,0x0
_0x5:
	.DB  0x0
_0x6:
	.DB  0x0
_0x7:
	.DB  0x0,0x0,0x0,0x0
_0x8:
	.DB  0x0,0x0,0x0,0x0
_0x9:
	.DB  0x0
_0xA:
	.DB  0x0
_0xB:
	.DB  0x0
_0xC:
	.DB  0x0
_0xD:
	.DB  0x1,0x0
_0xE:
	.DB  0x0,0x0
_0xF:
	.DB  0x0,0x0
_0x10:
	.DB  0x0,0x0
_0x11:
	.DB  0x0
_0x12:
	.DB  0x0
_0x13:
	.DB  0x0
_0x302:
	.DB  0x0,0x0
_0x495:
	.DB  0xD7,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0
_0x2040003:
	.DB  0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x04
	.DW  _fulldoze
	.DW  _0x3*2

	.DW  0x02
	.DW  _sutki
	.DW  _0x4*2

	.DW  0x01
	.DW  _hours
	.DW  _0x5*2

	.DW  0x01
	.DW  _minutes
	.DW  _0x6*2

	.DW  0x04
	.DW  _doze
	.DW  _0x7*2

	.DW  0x04
	.DW  _day_doze
	.DW  _0x8*2

	.DW  0x01
	.DW  _second
	.DW  _0x9*2

	.DW  0x01
	.DW  _second_tick
	.DW  _0xA*2

	.DW  0x01
	.DW  _minute_tick
	.DW  _0xB*2

	.DW  0x01
	.DW  _hour_tick
	.DW  _0xC*2

	.DW  0x02
	.DW  _beep_on_pulse
	.DW  _0xD*2

	.DW  0x02
	.DW  _key_press
	.DW  _0xE*2

	.DW  0x02
	.DW  _key_press_x
	.DW  _0xF*2

	.DW  0x02
	.DW  _VoltLevel
	.DW  _0x10*2

	.DW  0x01
	.DW  _alarm_cnt
	.DW  _0x11*2

	.DW  0x01
	.DW  _display_time
	.DW  _0x12*2

	.DW  0x01
	.DW  _error_count
	.DW  _0x13*2

	.DW  0x02
	.DW  _multiplex_counter
	.DW  _0x302*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x495*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#define impulse_pump_def 13        //              (330 )
;#define delay_pump_timeout 1        //      
;#define delay_pump_def 100          //           (330 )
;#define time_to_display 91          //    .  = <>+1
;#define alarm_level 60              //    
;#define alarm_counter 3              //             
;                                     //       
;
;
;
;// [     216  ( 3 . 36 .)
;//   8   .  ,       1600 /,    
;//       ,   1600      :)
;//       Shodan : rad_interval=35; rad_massive[36]; .. 36
;
;
;unsigned int rad_interval=215;//       = <>-1     0- 
;unsigned int rad_massive[216]; //   (rad_interval+1), ..   .   
;
;
;unsigned int rad=0; //    
;unsigned int rad_fon=0; //  
;unsigned int rad_hour=0; //    24 
;unsigned long fulldoze=0; //    ( ,   )

	.DSEG
;unsigned int rad_cnt=0; //  
;bit counted=0; //          
;bit blink=0; //     /
;bit blink_led_on_pulse=1; //   
;bit was_in_menu=0; //        .       
;unsigned int sutki=0;
;unsigned char hours=0;
;unsigned char minutes=0;
;unsigned long doze=0;
;unsigned long day_doze=0;
;
;unsigned int impulse_pump;
;unsigned int delay_pump;
;unsigned int s, x, iv, ivc;
;unsigned int peak, rcnt;
;
;eeprom unsigned int wdt_error @0x10;
;
;
;unsigned int tem;
;unsigned int display;
;unsigned int temd;
;bit need_pump=0;
;unsigned char second=0;
;
;unsigned char second_tick=0;
;unsigned char minute_tick=0;
;unsigned char hour_tick=0;
;
;
;unsigned int beep_on_pulse=1; //  
;unsigned int key_press=0;
;unsigned int key_press_x=0;
;
;unsigned int VoltLevel=0;
;
;bit reset_by_wdt=0;
;
;bit alarm=0;
;unsigned char alarm_cnt=0;
;bit user_cancel_alarm=0;
;
;bit doze_mode=0;
;bit volts_mode=0;
;bit hours_mode=0;
;bit fon_mode=1;
;bit search_mode=0;
;
;char display_time=0;
;
;char error_count=0;
;
;
;#define beep     PORTC.4
;#define trans    PORTD.1
;#define key      PIND.3 //(int1)
;#define impulse  PIND.2 //(int0)
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;
;#include <display.h>

	.CSEG
_calculate_segments:
;	character -> Y+0
	LD   R30,Y
	CPI  R30,0
	BREQ PC+2
	RJMP _0x17
	RJMP _0x18
_0x17:
	CPI  R30,LOW(0x30)
	BREQ PC+2
	RJMP _0x19
_0x18:
	RJMP _0x1A
_0x19:
	CPI  R30,LOW(0x4F)
	BREQ PC+2
	RJMP _0x1B
_0x1A:
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x1B:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x2A
	RJMP _0x2B
_0x2A:
	CPI  R30,LOW(0x31)
	BREQ PC+2
	RJMP _0x2C
_0x2B:
	RJMP _0x2D
_0x2C:
	CPI  R30,LOW(0x6C)
	BREQ PC+2
	RJMP _0x2E
_0x2D:
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x2E:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x3D
	RJMP _0x3E
_0x3D:
	CPI  R30,LOW(0x32)
	BREQ PC+2
	RJMP _0x3F
_0x3E:
	CBI  0x12,6
	CBI  0x12,5
	SBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x3F:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x4E
	RJMP _0x4F
_0x4E:
	CPI  R30,LOW(0x33)
	BREQ PC+2
	RJMP _0x50
_0x4F:
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x50:
	CPI  R30,LOW(0x4)
	BREQ PC+2
	RJMP _0x5F
	RJMP _0x60
_0x5F:
	CPI  R30,LOW(0x34)
	BREQ PC+2
	RJMP _0x61
_0x60:
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x61:
	CPI  R30,LOW(0x5)
	BREQ PC+2
	RJMP _0x70
	RJMP _0x71
_0x70:
	CPI  R30,LOW(0x35)
	BREQ PC+2
	RJMP _0x72
_0x71:
	RJMP _0x73
_0x72:
	CPI  R30,LOW(0x53)
	BREQ PC+2
	RJMP _0x74
_0x73:
	RJMP _0x75
_0x74:
	CPI  R30,LOW(0x73)
	BREQ PC+2
	RJMP _0x76
_0x75:
	CBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	SBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x76:
	CPI  R30,LOW(0x6)
	BREQ PC+2
	RJMP _0x85
	RJMP _0x86
_0x85:
	CPI  R30,LOW(0x36)
	BREQ PC+2
	RJMP _0x87
_0x86:
	CBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x87:
	CPI  R30,LOW(0x7)
	BREQ PC+2
	RJMP _0x96
	RJMP _0x97
_0x96:
	CPI  R30,LOW(0x37)
	BREQ PC+2
	RJMP _0x98
_0x97:
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x98:
	CPI  R30,LOW(0x8)
	BREQ PC+2
	RJMP _0xA7
	RJMP _0xA8
_0xA7:
	CPI  R30,LOW(0x38)
	BREQ PC+2
	RJMP _0xA9
_0xA8:
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0xA9:
	CPI  R30,LOW(0x9)
	BREQ PC+2
	RJMP _0xB8
	RJMP _0xB9
_0xB8:
	CPI  R30,LOW(0x39)
	BREQ PC+2
	RJMP _0xBA
_0xB9:
	RJMP _0xBB
_0xBA:
	CPI  R30,LOW(0x67)
	BREQ PC+2
	RJMP _0xBC
_0xBB:
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	SBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0xBC:
	CPI  R30,LOW(0xA)
	BREQ PC+2
	RJMP _0xCB
	RJMP _0xCC
_0xCB:
	CPI  R30,LOW(0x41)
	BREQ PC+2
	RJMP _0xCD
_0xCC:
	RJMP _0xCE
_0xCD:
	CPI  R30,LOW(0x61)
	BREQ PC+2
	RJMP _0xCF
_0xCE:
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0xCF:
	CPI  R30,LOW(0xB)
	BREQ PC+2
	RJMP _0xDE
	RJMP _0xDF
_0xDE:
	CPI  R30,LOW(0x42)
	BREQ PC+2
	RJMP _0xE0
_0xDF:
	RJMP _0xE1
_0xE0:
	CPI  R30,LOW(0x62)
	BREQ PC+2
	RJMP _0xE2
_0xE1:
	SBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0xE2:
	CPI  R30,LOW(0xC)
	BREQ PC+2
	RJMP _0xF1
	RJMP _0xF2
_0xF1:
	CPI  R30,LOW(0x43)
	BREQ PC+2
	RJMP _0xF3
_0xF2:
	CBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0xF3:
	CPI  R30,LOW(0x63)
	BREQ PC+2
	RJMP _0x102
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x102:
	CPI  R30,LOW(0xD)
	BREQ PC+2
	RJMP _0x111
	RJMP _0x112
_0x111:
	CPI  R30,LOW(0x44)
	BREQ PC+2
	RJMP _0x113
_0x112:
	RJMP _0x114
_0x113:
	CPI  R30,LOW(0x64)
	BREQ PC+2
	RJMP _0x115
_0x114:
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x115:
	CPI  R30,LOW(0xE)
	BREQ PC+2
	RJMP _0x124
	RJMP _0x125
_0x124:
	CPI  R30,LOW(0x45)
	BREQ PC+2
	RJMP _0x126
_0x125:
	CBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x126:
	CPI  R30,LOW(0x65)
	BREQ PC+2
	RJMP _0x135
	CBI  0x12,6
	CBI  0x12,5
	SBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x135:
	CPI  R30,LOW(0xF)
	BREQ PC+2
	RJMP _0x144
	RJMP _0x145
_0x144:
	CPI  R30,LOW(0x46)
	BREQ PC+2
	RJMP _0x146
_0x145:
	RJMP _0x147
_0x146:
	CPI  R30,LOW(0x66)
	BREQ PC+2
	RJMP _0x148
_0x147:
	CBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x148:
	CPI  R30,LOW(0x47)
	BREQ PC+2
	RJMP _0x157
	CBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x157:
	CPI  R30,LOW(0x48)
	BREQ PC+2
	RJMP _0x166
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x166:
	CPI  R30,LOW(0x68)
	BREQ PC+2
	RJMP _0x175
	SBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x175:
	CPI  R30,LOW(0x49)
	BREQ PC+2
	RJMP _0x184
	RJMP _0x185
_0x184:
	CPI  R30,LOW(0x69)
	BREQ PC+2
	RJMP _0x186
_0x185:
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x186:
	CPI  R30,LOW(0x4A)
	BREQ PC+2
	RJMP _0x195
	RJMP _0x196
_0x195:
	CPI  R30,LOW(0x6A)
	BREQ PC+2
	RJMP _0x197
_0x196:
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x197:
	CPI  R30,LOW(0x4C)
	BREQ PC+2
	RJMP _0x1A6
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x1A6:
	CPI  R30,LOW(0x4D)
	BREQ PC+2
	RJMP _0x1B5
	RJMP _0x1B6
_0x1B5:
	CPI  R30,LOW(0x6D)
	BREQ PC+2
	RJMP _0x1B7
_0x1B6:
	CBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x1B7:
	CPI  R30,LOW(0x4E)
	BREQ PC+2
	RJMP _0x1C6
	RJMP _0x1C7
_0x1C6:
	CPI  R30,LOW(0x6E)
	BREQ PC+2
	RJMP _0x1C8
_0x1C7:
	SBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x1C8:
	CPI  R30,LOW(0x6F)
	BREQ PC+2
	RJMP _0x1D7
	SBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x1D7:
	CPI  R30,LOW(0x50)
	BREQ PC+2
	RJMP _0x1E6
	RJMP _0x1E7
_0x1E6:
	CPI  R30,LOW(0x70)
	BREQ PC+2
	RJMP _0x1E8
_0x1E7:
	CBI  0x12,6
	CBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x1E8:
	CPI  R30,LOW(0x51)
	BREQ PC+2
	RJMP _0x1F7
	RJMP _0x1F8
_0x1F7:
	CPI  R30,LOW(0x71)
	BREQ PC+2
	RJMP _0x1F9
_0x1F8:
	CBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x1F9:
	CPI  R30,LOW(0x52)
	BREQ PC+2
	RJMP _0x208
	RJMP _0x209
_0x208:
	CPI  R30,LOW(0x72)
	BREQ PC+2
	RJMP _0x20A
_0x209:
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x20A:
	CPI  R30,LOW(0x54)
	BREQ PC+2
	RJMP _0x219
	RJMP _0x21A
_0x219:
	CPI  R30,LOW(0x74)
	BREQ PC+2
	RJMP _0x21B
_0x21A:
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x21B:
	CPI  R30,LOW(0x55)
	BREQ PC+2
	RJMP _0x22A
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x22A:
	CPI  R30,LOW(0x75)
	BREQ PC+2
	RJMP _0x239
	SBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x239:
	CPI  R30,LOW(0x56)
	BREQ PC+2
	RJMP _0x248
	RJMP _0x249
_0x248:
	CPI  R30,LOW(0x76)
	BREQ PC+2
	RJMP _0x24A
_0x249:
	SBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x24A:
	CPI  R30,LOW(0x57)
	BREQ PC+2
	RJMP _0x259
	RJMP _0x25A
_0x259:
	CPI  R30,LOW(0x77)
	BREQ PC+2
	RJMP _0x25B
_0x25A:
	CBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x25B:
	CPI  R30,LOW(0x59)
	BREQ PC+2
	RJMP _0x26A
	RJMP _0x26B
_0x26A:
	CPI  R30,LOW(0x79)
	BREQ PC+2
	RJMP _0x26C
_0x26B:
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	SBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x26C:
	CPI  R30,LOW(0x2D)
	BREQ PC+2
	RJMP _0x27B
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	RJMP _0x16
_0x27B:
	CPI  R30,LOW(0x22)
	BREQ PC+2
	RJMP _0x28A
	SBI  0x12,6
	CBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	CBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x28A:
	CPI  R30,LOW(0x27)
	BREQ PC+2
	RJMP _0x299
	SBI  0x12,6
	CBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x299:
	CPI  R30,LOW(0x5F)
	BREQ PC+2
	RJMP _0x2A8
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	CBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	RJMP _0x16
_0x2A8:
	CPI  R30,LOW(0x2A)
	BREQ PC+2
	RJMP _0x2C6
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
_0x2C6:
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
_0x16:
	ADIW R28,1
	RET
_clearDisplay:
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	SBI  0x15,2
	SBI  0x15,1
	SBI  0x15,0
	RET
_clearDisplayBuffer:
	LDI  R30,LOW(42)
	STS  _data,R30
	__PUTB1MN _data,1
	__PUTB1MN _data,2
	__PUTB1MN _data,3
	LDI  R30,LOW(0)
	STS  _dot,R30
	STS  _dot+1,R30
	__POINTW1MN _dot,2
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	STD  Z+0,R26
	STD  Z+1,R27
	__POINTW1MN _dot,4
	STD  Z+0,R26
	STD  Z+1,R27
	__POINTW1MN _dot,6
	STD  Z+0,R26
	STD  Z+1,R27
	RET
_show:
;	pos -> Y+2
;	digit -> Y+0
	RCALL _clearDisplay
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	LD   R30,Z
	ST   -Y,R30
	RCALL _calculate_segments
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDI  R26,LOW(_dot)
	LDI  R27,HIGH(_dot)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	SBIW R30,0
	BRNE PC+2
	RJMP _0x2ED
	CBI  0x18,5
	RJMP _0x2F0
_0x2ED:
	SBI  0x18,5
_0x2F0:
	LD   R30,Y
	LDD  R31,Y+1
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2F6
	CBI  0x15,3
	RJMP _0x2F5
_0x2F6:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2F9
	CBI  0x15,2
	RJMP _0x2F5
_0x2F9:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2FC
	CBI  0x15,1
	RJMP _0x2F5
_0x2FC:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2F5
	CBI  0x15,0
_0x2F5:
	ADIW R28,4
	RET
_set_char_at:
;	c -> Y+4
;	offset -> Y+2
;	dotflag -> Y+0
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDI  R26,LOW(_dot)
	LDI  R27,HIGH(_dot)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LD   R26,Y
	LDD  R27,Y+1
	STD  Z+0,R26
	STD  Z+1,R27
	ADIW R28,5
	RET
_shift_in:
;	c -> Y+2
;	dotflag -> Y+0
	__GETB1MN _data,1
	STS  _data,R30
	__GETB1MN _data,2
	__PUTB1MN _data,1
	__GETB1MN _data,3
	__PUTB1MN _data,2
	LDD  R30,Y+2
	__PUTB1MN _data,3
	__GETW1MN _dot,2
	STS  _dot,R30
	STS  _dot+1,R31
	__GETW1MN _dot,4
	__PUTW1MN _dot,2
	__GETW1MN _dot,6
	__PUTW1MN _dot,4
	LD   R30,Y
	LDD  R31,Y+1
	__PUTW1MN _dot,6
	ADIW R28,3
	RET

	.DSEG

	.CSEG
_multiplex:
	LDI  R26,LOW(_multiplex_counter)
	LDI  R27,HIGH(_multiplex_counter)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	LDS  R26,_multiplex_counter
	LDS  R27,_multiplex_counter+1
	SBIW R26,1
	BREQ PC+2
	RJMP _0x303
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _show
	RJMP _0x304
_0x303:
	LDS  R26,_multiplex_counter
	LDS  R27,_multiplex_counter+1
	SBIW R26,2
	BREQ PC+2
	RJMP _0x305
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _show
	RJMP _0x306
_0x305:
	LDS  R26,_multiplex_counter
	LDS  R27,_multiplex_counter+1
	SBIW R26,3
	BREQ PC+2
	RJMP _0x307
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _show
	RJMP _0x308
_0x307:
	LDS  R26,_multiplex_counter
	LDS  R27,_multiplex_counter+1
	SBIW R26,4
	BREQ PC+2
	RJMP _0x309
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _show
	RJMP _0x30A
_0x309:
	LDS  R26,_multiplex_counter
	LDS  R27,_multiplex_counter+1
	SBIW R26,5
	BREQ PC+2
	RJMP _0x30B
	RCALL _clearDisplay
_0x30B:
_0x30A:
_0x308:
_0x306:
_0x304:
	LDS  R26,_multiplex_counter
	LDS  R27,_multiplex_counter+1
	SBIW R26,6
	BRGE PC+2
	RJMP _0x30C
	LDI  R30,LOW(0)
	STS  _multiplex_counter,R30
	STS  _multiplex_counter+1,R30
_0x30C:
	RET
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	LDI  R30,LOW(255)
	OUT  0x32,R30
	LDS  R30,_display
	LDS  R31,_display+1
	SBIW R30,0
	BRNE PC+2
	RJMP _0x30D
	RCALL _multiplex
_0x30D:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;#include <microdozik.h>
_pump:
	RCALL __SAVELOCR2
;	i -> R16,R17
	SBRS R2,4
	RJMP _0x30E
	LDI  R30,LOW(0)
	OUT  0x3B,R30
	__GETWRN 16,17,0
_0x310:
	LDS  R30,_delay_pump
	LDS  R31,_delay_pump+1
	CP   R16,R30
	CPC  R17,R31
	BRLO PC+2
	RJMP _0x311
	SBI  0x12,1
	__DELAY_USB 5
	CBI  0x12,1
	__DELAY_USB 27
	wdr
_0x30F:
	__ADDWRN 16,17,1
	RJMP _0x310
_0x311:
	__DELAY_USB 67
	CLT
	BLD  R2,4
	LDI  R30,LOW(192)
	OUT  0x3B,R30
_0x30E:
	RCALL __LOADLOCR2P
	RET
_alarm_check:
	MOVW R26,R8
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RCALL __GTW12U
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,7
	LDI  R30,1
	AND  R30,R26
	BRNE PC+2
	RJMP _0x316
	SBI  0x15,4
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _display,R30
	STS  _display+1,R31
	SET
	BLD  R2,6
	CLT
	BLD  R3,4
	SET
	BLD  R3,3
_0x316:
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CP   R8,R30
	CPC  R9,R31
	BRSH PC+2
	RJMP _0x31A
	SBRC R2,7
	RJMP _0x31A
	RJMP _0x319
_0x31A:
	CBI  0x15,4
	CLT
	BLD  R2,6
_0x319:
	RET
_check_battery:
	RCALL __SAVELOCR2
;	pump_multipiller -> R16,R17
	__GETWRN 16,17,100
	RCALL _read_adc
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	CPI  R26,LOW(0x1A4)
	LDI  R30,HIGH(0x1A4)
	CPC  R27,R30
	BRLO PC+2
	RJMP _0x31E
	LDI  R30,LOW(420)
	LDI  R31,HIGH(420)
	SUB  R30,R26
	SBC  R31,R27
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	RCALL __MULW12U
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	RCALL __MULW12U
	MOVW R26,R30
	LDI  R30,LOW(420)
	LDI  R31,HIGH(420)
	RCALL __DIVW21U
	MOVW R16,R30
	__MULBNWRU 16,17,13
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	ADIW R30,13
	STS  _impulse_pump,R30
	STS  _impulse_pump+1,R31
	__MULBNWRU 16,17,100
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	SUBI R30,LOW(-100)
	SBCI R31,HIGH(-100)
	STS  _delay_pump,R30
	STS  _delay_pump+1,R31
	wdr
	RJMP _0x31F
_0x31E:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	STS  _impulse_pump,R30
	STS  _impulse_pump+1,R31
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	STS  _delay_pump,R30
	STS  _delay_pump+1,R31
_0x31F:
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	CPI  R26,LOW(0x12C)
	LDI  R30,HIGH(0x12C)
	CPC  R27,R30
	BRLO PC+2
	RJMP _0x320
	SBI  0x15,4
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	SBI  0x15,4
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
	LDI  R30,LOW(70)
	LDI  R31,HIGH(70)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	SBI  0x15,4
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
	wdr
_0x320:
	RCALL __LOADLOCR2P
	RET
_check_sbm20:
	MOV  R0,R8
	OR   R0,R9
	BREQ PC+2
	RJMP _0x32D
	LDS  R30,_error_count
	SUBI R30,-LOW(1)
	STS  _error_count,R30
	RJMP _0x32E
_0x32D:
	LDI  R30,LOW(0)
	STS  _error_count,R30
_0x32E:
	LDS  R26,_error_count
	CPI  R26,LOW(0x4)
	BRGE PC+2
	RJMP _0x32F
	SET
	BLD  R2,4
	RCALL _pump
_0x32F:
	LDS  R26,_error_count
	CPI  R26,LOW(0x6)
	BRGE PC+2
	RJMP _0x330
	SBI  0x15,4
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	CBI  0x15,4
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	SBI  0x15,4
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	CBI  0x15,4
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	SBI  0x15,4
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	wdr
	CBI  0x15,4
_0x330:
	RET
_read_adc:
	RCALL __SAVELOCR4
;	tmpv -> R16,R17
;	ixi -> R19
;	MCUCR_def -> R18
	__GETWRN 16,17,0
	LDI  R19,64
	sei
	LDI  R30,LOW(231)
	OUT  0x7,R30
	LDI  R30,LOW(159)
	OUT  0x6,R30
	IN   R18,53
	LDI  R30,LOW(144)
	OUT  0x35,R30
	__DELAY_USW 250
	LDI  R30,LOW(0)
	OUT  0x39,R30
_0x33D:
	CPI  R19,1
	BRSH PC+2
	RJMP _0x33F
	sleep
	wdr
	LDS  R30,_VoltLevel
	LDS  R31,_VoltLevel+1
	__ADDWRR 16,17,30,31
	SUBI R19,1
	RJMP _0x33D
_0x33F:
	LDI  R30,LOW(65)
	OUT  0x39,R30
	OUT  0x35,R18
	LDI  R30,LOW(0)
	OUT  0x6,R30
	OUT  0x8,R30
	OUT  0x7,R30
	MOVW R26,R16
	LDI  R30,LOW(6)
	RCALL __LSRW12
	STS  _VoltLevel,R30
	STS  _VoltLevel+1,R31
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;
;
;//  ********************************************************************
;void check_battery();
;
;
;//--------------------------------- --------------------------//
;interrupt [ADC_INT] void voidadc_isr(void)
; 0000 0061 {
_voidadc_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0062     VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
	IN   R30,0x5
	LDI  R31,0
	SBIW R30,1
	LSL  R30
	ROL  R31
	STS  _VoltLevel,R30
	STS  _VoltLevel+1,R31
; 0000 0063     //VoltLevel=1023;
; 0000 0064 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;//  ********************************************************************
;
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0069 {
_ext_int0_isr:
	ST   -Y,R24
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 006A unsigned char i;
; 0000 006B         #asm("wdr")
	ST   -Y,R17
;	i -> R17
	wdr
; 0000 006C rad_massive[rad_cnt]++;
	MOVW R30,R12
	LDI  R26,LOW(_rad_massive)
	LDI  R27,HIGH(_rad_massive)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 006D blink=1;
	SET
	BLD  R2,1
; 0000 006E 
; 0000 006F     // 
; 0000 0070     for(i=0;i<impulse_pump;i++)
	LDI  R17,LOW(0)
_0x341:
	LDS  R30,_impulse_pump
	LDS  R31,_impulse_pump+1
	MOV  R26,R17
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRLO PC+2
	RJMP _0x342
; 0000 0071     {
; 0000 0072         trans=1;
	SBI  0x12,1
; 0000 0073         delay_us(2);
	__DELAY_USB 5
; 0000 0074         trans=0;
	CBI  0x12,1
; 0000 0075         delay_us(7);
	__DELAY_USB 19
; 0000 0076         #asm("wdr")
	wdr
; 0000 0077     }
_0x340:
	SUBI R17,-1
	RJMP _0x341
_0x342:
; 0000 0078      delay_us(25);
	__DELAY_USB 67
; 0000 0079 }
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R24,Y+
	RETI
;
;
;//  ********************************************************************
;
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 007F {
_ext_int1_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0080 
; 0000 0081     key_press_x=0;
	LDI  R30,LOW(0)
	STS  _key_press_x,R30
	STS  _key_press_x+1,R30
; 0000 0082     if(doze_mode)doze_mode=0;
	SBRS R3,0
	RJMP _0x347
	CLT
	BLD  R3,0
; 0000 0083     if(hours_mode)hours_mode=0;
_0x347:
	SBRS R3,2
	RJMP _0x348
	CLT
	BLD  R3,2
; 0000 0084     if(volts_mode)volts_mode=0;
_0x348:
	SBRS R3,1
	RJMP _0x349
	CLT
	BLD  R3,1
; 0000 0085 
; 0000 0086     if ((!alarm)&&(display_time < time_to_display)) //      -    
_0x349:
	SBRC R2,6
	RJMP _0x34B
	LDS  R26,_display_time
	CPI  R26,LOW(0x5B)
	BRLT PC+2
	RJMP _0x34B
	RJMP _0x34C
_0x34B:
	RJMP _0x34A
_0x34C:
; 0000 0087     {
; 0000 0088         if(search_mode) { fon_mode=1; search_mode=0; } else { fon_mode=0; search_mode=1;}
	SBRS R3,4
	RJMP _0x34D
	SET
	BLD  R3,3
	CLT
	BLD  R3,4
	RJMP _0x34E
_0x34D:
	CLT
	BLD  R3,3
	SET
	BLD  R3,4
_0x34E:
; 0000 0089     }
; 0000 008A     if (was_in_menu) { fon_mode=1; search_mode=0; was_in_menu=0; } //       
_0x34A:
	SBRS R2,3
	RJMP _0x34F
	SET
	BLD  R3,3
	CLT
	BLD  R3,4
	BLD  R2,3
; 0000 008B 
; 0000 008C     while(!key)  //    
_0x34F:
_0x350:
	SBIC 0x10,3
	RJMP _0x352
; 0000 008D     {
; 0000 008E         clearDisplay();
	RCALL _clearDisplay
; 0000 008F         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0090         key_press++;
	LDI  R26,LOW(_key_press)
	LDI  R27,HIGH(_key_press)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0091         if(key_press>20) //    2 ,  1      
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	SBIW R26,21
	BRSH PC+2
	RJMP _0x353
; 0000 0092         {
; 0000 0093 //            PORTD.6=0;PORTD.5=0;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=0;PORTB.2=0; PORTB.5=1; PORTC.3=0;PORTC.2=0;PORTC.1=0;PORTC.0=0; //on
; 0000 0094 //            PORTD.6=1;PORTD.5=1;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=1;PORTB.2=1; PORTB.5=1; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
; 0000 0095         key_press_x++;
	LDI  R26,LOW(_key_press_x)
	LDI  R27,HIGH(_key_press_x)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0096 
; 0000 0097   switch (key_press_x){
	LDS  R30,_key_press_x
	LDS  R31,_key_press_x+1
; 0000 0098   {case 1: // d
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x357
; 0000 0099         beep=1; delay_ms(100); beep=0;
	SBI  0x15,4
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
; 0000 009A         PORTD.6=1;PORTD.5=0;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=1;PORTB.2=0; PORTB.5=0; PORTC.3=1;PORTC.2=0;PORTC.1=0;PORTC.0=1; //on
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	CBI  0x18,5
	SBI  0x15,3
	CBI  0x15,2
	CBI  0x15,1
	SBI  0x15,0
; 0000 009B         delay_ms(400);
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 009C         PORTD.6=1;PORTD.5=1;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=1;PORTB.2=1; PORTB.5=1; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	SBI  0x15,2
	SBI  0x15,1
	SBI  0x15,0
; 0000 009D         break;}
	RJMP _0x356
; 0000 009E   {case 2: // H
_0x357:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x38C
; 0000 009F         beep=1; delay_ms(100); beep=0;
	SBI  0x15,4
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
; 0000 00A0         PORTD.6=1;PORTD.5=0;PORTB.0=0;PORTB.1=1;PORTB.3=0;PORTB.4=0;PORTB.2=0; PORTB.5=1; PORTC.3=1;PORTC.2=0;PORTC.1=0;PORTC.0=1; //on
	SBI  0x12,6
	CBI  0x12,5
	CBI  0x18,0
	SBI  0x18,1
	CBI  0x18,3
	CBI  0x18,4
	CBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	CBI  0x15,2
	CBI  0x15,1
	SBI  0x15,0
; 0000 00A1         delay_ms(400);
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00A2         PORTD.6=1;PORTD.5=1;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=1;PORTB.2=1; PORTB.5=1; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	SBI  0x15,2
	SBI  0x15,1
	SBI  0x15,0
; 0000 00A3         break;}
	RJMP _0x356
; 0000 00A4   {case 3: // U
_0x38C:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x3C1
; 0000 00A5         beep=1; delay_ms(100); beep=0;
	SBI  0x15,4
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
; 0000 00A6         PORTD.6=1;PORTD.5=1;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=1;PORTB.2=1; PORTB.5=1; PORTC.3=1;PORTC.2=0;PORTC.1=0;PORTC.0=1; //on
	SBI  0x12,6
	SBI  0x12,5
	CBI  0x18,0
	CBI  0x18,1
	CBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	CBI  0x15,2
	CBI  0x15,1
	SBI  0x15,0
; 0000 00A7         delay_ms(400);
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00A8         PORTD.6=1;PORTD.5=1;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=1;PORTB.2=1; PORTB.5=1; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	SBI  0x15,2
	SBI  0x15,1
	SBI  0x15,0
; 0000 00A9         break;}
	RJMP _0x356
; 0000 00AA   {case 4: // --
_0x3C1:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x356
; 0000 00AB         beep=1; delay_ms(100); beep=0;
	SBI  0x15,4
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,4
; 0000 00AC         PORTD.6=1;PORTD.5=1;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=1;PORTB.2=0; PORTB.5=1; PORTC.3=1;PORTC.2=0;PORTC.1=0;PORTC.0=1; //on
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	CBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	CBI  0x15,2
	CBI  0x15,1
	SBI  0x15,0
; 0000 00AD         delay_ms(400);
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00AE         PORTD.6=1;PORTD.5=1;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=1;PORTB.2=1; PORTB.5=1; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x18,0
	SBI  0x18,1
	SBI  0x18,3
	SBI  0x18,4
	SBI  0x18,2
	SBI  0x18,5
	SBI  0x15,3
	SBI  0x15,2
	SBI  0x15,1
	SBI  0x15,0
; 0000 00AF         break;}
; 0000 00B0    }
_0x356:
; 0000 00B1             delay_ms(700);
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00B2         }
; 0000 00B3     }
_0x353:
	RJMP _0x350
_0x352:
; 0000 00B4         if(key_press>20) //    2 ,   
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	SBIW R26,21
	BRSH PC+2
	RJMP _0x42B
; 0000 00B5         {
; 0000 00B6             was_in_menu=1;
	SET
	BLD  R2,3
; 0000 00B7             if(key_press_x==1)
	LDS  R26,_key_press_x
	LDS  R27,_key_press_x+1
	SBIW R26,1
	BREQ PC+2
	RJMP _0x42C
; 0000 00B8             {
; 0000 00B9             doze_mode=1; //  
	BLD  R3,0
; 0000 00BA             hours_mode=0;
	CLT
	BLD  R3,2
; 0000 00BB             volts_mode=0;
	BLD  R3,1
; 0000 00BC             }
; 0000 00BD             if(key_press_x==2)
_0x42C:
	LDS  R26,_key_press_x
	LDS  R27,_key_press_x+1
	SBIW R26,2
	BREQ PC+2
	RJMP _0x42D
; 0000 00BE             {
; 0000 00BF             doze_mode=0; //  
	CLT
	BLD  R3,0
; 0000 00C0             hours_mode=1;
	SET
	BLD  R3,2
; 0000 00C1             volts_mode=0;
	CLT
	BLD  R3,1
; 0000 00C2             }
; 0000 00C3             if(key_press_x==3)
_0x42D:
	LDS  R26,_key_press_x
	LDS  R27,_key_press_x+1
	SBIW R26,3
	BREQ PC+2
	RJMP _0x42E
; 0000 00C4             {
; 0000 00C5             doze_mode=0; //  
	CLT
	BLD  R3,0
; 0000 00C6             hours_mode=0;
	BLD  R3,2
; 0000 00C7             volts_mode=1;
	SET
	BLD  R3,1
; 0000 00C8             }
; 0000 00C9             if(key_press_x>3)
_0x42E:
	LDS  R26,_key_press_x
	LDS  R27,_key_press_x+1
	SBIW R26,4
	BRSH PC+2
	RJMP _0x42F
; 0000 00CA             {
; 0000 00CB             doze_mode=0; // 
	CLT
	BLD  R3,0
; 0000 00CC             hours_mode=0;
	BLD  R3,2
; 0000 00CD             volts_mode=0;
	BLD  R3,1
; 0000 00CE             }
; 0000 00CF             search_mode=0;
_0x42F:
	CLT
	BLD  R3,4
; 0000 00D0             display_time=0;
	LDI  R30,LOW(0)
	STS  _display_time,R30
; 0000 00D1             display=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _display,R30
	STS  _display+1,R31
; 0000 00D2             beep=0;
	CBI  0x15,4
; 0000 00D3 
; 0000 00D4          }
; 0000 00D5     key_press=0;
_0x42B:
	LDI  R30,LOW(0)
	STS  _key_press,R30
	STS  _key_press+1,R30
; 0000 00D6     display_time=0;
	STS  _display_time,R30
; 0000 00D7     clearDisplayBuffer();
	RCALL _clearDisplayBuffer
; 0000 00D8     clearDisplay();
	RCALL _clearDisplay
; 0000 00D9     if(alarm)user_cancel_alarm=1;
	SBRS R2,6
	RJMP _0x432
	SET
	BLD  R2,7
; 0000 00DA     #asm("wdr")
_0x432:
	wdr
; 0000 00DB }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;//  ********************************************************************
;
;
;
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 00E2 {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00E3     TIFR |= (1<<TOV2);
	IN   R30,0x38
	ORI  R30,0x40
	OUT  0x38,R30
; 0000 00E4     TCNT2=0xDF; //   
	LDI  R30,LOW(223)
	OUT  0x24,R30
; 0000 00E5 
; 0000 00E6     //          . 
; 0000 00E7     if (rad_cnt == rad_interval) {rad_massive[0]=0; rad_cnt=0; counted=1;} else { rad_massive[rad_cnt+1]=0;  rad_cnt++;}
	__CPWRR 4,5,12,13
	BREQ PC+2
	RJMP _0x433
	LDI  R30,LOW(0)
	STS  _rad_massive,R30
	STS  _rad_massive+1,R30
	CLR  R12
	CLR  R13
	SET
	BLD  R2,0
	RJMP _0x434
_0x433:
	MOVW R26,R12
	LSL  R26
	ROL  R27
	__ADDW2MN _rad_massive,2
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
_0x434:
; 0000 00E8     //         
; 0000 00E9 
; 0000 00EA 
; 0000 00EB     if ((alarm_cnt >= alarm_counter)&(counted)&(!user_cancel_alarm)) {beep=1;display=1;alarm=1;search_mode=0;fon_mode=1;}
	LDS  R26,_alarm_cnt
	LDI  R30,LOW(3)
	RCALL __GEB12U
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,7
	LDI  R30,1
	AND  R30,R26
	BRNE PC+2
	RJMP _0x435
	SBI  0x15,4
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _display,R30
	STS  _display+1,R31
	SET
	BLD  R2,6
	CLT
	BLD  R3,4
	SET
	BLD  R3,3
; 0000 00EC     //     alarm_counter    - 
; 0000 00ED     if ((alarm_cnt < alarm_counter)||(user_cancel_alarm)) {beep=0;alarm=0;} //  -  
_0x435:
	LDS  R26,_alarm_cnt
	CPI  R26,LOW(0x3)
	BRSH PC+2
	RJMP _0x439
	SBRC R2,7
	RJMP _0x439
	RJMP _0x438
_0x439:
	CBI  0x15,4
	CLT
	BLD  R2,6
; 0000 00EE     alarm_cnt=0;
_0x438:
	LDI  R30,LOW(0)
	STS  _alarm_cnt,R30
; 0000 00EF 
; 0000 00F0     second_tick++;
	LDS  R30,_second_tick
	SUBI R30,-LOW(1)
	STS  _second_tick,R30
; 0000 00F1     if(second_tick>59)
	LDS  R26,_second_tick
	CPI  R26,LOW(0x3C)
	BRSH PC+2
	RJMP _0x43D
; 0000 00F2     {
; 0000 00F3         second_tick=0;
	LDI  R30,LOW(0)
	STS  _second_tick,R30
; 0000 00F4         minutes++;
	LDS  R30,_minutes
	SUBI R30,-LOW(1)
	STS  _minutes,R30
; 0000 00F5         minute_tick++;
	LDS  R30,_minute_tick
	SUBI R30,-LOW(1)
	STS  _minute_tick,R30
; 0000 00F6         check_battery();
	RCALL _check_battery
; 0000 00F7         check_sbm20();
	RCALL _check_sbm20
; 0000 00F8         if (minute_tick%5) user_cancel_alarm=0;
	LDS  R26,_minute_tick
	LDI  R30,LOW(5)
	RCALL __MODB21U
	CPI  R30,0
	BRNE PC+2
	RJMP _0x43E
	CLT
	BLD  R2,7
; 0000 00F9         //      .   5    .
; 0000 00FA     }
_0x43E:
; 0000 00FB 
; 0000 00FC     if(minute_tick>59)
_0x43D:
	LDS  R26,_minute_tick
	CPI  R26,LOW(0x3C)
	BRSH PC+2
	RJMP _0x43F
; 0000 00FD     {
; 0000 00FE         rad_hour += rad_fon; //      
	__ADDWRR 10,11,8,9
; 0000 00FF         doze = rad_hour + fulldoze; //      +   
	LDS  R30,_fulldoze
	LDS  R31,_fulldoze+1
	LDS  R22,_fulldoze+2
	LDS  R23,_fulldoze+3
	MOVW R26,R10
	CLR  R24
	CLR  R25
	RCALL __ADDD12
	STS  _doze,R30
	STS  _doze+1,R31
	STS  _doze+2,R22
	STS  _doze+3,R23
; 0000 0100         minute_tick=0;
	LDI  R30,LOW(0)
	STS  _minute_tick,R30
; 0000 0101         minutes=0;
	STS  _minutes,R30
; 0000 0102         hours++;
	LDS  R30,_hours
	SUBI R30,-LOW(1)
	STS  _hours,R30
; 0000 0103         hour_tick++;
	LDS  R30,_hour_tick
	SUBI R30,-LOW(1)
	STS  _hour_tick,R30
; 0000 0104     }
; 0000 0105     if(hour_tick>23)
_0x43F:
	LDS  R26,_hour_tick
	CPI  R26,LOW(0x18)
	BRSH PC+2
	RJMP _0x440
; 0000 0106     {
; 0000 0107         day_doze = rad_hour; rad_hour = 0; //     .   
	MOVW R30,R10
	CLR  R22
	CLR  R23
	STS  _day_doze,R30
	STS  _day_doze+1,R31
	STS  _day_doze+2,R22
	STS  _day_doze+3,R23
	CLR  R10
	CLR  R11
; 0000 0108         fulldoze += day_doze; //        
	LDS  R26,_fulldoze
	LDS  R27,_fulldoze+1
	LDS  R24,_fulldoze+2
	LDS  R25,_fulldoze+3
	RCALL __ADDD12
	STS  _fulldoze,R30
	STS  _fulldoze+1,R31
	STS  _fulldoze+2,R22
	STS  _fulldoze+3,R23
; 0000 0109         hour_tick=0;
	LDI  R30,LOW(0)
	STS  _hour_tick,R30
; 0000 010A         sutki++;
	LDI  R26,LOW(_sutki)
	LDI  R27,HIGH(_sutki)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 010B         hours=0;
	LDI  R30,LOW(0)
	STS  _hours,R30
; 0000 010C     }
; 0000 010D 
; 0000 010E     second++;
_0x440:
	LDS  R30,_second
	SUBI R30,-LOW(1)
	STS  _second,R30
; 0000 010F     need_pump=1;
	SET
	BLD  R2,4
; 0000 0110     // pump();
; 0000 0111     display_time++;
	LDS  R30,_display_time
	SUBI R30,-LOW(1)
	STS  _display_time,R30
; 0000 0112     if (display_time > 100) display_time =96;
	LDS  R26,_display_time
	CPI  R26,LOW(0x65)
	BRGE PC+2
	RJMP _0x441
	LDI  R30,LOW(96)
	STS  _display_time,R30
; 0000 0113 }
_0x441:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// *******************************************************************
;
;void calculate_rad(void)
; 0000 0118 {
_calculate_rad:
; 0000 0119 
; 0000 011A     iv=0;
	LDI  R30,LOW(0)
	STS  _iv,R30
	STS  _iv+1,R30
; 0000 011B     ivc=0;
	STS  _ivc,R30
	STS  _ivc+1,R30
; 0000 011C     peak=0;
	STS  _peak,R30
	STS  _peak+1,R30
; 0000 011D     rcnt=0;
	STS  _rcnt,R30
	STS  _rcnt+1,R30
; 0000 011E     rad=0;
	CLR  R6
	CLR  R7
; 0000 011F 
; 0000 0120     //   
; 0000 0121     if (counted) {s=rad_interval+1;} else {s=rad_cnt+1;} //       .  -  
	SBRS R2,0
	RJMP _0x442
	MOVW R30,R4
	ADIW R30,1
	STS  _s,R30
	STS  _s+1,R31
	RJMP _0x443
_0x442:
	MOVW R30,R12
	ADIW R30,1
	STS  _s,R30
	STS  _s+1,R31
_0x443:
; 0000 0122 
; 0000 0123     for(x=0;x<s;x++) //      .
	LDI  R30,LOW(0)
	STS  _x,R30
	STS  _x+1,R30
_0x445:
	LDS  R30,_s
	LDS  R31,_s+1
	LDS  R26,_x
	LDS  R27,_x+1
	CP   R26,R30
	CPC  R27,R31
	BRLO PC+2
	RJMP _0x446
; 0000 0124     {
; 0000 0125     peak += rad_massive[x];
	LDS  R30,_x
	LDS  R31,_x+1
	LDI  R26,LOW(_rad_massive)
	LDI  R27,HIGH(_rad_massive)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	LDS  R26,_peak
	LDS  R27,_peak+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _peak,R30
	STS  _peak+1,R31
; 0000 0126 	rad += rad_massive[x];
	LDS  R30,_x
	LDS  R31,_x+1
	LDI  R26,LOW(_rad_massive)
	LDI  R27,HIGH(_rad_massive)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	__ADDWRR 6,7,30,31
; 0000 0127 if (iv == 35)  // [0-35]  36 
	LDS  R26,_iv
	LDS  R27,_iv+1
	SBIW R26,35
	BREQ PC+2
	RJMP _0x447
; 0000 0128  {
; 0000 0129  if (peak > alarm_level) alarm_cnt++;
	LDS  R26,_peak
	LDS  R27,_peak+1
	SBIW R26,61
	BRSH PC+2
	RJMP _0x448
	LDS  R30,_alarm_cnt
	SUBI R30,-LOW(1)
	STS  _alarm_cnt,R30
; 0000 012A  rcnt += peak;
_0x448:
	LDS  R30,_peak
	LDS  R31,_peak+1
	LDS  R26,_rcnt
	LDS  R27,_rcnt+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _rcnt,R30
	STS  _rcnt+1,R31
; 0000 012B  peak=0;
	LDI  R30,LOW(0)
	STS  _peak,R30
	STS  _peak+1,R30
; 0000 012C  ivc++;
	LDI  R26,LOW(_ivc)
	LDI  R27,HIGH(_ivc)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 012D  iv=0;
	LDI  R30,LOW(0)
	STS  _iv,R30
	STS  _iv+1,R30
; 0000 012E  }
; 0000 012F     iv++;
_0x447:
	LDI  R26,LOW(_iv)
	LDI  R27,HIGH(_iv)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0130     }
_0x444:
	LDI  R26,LOW(_x)
	LDI  R27,HIGH(_x)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0x445
_0x446:
; 0000 0131          if (counted)
	SBRS R2,0
	RJMP _0x449
; 0000 0132         {
; 0000 0133         rad_fon = rcnt/ivc; //    36   
	LDS  R30,_ivc
	LDS  R31,_ivc+1
	LDS  R26,_rcnt
	LDS  R27,_rcnt+1
	RCALL __DIVW21U
	MOVW R8,R30
; 0000 0134 		}
; 0000 0135         else
	RJMP _0x44A
_0x449:
; 0000 0136         {
; 0000 0137 		rad_fon = rad*36/(rad_cnt+1); // 
	MOVW R30,R6
	LDI  R26,LOW(36)
	LDI  R27,HIGH(36)
	RCALL __MULW12U
	MOVW R26,R30
	MOVW R30,R12
	ADIW R30,1
	RCALL __DIVW21U
	MOVW R8,R30
; 0000 0138 		}
_0x44A:
; 0000 0139 
; 0000 013A 
; 0000 013B /*
; 0000 013C unsigned int s, x, iv, ivc;
; 0000 013D unsigned int peak, rcnt;
; 0000 013E 
; 0000 013F     iv=0;
; 0000 0140     ivc=0;
; 0000 0141     peak=0;
; 0000 0142 
; 0000 0143     //   
; 0000 0144     if (counted) s=rad_interval+1; else s=rad_cnt+1; //       .  -  
; 0000 0145     rcnt=0;
; 0000 0146     rad=0;
; 0000 0147 
; 0000 0148     for(x=0;x<s;x++) //      .
; 0000 0149     {
; 0000 014A     peak = peak+rad_massive[x];
; 0000 014B if (iv > 34)  // [0-35]  36 
; 0000 014C  {
; 0000 014D  if (peak > alarm_level) alarm_cnt++;
; 0000 014E  rcnt += peak;
; 0000 014F  rad += peak;
; 0000 0150  peak=0;
; 0000 0151  ivc++; iv=0;
; 0000 0152  }
; 0000 0153     iv++;
; 0000 0154     }
; 0000 0155 
; 0000 0156         if ((rad_cnt < 37)&&(!counted))
; 0000 0157         {
; 0000 0158         rad_fon = rad;
; 0000 0159         }
; 0000 015A         else
; 0000 015B         {
; 0000 015C         s=ivc+1;
; 0000 015D         rad_fon = rcnt/s; //    36   
; 0000 015E         }
; 0000 015F */
; 0000 0160 }
	RET
;
;// ********************************************************************
;
;
;void main(void)
; 0000 0166 {
_main:
; 0000 0167 unsigned long i=0;
; 0000 0168 wdt_error=0;
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
;	i -> Y+0
	LDI  R26,LOW(_wdt_error)
	LDI  R27,HIGH(_wdt_error)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL __EEPROMWRW
; 0000 0169 rad_cnt=0;
	CLR  R12
	CLR  R13
; 0000 016A 
; 0000 016B #pragma optsize-
; 0000 016C 
; 0000 016D if (MCUCSR & 0x08)    //0000 1000
	IN   R30,0x34
	SBRS R30,3
	RJMP _0x44B
; 0000 016E    {
; 0000 016F    // Watchdog Reset
; 0000 0170    reset_by_wdt = 1;
	SET
	BLD  R2,5
; 0000 0171    wdt_error++;
	LDI  R26,LOW(_wdt_error)
	LDI  R27,HIGH(_wdt_error)
	RCALL __EEPROMRDW
	ADIW R30,1
	RCALL __EEPROMWRW
	SBIW R30,1
; 0000 0172    MCUCSR=0;
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 0173    }
; 0000 0174 MCUCSR=0;
_0x44B:
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 0175 
; 0000 0176 WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 0177 WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 0178 #ifdef _OPTIMIZE_SIZE_
; 0000 0179 #pragma optsize+
; 0000 017A #endif
; 0000 017B 
; 0000 017C 
; 0000 017D PORTB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x18,R30
; 0000 017E DDRB=0x3F;
	OUT  0x17,R30
; 0000 017F PORTC=0x0F;
	LDI  R30,LOW(15)
	OUT  0x15,R30
; 0000 0180 DDRC=0x1F;
	LDI  R30,LOW(31)
	OUT  0x14,R30
; 0000 0181 PORTD=0x6C;
	LDI  R30,LOW(108)
	OUT  0x12,R30
; 0000 0182 DDRD=0x62;
	LDI  R30,LOW(98)
	OUT  0x11,R30
; 0000 0183 
; 0000 0184 //TCCR0=0x02;
; 0000 0185 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 0186 TCNT0=0xFF;
	LDI  R30,LOW(255)
	OUT  0x32,R30
; 0000 0187 
; 0000 0188 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 0189 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 018A TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 018B TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 018C ICR1H=0x00;
	OUT  0x27,R30
; 0000 018D ICR1L=0x00;
	OUT  0x26,R30
; 0000 018E OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 018F OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0190 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0191 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0192 
; 0000 0193 ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 0194 TCCR2=0x07;
	LDI  R30,LOW(7)
	OUT  0x25,R30
; 0000 0195 TCNT2=0xDF;
	LDI  R30,LOW(223)
	OUT  0x24,R30
; 0000 0196 OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 0197 
; 0000 0198 GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 0199 MCUCR=0xB0;
	LDI  R30,LOW(176)
	OUT  0x35,R30
; 0000 019A GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 019B 
; 0000 019C TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 019D 
; 0000 019E // delay_ms(2);
; 0000 019F 
; 0000 01A0 
; 0000 01A1 if(!key) //     ,    .
	SBIC 0x10,3
	RJMP _0x44C
; 0000 01A2 {
; 0000 01A3 DDRC.4=0;
	CBI  0x14,4
; 0000 01A4 beep_on_pulse=0;
	LDI  R30,LOW(0)
	STS  _beep_on_pulse,R30
	STS  _beep_on_pulse+1,R30
; 0000 01A5 }
; 0000 01A6 
; 0000 01A7 
; 0000 01A8     GICR=0x00;
_0x44C:
	LDI  R30,LOW(0)
	OUT  0x3B,R30
; 0000 01A9     for(i=0;i<120000;i++)
	RCALL __CLRD1S0
_0x450:
	RCALL __GETD2S0
	__CPD2N 0x1D4C0
	BRLO PC+2
	RJMP _0x451
; 0000 01AA     {
; 0000 01AB         i++;
	RCALL __GETD1S0
	__SUBD1N -1
	RCALL __PUTD1S0
; 0000 01AC         trans=1;
	SBI  0x12,1
; 0000 01AD         delay_us(3);
	__DELAY_USB 8
; 0000 01AE         trans=0;
	CBI  0x12,1
; 0000 01AF         delay_us(7);
	__DELAY_USB 19
; 0000 01B0         #asm("wdr")
	wdr
; 0000 01B1     }
_0x44F:
	RCALL __GETD1S0
	__SUBD1N -1
	RCALL __PUTD1S0
	RJMP _0x450
_0x451:
; 0000 01B2     tem=0;
	LDI  R30,LOW(0)
	STS  _tem,R30
	STS  _tem+1,R30
; 0000 01B3     GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 01B4 iv=0;
	LDI  R30,LOW(0)
	STS  _iv,R30
	STS  _iv+1,R30
; 0000 01B5 ivc=0;
	STS  _ivc,R30
	STS  _ivc+1,R30
; 0000 01B6 peak=0;
	STS  _peak,R30
	STS  _peak+1,R30
; 0000 01B7 rcnt=0;
	STS  _rcnt,R30
	STS  _rcnt+1,R30
; 0000 01B8 rad=0;
	CLR  R6
	CLR  R7
; 0000 01B9 for(x=0;x<(rad_interval+1);x++){ rad_massive[x]=0;} //  .     , 
	STS  _x,R30
	STS  _x+1,R30
_0x457:
	MOVW R30,R4
	ADIW R30,1
	LDS  R26,_x
	LDS  R27,_x+1
	CP   R26,R30
	CPC  R27,R31
	BRLO PC+2
	RJMP _0x458
	LDS  R30,_x
	LDS  R31,_x+1
	LDI  R26,LOW(_rad_massive)
	LDI  R27,HIGH(_rad_massive)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x456:
	LDI  R26,LOW(_x)
	LDI  R27,HIGH(_x)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0x457
_0x458:
; 0000 01BA 
; 0000 01BB     delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01BC 
; 0000 01BD 
; 0000 01BE check_battery();
	RCALL _check_battery
; 0000 01BF 
; 0000 01C0 #asm("sei") // 
	sei
; 0000 01C1 
; 0000 01C2 
; 0000 01C3 while (1)
_0x459:
; 0000 01C4  {
; 0000 01C5  calculate_rad();
	RCALL _calculate_rad
; 0000 01C6 
; 0000 01C7  if(display_time < time_to_display)         //time_to_display    
	LDS  R26,_display_time
	CPI  R26,LOW(0x5B)
	BRLT PC+2
	RJMP _0x45C
; 0000 01C8    {
; 0000 01C9  display=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _display,R30
	STS  _display+1,R31
; 0000 01CA  if(doze_mode)
	SBRS R3,0
	RJMP _0x45D
; 0000 01CB  {
; 0000 01CC      tem=doze/100;
	LDS  R26,_doze
	LDS  R27,_doze+1
	LDS  R24,_doze+2
	LDS  R25,_doze+3
	__GETD1N 0x64
	RCALL __DIVD21U
	STS  _tem,R30
	STS  _tem+1,R31
; 0000 01CD     temd=day_doze/100;
	LDS  R26,_day_doze
	LDS  R27,_day_doze+1
	LDS  R24,_day_doze+2
	LDS  R25,_day_doze+3
	__GETD1N 0x64
	RCALL __DIVD21U
	STS  _temd,R30
	STS  _temd+1,R31
; 0000 01CE        clearDisplayBuffer();
	RCALL _clearDisplayBuffer
; 0000 01CF        clearDisplay();
	RCALL _clearDisplay
; 0000 01D0     if(tem>9999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);}
	LDS  R26,_tem
	LDS  R27,_tem+1
	CPI  R26,LOW(0x2710)
	LDI  R30,HIGH(0x2710)
	CPC  R27,R30
	BRSH PC+2
	RJMP _0x45E
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 01D1        else
	RJMP _0x45F
_0x45E:
; 0000 01D2        {
; 0000 01D3        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01D4        shift_in('d',0);
	LDI  R30,LOW(100)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01D5        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01D6        shift_in('o',0);
	LDI  R30,LOW(111)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01D7        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01D8        shift_in('s',0);
	LDI  R30,LOW(115)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01D9        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01DA        shift_in('e',0);
	LDI  R30,LOW(101)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01DB        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01DC        shift_in('*',0);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01DD        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01DE        shift_in('A',0);
	LDI  R30,LOW(65)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01DF        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01E0        shift_in('L',0);
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01E1        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01E2        shift_in('L',0);
	LDI  R30,LOW(76)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01E3        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01E4        shift_in('_',0);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01E5        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01E6       if ((tem/1000)>0)
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x460
; 0000 01E7       {
; 0000 01E8        shift_in((tem/1000),0);
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01E9        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01EA       }
; 0000 01EB       if (((tem%1000)/100)>0)
_0x460:
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x461
; 0000 01EC       {
; 0000 01ED        shift_in(((tem%1000)/100),0);
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01EE        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01EF       }
; 0000 01F0        shift_in(((tem%100)/10),1);
_0x461:
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01F1        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01F2        shift_in((tem%10),0);
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01F3        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01F4        shift_in('*',0);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01F5        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01F6        shift_in('D',0);
	LDI  R30,LOW(68)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01F7        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01F8        shift_in('A',0);
	LDI  R30,LOW(65)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01F9        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01FA        shift_in('Y',0);
	LDI  R30,LOW(89)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01FB        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01FC        shift_in('_',0);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 01FD        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01FE       if ((temd/1000)>0)
	LDS  R26,_temd
	LDS  R27,_temd+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x462
; 0000 01FF       {
; 0000 0200        shift_in((temd/1000),0);
	LDS  R26,_temd
	LDS  R27,_temd+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0201        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0202       }
; 0000 0203       if (((temd%1000)/100)>0)
_0x462:
	LDS  R26,_temd
	LDS  R27,_temd+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x463
; 0000 0204       {
; 0000 0205        shift_in(((temd%1000)/100),0);
	LDS  R26,_temd
	LDS  R27,_temd+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0206        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0207       }
; 0000 0208        shift_in(((temd%100)/10),1);
_0x463:
	LDS  R26,_temd
	LDS  R27,_temd+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0209        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 020A        shift_in((temd%10),0);
	LDS  R26,_temd
	LDS  R27,_temd+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 020B        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 020C        shift_in('*',0);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 020D        delay_ms(600);
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 020E        #asm("wdr")
	wdr
; 0000 020F        }
_0x45F:
; 0000 0210  }
; 0000 0211 else if(hours_mode)
	RJMP _0x464
_0x45D:
	SBRS R3,2
	RJMP _0x465
; 0000 0212  {
; 0000 0213        clearDisplayBuffer();
	RCALL _clearDisplayBuffer
; 0000 0214        clearDisplay();
	RCALL _clearDisplay
; 0000 0215     if(sutki>999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);}
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRSH PC+2
	RJMP _0x466
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 0216        else
	RJMP _0x467
_0x466:
; 0000 0217        {
; 0000 0218        shift_in('*',0);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0219        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 021A        shift_in('d',0);
	LDI  R30,LOW(100)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 021B        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 021C        shift_in('a',0);
	LDI  R30,LOW(97)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 021D        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 021E        shift_in('y',0);
	LDI  R30,LOW(121)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 021F        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0220        shift_in('_',0);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0221        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0222       if (((sutki%1000)/100)>0)
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x468
; 0000 0223       {
; 0000 0224        shift_in((sutki%1000)/100,0);
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0225        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0226       }
; 0000 0227       if (((sutki%100)/10)>0)
_0x468:
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x469
; 0000 0228       {
; 0000 0229        shift_in((sutki%100)/10,0);
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 022A        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 022B       }
; 0000 022C        shift_in((sutki%10),0);
_0x469:
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 022D        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 022E        shift_in('*',0);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 022F        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0230        shift_in('*',0);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0231        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0232        shift_in('h',0);
	LDI  R30,LOW(104)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0233        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0234        shift_in('o',0);
	LDI  R30,LOW(111)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0235        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0236        shift_in('u',0);
	LDI  R30,LOW(117)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0237        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0238        shift_in('r',0);
	LDI  R30,LOW(114)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0239        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 023A        shift_in('_',0);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 023B        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 023C        shift_in(((hours%100)/10),0);
	LDS  R26,_hours
	LDI  R30,LOW(100)
	RCALL __MODB21U
	MOV  R26,R30
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 023D        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 023E        shift_in((hours%10),0);
	LDS  R26,_hours
	LDI  R30,LOW(10)
	RCALL __MODB21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 023F        delay_ms(240);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0240        shift_in('*',0);
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _shift_in
; 0000 0241        delay_ms(600);
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0242         #asm("wdr")
	wdr
; 0000 0243        }
_0x467:
; 0000 0244  }
; 0000 0245 else if(volts_mode)
	RJMP _0x46A
_0x465:
	SBRS R3,1
	RJMP _0x46B
; 0000 0246  {
; 0000 0247     if(VoltLevel>999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);}
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRSH PC+2
	RJMP _0x46C
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 0248        else
	RJMP _0x46D
_0x46C:
; 0000 0249        {
; 0000 024A             set_char_at('u', 0,0);   //  'u'
	LDI  R30,LOW(117)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 024B             set_char_at(((VoltLevel%1000)/100), 1,1);
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 024C             set_char_at(((VoltLevel%100)/10), 2,0);
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 024D             set_char_at((VoltLevel%10), 3,0);
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 024E         #asm("wdr")
	wdr
; 0000 024F        }
_0x46D:
; 0000 0250  }
; 0000 0251 else if(fon_mode)
	RJMP _0x46E
_0x46B:
	SBRS R3,3
	RJMP _0x46F
; 0000 0252   {
; 0000 0253 if ((second_tick % 2)||(counted))  //      -  
	LDS  R30,_second_tick
	ANDI R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x471
	SBRC R2,0
	RJMP _0x471
	RJMP _0x470
_0x471:
; 0000 0254              {
; 0000 0255    tem=rad_fon;
	__PUTWMRN _tem,0,8,9
; 0000 0256        if(tem>9999)
	LDS  R26,_tem
	LDS  R27,_tem+1
	CPI  R26,LOW(0x2710)
	LDI  R30,HIGH(0x2710)
	CPC  R27,R30
	BRSH PC+2
	RJMP _0x473
; 0000 0257        {
; 0000 0258        set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);//    "- - - -"
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	LDI  R30,LOW(45)
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 0259        }
; 0000 025A        else
	RJMP _0x474
_0x473:
; 0000 025B        {
; 0000 025C             if ((tem/1000)>0) set_char_at((tem/1000), 0,0); else set_char_at('*', 0,0); // 
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x475
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	RJMP _0x476
_0x475:
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 025D             if (((tem%1000)/100)>0) set_char_at(((tem%1000)/100), 1,0); else set_char_at('*', 1,0);
_0x476:
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x477
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	RJMP _0x478
_0x477:
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 025E             if (((tem%100)/10)>0) set_char_at(((tem%100)/10), 2,0); else set_char_at('*', 2,0);
_0x478:
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL __CPW02
	BRLO PC+2
	RJMP _0x479
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
	RJMP _0x47A
_0x479:
	LDI  R30,LOW(42)
	ST   -Y,R30
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 025F             set_char_at((tem%10), 3,0);
_0x47A:
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 0260             #asm("wdr")
	wdr
; 0000 0261        }
_0x474:
; 0000 0262              } else { display=0; clearDisplayBuffer(); clearDisplay();}
	RJMP _0x47B
_0x470:
	LDI  R30,LOW(0)
	STS  _display,R30
	STS  _display+1,R30
	RCALL _clearDisplayBuffer
	RCALL _clearDisplay
_0x47B:
; 0000 0263    }
; 0000 0264 else
	RJMP _0x47C
_0x46F:
; 0000 0265    {
; 0000 0266    display=0; clearDisplayBuffer(); clearDisplay();
	LDI  R30,LOW(0)
	STS  _display,R30
	STS  _display+1,R30
	RCALL _clearDisplayBuffer
	RCALL _clearDisplay
; 0000 0267    if (blink)
	SBRS R2,1
	RJMP _0x47D
; 0000 0268    {
; 0000 0269 if ((beep_on_pulse)||(blink_led_on_pulse)) //     
	LDS  R30,_beep_on_pulse
	LDS  R31,_beep_on_pulse+1
	SBIW R30,0
	BREQ PC+2
	RJMP _0x47F
	SBRC R2,2
	RJMP _0x47F
	RJMP _0x47E
_0x47F:
; 0000 026A         {
; 0000 026B         if (blink_led_on_pulse) { digit_2=0;seg_dp=0; }
	SBRS R2,2
	RJMP _0x481
	CBI  0x15,2
	CBI  0x18,5
; 0000 026C         if (beep_on_pulse) beep = 1;
_0x481:
	LDS  R30,_beep_on_pulse
	LDS  R31,_beep_on_pulse+1
	SBIW R30,0
	BRNE PC+2
	RJMP _0x486
	SBI  0x15,4
; 0000 026D         delay_ms(20);
_0x486:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 026E         if (beep_on_pulse) beep = 0;
	LDS  R30,_beep_on_pulse
	LDS  R31,_beep_on_pulse+1
	SBIW R30,0
	BRNE PC+2
	RJMP _0x489
	CBI  0x15,4
; 0000 026F         if (blink_led_on_pulse) { digit_2=1;seg_dp=1; }
_0x489:
	SBRS R2,2
	RJMP _0x48C
	SBI  0x15,2
	SBI  0x18,5
; 0000 0270         }
_0x48C:
; 0000 0271     blink=0;
_0x47E:
	CLT
	BLD  R2,1
; 0000 0272     }
; 0000 0273    }
_0x47D:
_0x47C:
_0x46E:
_0x46A:
_0x464:
; 0000 0274   } else display=0;
	RJMP _0x491
_0x45C:
	LDI  R30,LOW(0)
	STS  _display,R30
	STS  _display+1,R30
; 0000 0275 
; 0000 0276 //       -    .  .
; 0000 0277 if (counted) alarm_check();
_0x491:
	SBRS R2,0
	RJMP _0x492
	RCALL _alarm_check
; 0000 0278 
; 0000 0279 #asm("wdr");
_0x492:
	wdr
; 0000 027A     pump();
	RCALL _pump
; 0000 027B #asm("wdr");
	wdr
; 0000 027C 
; 0000 027D if ((!display)&(!alarm))
	LDS  R30,_display
	LDS  R31,_display+1
	RCALL __LNEGW1
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,6
	LDI  R30,1
	AND  R30,R26
	BRNE PC+2
	RJMP _0x493
; 0000 027E         {
; 0000 027F         clearDisplay();
	RCALL _clearDisplay
; 0000 0280         clearDisplayBuffer();
	RCALL _clearDisplayBuffer
; 0000 0281         #asm("wdr");
	wdr
; 0000 0282         #asm("sleep");
	sleep
; 0000 0283         }
; 0000 0284 
; 0000 0285 
; 0000 0286  }
_0x493:
	RJMP _0x459
_0x45B:
; 0000 0287 }
	ADIW R28,4
_0x494:
	RJMP _0x494
;
;//-------------------------------------------
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.DSEG

	.CSEG

	.DSEG
_rad_massive:
	.BYTE 0x1B0
_fulldoze:
	.BYTE 0x4
_sutki:
	.BYTE 0x2
_hours:
	.BYTE 0x1
_minutes:
	.BYTE 0x1
_doze:
	.BYTE 0x4
_day_doze:
	.BYTE 0x4
_impulse_pump:
	.BYTE 0x2
_delay_pump:
	.BYTE 0x2
_s:
	.BYTE 0x2
_x:
	.BYTE 0x2
_iv:
	.BYTE 0x2
_ivc:
	.BYTE 0x2
_peak:
	.BYTE 0x2
_rcnt:
	.BYTE 0x2

	.ESEG

	.ORG 0x10
_wdt_error:
	.BYTE 0x2

	.ORG 0x0

	.DSEG
_tem:
	.BYTE 0x2
_display:
	.BYTE 0x2
_temd:
	.BYTE 0x2
_second:
	.BYTE 0x1
_second_tick:
	.BYTE 0x1
_minute_tick:
	.BYTE 0x1
_hour_tick:
	.BYTE 0x1
_beep_on_pulse:
	.BYTE 0x2
_key_press:
	.BYTE 0x2
_key_press_x:
	.BYTE 0x2
_VoltLevel:
	.BYTE 0x2
_alarm_cnt:
	.BYTE 0x1
_display_time:
	.BYTE 0x1
_error_count:
	.BYTE 0x1
_data:
	.BYTE 0x4
_dot:
	.BYTE 0x8
_multiplex_counter:
	.BYTE 0x2

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

	.equ __w1_port=0x12
	.equ __w1_bit=0x02

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__GEB12U:
	CP   R26,R30
	LDI  R30,1
	BRSH __GEB12U1
	CLR  R30
__GEB12U1:
	RET

__GTW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLO __GTW12UT
	CLR  R30
__GTW12UT:
	RET

__LNEGW1:
	OR   R30,R31
	LDI  R30,1
	BREQ __LNEGW1F
	LDI  R30,0
__LNEGW1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__CLRD1S0:
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
