
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : No
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: No
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rad_interval_def=R6
	.DEF _rad_interval=R8
	.DEF _rad=R10
	.DEF _rad_fon=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP _timer2_comp_ovf
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _voidadc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0404
	.DW  0x0001

_0x3:
	.DB  0x1
_0x4A9:
	.DB  0x8F,0x0,0x8F,0x0,0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x04
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _beep_on_pulse
	.DW  _0x3*2

	.DW  0x08
	.DW  0x06
	.DW  _0x4A9*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;eeprom unsigned char delay_pump_def=18;     //           (330 )
;eeprom unsigned char impulse_pump_def=10;     //              (330 )
;eeprom int time_to_display=60;    //    .
;eeprom int alarm_level=60;         //    
;
;#define alarm_counter 3              //             
;                                     //       
;
;
;// [     216  ( 3 . 36 .)
;//   8   .  ,       1600 /,    
;//       ,   1600      :)
;//       Shodan : rad_interval=35; rad_massive[36]; .. 36
;
;
;
;unsigned int rad_interval_def=143;//       = <>-1     0- 
;unsigned int rad_massive[144]; //   (rad_interval+1), ..   .   
;
;
;unsigned int rad_interval=143;//       = <>-1     0- 
;
;
;unsigned int rad=0; //    
;unsigned int rad_fon=0; //  
;unsigned int rad_hour=0; //    24 
;unsigned long fulldoze=0; //    ( ,   )
;unsigned int rad_cnt=0; //  
;bit counted=0; //          
;bit blink=0; //     /
;bit blink_led_on_pulse=1; //  
;
;unsigned int fon_hour_approx=0;
;
;unsigned int sutki=0;
;unsigned char hours=0;
;
;unsigned char minutes=0;
;unsigned long doze=0;
;unsigned long day_doze=0;
;
;unsigned int impulse_pump;
;unsigned int delay_pump;
;unsigned int s, x, iv, ivc;
;unsigned int peak, rcnt;
;
;eeprom unsigned int wdt_error @0x10;
;
;
;unsigned long tem;
;unsigned int display;
;// unsigned int temd;
;bit need_pump=0;
;unsigned char second=0;
;
;unsigned char second_tick=0;
;unsigned char minute_tick=0;
;unsigned char hour_tick=0;
;unsigned char menu_select=0;
;
;
;unsigned char beep_on_pulse=1; //  

	.DSEG
;unsigned char vib_on_pulse=0;
;
;unsigned int search_imp=0;
;
;unsigned int key_press=0;
;unsigned int key_press_x=0;
;
;unsigned int VoltLevel=0;
;
;bit reset_by_wdt=0;
;
;bit alarm=0;
;unsigned char alarm_cnt=0;
;bit user_cancel_alarm=0;
;
;bit today_doze_mode=0;
;bit all_doze_mode=0;
;bit volts_mode=0;
;bit fon_mode=1;
;bit search_mode=0;
;bit clock_mode=0;
;bit menu_active=0;
;bit scroll=0;
;bit scroll_off=0, hello=1;
;bit power_on_off;
;
;bit menu_set_time_h=0;
;bit menu_set_time_m=0;
;bit menu_set_disp=0;
;bit menu_set_alarm=0;
;bit menu_set_pump=0;
;bit menu_set_imp_pump=0;
;
;
;int test_fon_counter=0;
;int test_fon=0;
;char test_fon_timer=0;
;bit test_fon_true=0;
;
;int display_time=0;
;
;char error_count=0;
;
;bit key_2_pressed=0;
;bit key2_set=0;
;bit poweroff_bit=0;
;char dr=0, mode_counter;
;
;#define beep     PORTB.0
;#define trans    PORTD.7
;#define key      PIND.3 //(int1)
;#define key_2    PIND.5 //(set)
;#define impulse  PIND.2 //(int0)
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;
;#include <display.h>

	.CSEG
_calculate_segments:
;	character -> Y+0
	LD   R30,Y
	CPI  R30,0
	BREQ _0x8
	CPI  R30,LOW(0x30)
	BRNE _0x9
_0x8:
	RJMP _0xA
_0x9:
	CPI  R30,LOW(0x4F)
	BRNE _0xB
_0xA:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	RJMP _0x493
_0xB:
	CPI  R30,LOW(0x1)
	BREQ _0x1B
	CPI  R30,LOW(0x31)
	BRNE _0x1C
_0x1B:
	RJMP _0x1D
_0x1C:
	CPI  R30,LOW(0x6C)
	BRNE _0x1E
_0x1D:
	RCALL SUBOPT_0x3
	RJMP _0x494
_0x1E:
	CPI  R30,LOW(0x2)
	BREQ _0x2E
	CPI  R30,LOW(0x32)
	BRNE _0x2F
_0x2E:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RJMP _0x6
_0x2F:
	CPI  R30,LOW(0x3)
	BREQ _0x3F
	CPI  R30,LOW(0x33)
	BRNE _0x40
_0x3F:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	CBI  0x15,4
	CBI  0x18,4
	SBI  0x15,2
	RJMP _0x6
_0x40:
	CPI  R30,LOW(0x4)
	BREQ _0x50
	CPI  R30,LOW(0x34)
	BRNE _0x51
_0x50:
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x6
	RJMP _0x6
_0x51:
	CPI  R30,LOW(0x5)
	BREQ _0x61
	CPI  R30,LOW(0x35)
	BRNE _0x62
_0x61:
	RJMP _0x63
_0x62:
	CPI  R30,LOW(0x53)
	BRNE _0x64
_0x63:
	RJMP _0x65
_0x64:
	CPI  R30,LOW(0x73)
	BRNE _0x66
_0x65:
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RJMP _0x6
_0x66:
	CPI  R30,LOW(0x6)
	BREQ _0x76
	CPI  R30,LOW(0x36)
	BRNE _0x77
_0x76:
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x2
	SBI  0x15,2
	RJMP _0x6
_0x77:
	CPI  R30,LOW(0x7)
	BREQ _0x87
	CPI  R30,LOW(0x37)
	BRNE _0x88
_0x87:
	RCALL SUBOPT_0x0
	SBI  0x15,3
	RJMP _0x494
_0x88:
	CPI  R30,LOW(0x8)
	BREQ _0x98
	CPI  R30,LOW(0x38)
	BRNE _0x99
_0x98:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	SBI  0x15,2
	RJMP _0x6
_0x99:
	CPI  R30,LOW(0x9)
	BREQ _0xA9
	CPI  R30,LOW(0x39)
	BRNE _0xAA
_0xA9:
	RJMP _0xAB
_0xAA:
	CPI  R30,LOW(0x67)
	BRNE _0xAC
_0xAB:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x8
	RJMP _0x6
_0xAC:
	CPI  R30,LOW(0xA)
	BREQ _0xBC
	CPI  R30,LOW(0x41)
	BRNE _0xBD
_0xBC:
	RJMP _0xBE
_0xBD:
	CPI  R30,LOW(0x61)
	BRNE _0xBF
_0xBE:
	RCALL SUBOPT_0x0
	SBI  0x15,3
	RCALL SUBOPT_0x9
	SBI  0x15,2
	RJMP _0x6
_0xBF:
	CPI  R30,LOW(0xB)
	BREQ _0xCF
	CPI  R30,LOW(0x42)
	BRNE _0xD0
_0xCF:
	RJMP _0xD1
_0xD0:
	CPI  R30,LOW(0x62)
	BRNE _0xD2
_0xD1:
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	SBI  0x15,2
	RJMP _0x6
_0xD2:
	CPI  R30,LOW(0xC)
	BREQ _0xE2
	CPI  R30,LOW(0x43)
	BRNE _0xE3
_0xE2:
	SBI  0x18,5
	CBI  0x18,1
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x2
	RJMP _0x493
_0xE3:
	CPI  R30,LOW(0x63)
	BRNE _0xF2
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RJMP _0x6
_0xF2:
	CPI  R30,LOW(0xD)
	BREQ _0x102
	CPI  R30,LOW(0x44)
	BRNE _0x103
_0x102:
	RJMP _0x104
_0x103:
	CPI  R30,LOW(0x64)
	BRNE _0x105
_0x104:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x5
	RJMP _0x6
_0x105:
	CPI  R30,LOW(0xE)
	BREQ _0x115
	CPI  R30,LOW(0x45)
	BRNE _0x116
_0x115:
	SBI  0x18,5
	CBI  0x18,1
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x2
	SBI  0x15,2
	RJMP _0x6
_0x116:
	CPI  R30,LOW(0x65)
	BRNE _0x125
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x2
	SBI  0x15,2
	RJMP _0x6
_0x125:
	CPI  R30,LOW(0xF)
	BREQ _0x135
	CPI  R30,LOW(0x46)
	BRNE _0x136
_0x135:
	RJMP _0x137
_0x136:
	CPI  R30,LOW(0x66)
	BRNE _0x138
_0x137:
	SBI  0x18,5
	CBI  0x18,1
	CBI  0x15,3
	RCALL SUBOPT_0x9
	SBI  0x15,2
	RJMP _0x6
_0x138:
	CPI  R30,LOW(0x47)
	BRNE _0x147
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x2
	RJMP _0x493
_0x147:
	CPI  R30,LOW(0x48)
	BRNE _0x156
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x9
	SBI  0x15,2
	RJMP _0x6
_0x156:
	CPI  R30,LOW(0x68)
	BRNE _0x165
	RCALL SUBOPT_0xA
	SBI  0x15,3
	RCALL SUBOPT_0x9
	SBI  0x15,2
	RJMP _0x6
_0x165:
	CPI  R30,LOW(0x49)
	BREQ _0x175
	CPI  R30,LOW(0x69)
	BRNE _0x176
_0x175:
	RCALL SUBOPT_0x3
	RJMP _0x494
_0x176:
	CPI  R30,LOW(0x4A)
	BREQ _0x186
	CPI  R30,LOW(0x6A)
	BRNE _0x187
_0x186:
	RCALL SUBOPT_0xB
	SBI  0x15,4
	RJMP _0x495
_0x187:
	CPI  R30,LOW(0x4C)
	BRNE _0x196
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x2
	RJMP _0x493
_0x196:
	CPI  R30,LOW(0x4D)
	BREQ _0x1A6
	CPI  R30,LOW(0x6D)
	BRNE _0x1A7
_0x1A6:
	SBI  0x18,5
	CBI  0x18,1
	SBI  0x15,3
	CBI  0x15,5
	RCALL SUBOPT_0x5
	RJMP _0x6
_0x1A7:
	CPI  R30,LOW(0x4E)
	BREQ _0x1B7
	CPI  R30,LOW(0x6E)
	BRNE _0x1B8
_0x1B7:
	RCALL SUBOPT_0xA
	SBI  0x15,3
	CBI  0x15,5
	RCALL SUBOPT_0x5
	RJMP _0x6
_0x1B8:
	CPI  R30,LOW(0x6F)
	BRNE _0x1C7
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x5
	RJMP _0x6
_0x1C7:
	CPI  R30,LOW(0x50)
	BREQ _0x1D7
	CPI  R30,LOW(0x70)
	BRNE _0x1D8
_0x1D7:
	RCALL SUBOPT_0x0
	CBI  0x15,3
	RCALL SUBOPT_0x9
	SBI  0x15,2
	RJMP _0x6
_0x1D8:
	CPI  R30,LOW(0x51)
	BREQ _0x1E8
	CPI  R30,LOW(0x71)
	BRNE _0x1E9
_0x1E8:
	RCALL SUBOPT_0x0
	SBI  0x15,3
	RCALL SUBOPT_0x6
	RJMP _0x6
_0x1E9:
	CPI  R30,LOW(0x52)
	BREQ _0x1F9
	CPI  R30,LOW(0x72)
	BRNE _0x1FA
_0x1F9:
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x5
	RJMP _0x6
_0x1FA:
	CPI  R30,LOW(0x54)
	BREQ _0x20A
	CPI  R30,LOW(0x74)
	BRNE _0x20B
_0x20A:
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x2
	SBI  0x15,2
	RJMP _0x6
_0x20B:
	CPI  R30,LOW(0x55)
	BRNE _0x21A
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x2
	RJMP _0x493
_0x21A:
	CPI  R30,LOW(0x75)
	BRNE _0x229
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1
	SBI  0x15,4
	RJMP _0x495
_0x229:
	CPI  R30,LOW(0x56)
	BREQ _0x239
	CPI  R30,LOW(0x76)
	BRNE _0x23A
_0x239:
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x1
	SBI  0x15,4
	RJMP _0x495
_0x23A:
	CPI  R30,LOW(0x57)
	BREQ _0x24A
	CPI  R30,LOW(0x77)
	BRNE _0x24B
_0x24A:
	RCALL SUBOPT_0x7
	SBI  0x15,4
	RJMP _0x495
_0x24B:
	CPI  R30,LOW(0x59)
	BREQ _0x25B
	CPI  R30,LOW(0x79)
	BRNE _0x25C
_0x25B:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x8
	RJMP _0x6
_0x25C:
	CPI  R30,LOW(0x2D)
	BRNE _0x26B
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xC
	CBI  0x15,4
	CBI  0x18,4
	SBI  0x15,2
	RJMP _0x6
_0x26B:
	CPI  R30,LOW(0x22)
	BRNE _0x27A
	CBI  0x18,5
	SBI  0x18,1
	RCALL SUBOPT_0xC
	CBI  0x15,4
	SBI  0x18,4
	RJMP _0x493
_0x27A:
	CPI  R30,LOW(0x27)
	BRNE _0x289
	CBI  0x18,5
	SBI  0x18,1
	RJMP _0x496
_0x289:
	CPI  R30,LOW(0x5F)
	BRNE _0x298
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x4
	RJMP _0x497
_0x298:
	CPI  R30,LOW(0x2A)
	BRNE _0x2B6
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xC
	CBI  0x15,4
	CBI  0x18,4
	CBI  0x15,2
_0x2B6:
	RCALL SUBOPT_0xA
_0x496:
	CBI  0x15,3
_0x494:
	CBI  0x15,5
_0x497:
	CBI  0x15,4
_0x495:
	CBI  0x18,4
_0x493:
	CBI  0x15,2
_0x6:
	ADIW R28,1
	RET
_clearDisplay:
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xC
	CBI  0x15,4
	CBI  0x18,4
	CBI  0x15,2
	CBI  0x12,0
	SBI  0x15,0
	SBI  0x18,3
	SBI  0x18,2
	SBI  0x15,1
	RET
_clearDisplayBuffer:
	LDI  R30,LOW(42)
	STS  _data,R30
	__PUTB1MN _data,1
	__PUTB1MN _data,2
	__PUTB1MN _data,3
	LDI  R30,LOW(0)
	STS  _dot,R30
	STS  _dot+1,R30
	__POINTW1MN _dot,2
	RCALL SUBOPT_0xD
	__POINTW1MN _dot,4
	RCALL SUBOPT_0xD
	__POINTW1MN _dot,6
	RCALL SUBOPT_0xD
	RET
_show:
;	pos -> Y+2
;	digit -> Y+0
	RCALL _clearDisplay
	RCALL SUBOPT_0xE
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	LD   R30,Z
	ST   -Y,R30
	RCALL _calculate_segments
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
	SBIW R30,0
	BREQ _0x2DD
	SBI  0x12,0
	RJMP _0x2E0
_0x2DD:
	CBI  0x12,0
_0x2E0:
	LD   R30,Y
	LDD  R31,Y+1
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2E6
	CBI  0x15,0
	RJMP _0x2E5
_0x2E6:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2E9
	CBI  0x18,3
	RJMP _0x2E5
_0x2E9:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x2EC
	CBI  0x18,2
	RJMP _0x2E5
_0x2EC:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x2E5
	CBI  0x15,1
_0x2E5:
	RJMP _0x2060003
_set_char_at:
;	c -> Y+4
;	offset -> Y+2
;	dotflag -> Y+0
	RCALL SUBOPT_0xE
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	LDD  R26,Y+4
	STD  Z+0,R26
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x11
	LD   R26,Y
	LDD  R27,Y+1
	STD  Z+0,R26
	STD  Z+1,R27
	ADIW R28,5
	RET
_shift_in:
;	c -> Y+2
;	dotflag -> Y+0
	__GETB1MN _data,1
	STS  _data,R30
	__GETB1MN _data,2
	__PUTB1MN _data,1
	__GETB1MN _data,3
	__PUTB1MN _data,2
	LDD  R30,Y+2
	__PUTB1MN _data,3
	__GETW1MN _dot,2
	STS  _dot,R30
	STS  _dot+1,R31
	__GETW1MN _dot,4
	__PUTW1MN _dot,2
	__GETW1MN _dot,6
	__PUTW1MN _dot,4
	LD   R30,Y
	LDD  R31,Y+1
	__PUTW1MN _dot,6
	ADIW R28,3
	RET
_multiplex:
	LDI  R26,LOW(_multiplex_counter)
	LDI  R27,HIGH(_multiplex_counter)
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	SBIW R26,1
	BRNE _0x2F2
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	RCALL _show
	RJMP _0x2F3
_0x2F2:
	RCALL SUBOPT_0x13
	SBIW R26,2
	BRNE _0x2F4
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	RCALL _show
	RJMP _0x2F5
_0x2F4:
	RCALL SUBOPT_0x13
	SBIW R26,3
	BRNE _0x2F6
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RCALL _show
	RJMP _0x2F7
_0x2F6:
	RCALL SUBOPT_0x13
	SBIW R26,4
	BRNE _0x2F8
	RCALL SUBOPT_0x18
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0x15
	RCALL _show
	RJMP _0x2F9
_0x2F8:
	RCALL SUBOPT_0x13
	SBIW R26,5
	BRNE _0x2FA
	RCALL _clearDisplay
_0x2FA:
_0x2F9:
_0x2F7:
_0x2F5:
_0x2F3:
	RCALL SUBOPT_0x13
	SBIW R26,6
	BRLT _0x2FB
	LDI  R30,LOW(0)
	STS  _multiplex_counter,R30
	STS  _multiplex_counter+1,R30
_0x2FB:
	RET
_timer0_ovf_isr:
	RCALL SUBOPT_0x19
	LDI  R30,LOW(255)
	OUT  0x32,R30
	RCALL SUBOPT_0x1A
	SBIW R30,0
	BREQ _0x2FC
	RCALL _multiplex
_0x2FC:
	RJMP _0x4A8
;#include <microdozik.h>
_pump:
	RCALL __SAVELOCR2
;	i -> R16,R17
	SBRS R2,3
	RJMP _0x2FD
	LDI  R30,LOW(0)
	OUT  0x3B,R30
	__GETWRN 16,17,0
_0x2FF:
	LDS  R30,_delay_pump
	LDS  R31,_delay_pump+1
	CP   R16,R30
	CPC  R17,R31
	BRSH _0x300
	SBI  0x12,7
	__DELAY_USB 5
	CBI  0x12,7
	__DELAY_USB 35
	wdr
	__ADDWRN 16,17,1
	RJMP _0x2FF
_0x300:
	__DELAY_USB 13
	CLT
	BLD  R2,3
	LDI  R30,LOW(192)
	OUT  0x3B,R30
_0x2FD:
	RJMP _0x2060001
_alarm_check:
	RCALL SUBOPT_0x1B
	MOVW R26,R12
	RCALL __GTW12U
	RCALL SUBOPT_0x1C
	BREQ _0x305
	RCALL SUBOPT_0x1D
	LDS  R30,_second
	ANDI R30,LOW(0x1)
	BREQ _0x308
	SBI  0x12,4
	RJMP _0x30B
_0x308:
	CBI  0x12,4
_0x30B:
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1F
	CLT
	BLD  R3,2
	BLD  R3,5
	RCALL SUBOPT_0x20
_0x305:
	RCALL SUBOPT_0x1B
	CP   R12,R30
	CPC  R13,R31
	BRLO _0x30F
	SBRS R2,6
	RJMP _0x30E
_0x30F:
	CBI  0x18,0
	CLT
	BLD  R2,5
	CBI  0x12,4
_0x30E:
	RET
_check_battery:
	RCALL __SAVELOCR4
;	pump_v -> R16,R17
;	pump_mf -> R18,R19
	__GETWRN 16,17,10
	RCALL _read_adc
	RCALL SUBOPT_0x21
	CPI  R26,LOW(0x19A)
	LDI  R30,HIGH(0x19A)
	CPC  R27,R30
	BRSH _0x315
	RCALL SUBOPT_0x21
	LDI  R30,LOW(410)
	LDI  R31,HIGH(410)
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x22
	MOVW R26,R30
	MOVW R30,R16
	RCALL __MULW12U
	MOVW R18,R30
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x24
	RJMP _0x498
_0x315:
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
_0x498:
	STS  _delay_pump,R30
	STS  _delay_pump+1,R31
	RCALL SUBOPT_0x21
	CPI  R26,LOW(0x12C)
	LDI  R30,HIGH(0x12C)
	CPC  R27,R30
	BRSH _0x317
	RCALL SUBOPT_0x27
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	RCALL SUBOPT_0x15
	RCALL _delay_ms
	RCALL SUBOPT_0x27
	LDI  R30,LOW(70)
	LDI  R31,HIGH(70)
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x27
	wdr
_0x317:
	RJMP _0x2060002
_check_sbm20:
	MOV  R0,R12
	OR   R0,R13
	BRNE _0x324
	LDS  R30,_error_count
	SUBI R30,-LOW(1)
	RJMP _0x499
_0x324:
	LDI  R30,LOW(0)
_0x499:
	STS  _error_count,R30
	LDS  R26,_error_count
	CPI  R26,LOW(0x4)
	BRLO _0x326
	SET
	BLD  R2,3
	RCALL _pump
_0x326:
	LDS  R26,_error_count
	CPI  R26,LOW(0x6)
	BRLO _0x327
	RCALL SUBOPT_0x29
	wdr
	RCALL SUBOPT_0x2A
	wdr
	RCALL SUBOPT_0x29
	wdr
	RCALL SUBOPT_0x2A
	wdr
	RCALL SUBOPT_0x29
	wdr
	CBI  0x18,0
_0x327:
	RET
_read_adc:
	RCALL __SAVELOCR4
;	tmpv -> R16,R17
;	ixi -> R19
;	MCUCR_def -> R18
	__GETWRN 16,17,0
	LDI  R19,64
	sei
	IN   R30,0x6
	ORI  R30,LOW(0x8E)
	OUT  0x6,R30
	IN   R30,0x7
	ORI  R30,LOW(0x6E)
	OUT  0x7,R30
	IN   R18,53
	LDI  R30,LOW(144)
	OUT  0x35,R30
	__DELAY_USW 250
	LDI  R30,LOW(0)
	OUT  0x39,R30
_0x334:
	CPI  R19,1
	BRLO _0x336
	sleep
	wdr
	LDS  R30,_VoltLevel
	LDS  R31,_VoltLevel+1
	__ADDWRR 16,17,30,31
	SUBI R19,1
	RJMP _0x334
_0x336:
	LDI  R30,LOW(65)
	OUT  0x39,R30
	OUT  0x35,R18
	LDI  R30,LOW(0)
	OUT  0x6,R30
	OUT  0x8,R30
	OUT  0x7,R30
	MOVW R26,R16
	LDI  R30,LOW(6)
	RCALL __LSRW12
	RCALL SUBOPT_0x2B
_0x2060002:
	RCALL __LOADLOCR4
_0x2060003:
	ADIW R28,4
	RET
;
;
;//  ********************************************************************
;void check_battery();
;void off();
;void init_pump();
;//--------------------------------- --------------------------//
;interrupt [ADC_INT] void voidadc_isr(void)
; 0000 0083 {
_voidadc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0084 	VoltLevel=(120*255)/(ADCH-1); // 1.16  ( 8   1.01  1.2      ADC_VALUE = V_BG * 255/Vcc)
	IN   R30,0x5
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x26
	LDI  R26,LOW(30600)
	LDI  R27,HIGH(30600)
	RCALL __DIVW21
	RCALL SUBOPT_0x2B
; 0000 0085 //    VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
; 0000 0086     //VoltLevel=1023;
; 0000 0087 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;//  ********************************************************************
;
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 008C {
_ext_int0_isr:
	ST   -Y,R24
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 008D #pragma optsize-
; 0000 008E unsigned char i;
; 0000 008F 
; 0000 0090 test_fon_counter++;
	ST   -Y,R17
;	i -> R17
	LDI  R26,LOW(_test_fon_counter)
	LDI  R27,HIGH(_test_fon_counter)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0091 rad_massive[rad_cnt]++;
	LDS  R30,_rad_cnt
	LDS  R31,_rad_cnt+1
	LDI  R26,LOW(_rad_massive)
	LDI  R27,HIGH(_rad_massive)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0092 blink=1;
	SET
	BLD  R2,1
; 0000 0093     // 
; 0000 0094     for(i=0;i<impulse_pump;i++)
	LDI  R17,LOW(0)
_0x338:
	LDS  R30,_impulse_pump
	LDS  R31,_impulse_pump+1
	MOV  R26,R17
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x339
; 0000 0095     {
; 0000 0096         trans=1;
	SBI  0x12,7
; 0000 0097         delay_us(2);
	__DELAY_USB 5
; 0000 0098         trans=0;
	CBI  0x12,7
; 0000 0099         delay_us(13);
	__DELAY_USB 35
; 0000 009A         #asm("wdr")
	wdr
; 0000 009B     }
	SUBI R17,-1
	RJMP _0x338
_0x339:
; 0000 009C      delay_us(5);
	__DELAY_USB 13
; 0000 009D #ifdef _OPTIMIZE_SIZE_
; 0000 009E #pragma optsize+
; 0000 009F #endif
; 0000 00A0 }
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R24,Y+
	RETI
;
;
;//  ********************************************************************
;
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 00A6 {
_ext_int1_isr:
	RCALL SUBOPT_0x19
; 0000 00A7 #pragma optsize-
; 0000 00A8 int i;
; 0000 00A9 key2_set=0;
	RCALL __SAVELOCR2
;	i -> R16,R17
	CLT
	BLD  R5,2
; 0000 00AA 
; 0000 00AB     if(alarm&(!user_cancel_alarm))
	LDI  R26,0
	SBRC R2,5
	LDI  R26,1
	LDI  R30,0
	SBRS R2,6
	LDI  R30,1
	AND  R30,R26
	BREQ _0x33E
; 0000 00AC     {
; 0000 00AD         user_cancel_alarm=1;
	SET
	BLD  R2,6
; 0000 00AE         beep=0;
	CBI  0x18,0
; 0000 00AF         key_press=0;
	LDI  R30,LOW(0)
	STS  _key_press,R30
	STS  _key_press+1,R30
; 0000 00B0         display_time=0;
	STS  _display_time,R30
	STS  _display_time+1,R30
; 0000 00B1             beep=0;
	CBI  0x18,0
; 0000 00B2             vibra=0;
	CBI  0x12,4
; 0000 00B3             mode_counter=4;
	LDI  R30,LOW(4)
	STS  _mode_counter,R30
; 0000 00B4             return;
	RCALL __LOADLOCR2P
	RJMP _0x4A8
; 0000 00B5     }
; 0000 00B6     // MCUCR &= ~(1<<SE);
; 0000 00B7 if (!power_on_off)
_0x33E:
	SBRC R4,1
	RJMP _0x345
; 0000 00B8 {
; 0000 00B9 
; 0000 00BA 
; 0000 00BB if(display_time < time_to_display+1)
	LDI  R26,LOW(_time_to_display)
	LDI  R27,HIGH(_time_to_display)
	RCALL __EEPROMRDW
	ADIW R30,1
	LDS  R26,_display_time
	LDS  R27,_display_time+1
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x346
; 0000 00BC   {
; 0000 00BD         if(menu_active)
	SBRS R3,5
	RJMP _0x347
; 0000 00BE         {
; 0000 00BF            menu_select++;
	LDS  R30,_menu_select
	SUBI R30,-LOW(1)
	STS  _menu_select,R30
; 0000 00C0            scroll=1;
	SET
	BLD  R3,6
; 0000 00C1         }
; 0000 00C2   }
_0x347:
; 0000 00C3 
; 0000 00C4     while(!key)  //    
_0x346:
_0x348:
	SBIC 0x10,3
	RJMP _0x34A
; 0000 00C5     {
; 0000 00C6         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00C7         // #asm("wdr")
; 0000 00C8         if(!key_2) key2_set=1; //  
	SBIC 0x10,5
	RJMP _0x34B
	SET
	BLD  R5,2
; 0000 00C9         key_press++;
_0x34B:
	LDI  R26,LOW(_key_press)
	LDI  R27,HIGH(_key_press)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 00CA 
; 0000 00CB         if((key_press%10)==0)for(i=800;i>0;i--)
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	SBIW R30,0
	BRNE _0x34C
	__GETWRN 16,17,800
_0x34E:
	CLR  R0
	CP   R0,R16
	CPC  R0,R17
	BRGE _0x34F
; 0000 00CC         {
; 0000 00CD             beep=1;
	SBI  0x18,0
; 0000 00CE             delay_us(50);
	__DELAY_USB 133
; 0000 00CF             beep=0;
	CBI  0x18,0
; 0000 00D0             delay_us(300);
	__DELAY_USW 600
; 0000 00D1         }
	__SUBWRN 16,17,1
	RJMP _0x34E
_0x34F:
; 0000 00D2 
; 0000 00D3 
; 0000 00D4         if(key_press>50) //    5- ,   
_0x34C:
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	SBIW R26,51
	BRLO _0x354
; 0000 00D5         {
; 0000 00D6         scroll_off=1;
	SET
	BLD  R3,7
; 0000 00D7         }
; 0000 00D8     }
_0x354:
	RJMP _0x348
_0x34A:
; 0000 00D9     if((key_press>=10)&(key_press<=50)&key2_set)
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __GEW12U
	MOV  R0,R30
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __LEW12U
	AND  R30,R0
	MOV  R26,R30
	LDI  R30,0
	SBRC R5,2
	LDI  R30,1
	AND  R30,R26
	BREQ _0x355
; 0000 00DA     {
; 0000 00DB         if(menu_active==0)
	SBRC R3,5
	RJMP _0x356
; 0000 00DC             {
; 0000 00DD                 menu_active=1; scroll=1;
	SET
	BLD  R3,5
	BLD  R3,6
; 0000 00DE             }
; 0000 00DF     }
_0x356:
; 0000 00E0     else
	RJMP _0x357
_0x355:
; 0000 00E1     {
; 0000 00E2         if((key_press>=10)&(key_press<=50)&(!key2_set))
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __GEW12U
	MOV  R0,R30
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __LEW12U
	AND  R30,R0
	MOV  R26,R30
	LDI  R30,0
	SBRS R5,2
	LDI  R30,1
	AND  R30,R26
	BREQ _0x358
; 0000 00E3         {
; 0000 00E4             // 1  -
; 0000 00E5         if(search_mode) { fon_mode=1; search_mode=0; } else { fon_mode=0; search_mode=1;}
	SBRS R3,3
	RJMP _0x359
	SET
	BLD  R3,2
	CLT
	RJMP _0x49A
_0x359:
	CLT
	BLD  R3,2
	SET
_0x49A:
	BLD  R3,3
; 0000 00E6         }
; 0000 00E7     }
_0x358:
_0x357:
; 0000 00E8 if ((key_press<9)&(!search_mode)&(display_time < time_to_display+1))
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RCALL __LTW12U
	MOV  R26,R30
	LDI  R30,0
	SBRS R3,3
	LDI  R30,1
	AND  R30,R26
	MOV  R0,R30
	LDI  R26,LOW(_time_to_display)
	LDI  R27,HIGH(_time_to_display)
	RCALL __EEPROMRDW
	ADIW R30,1
	LDS  R26,_display_time
	LDS  R27,_display_time+1
	RCALL __LTW12
	AND  R30,R0
	BREQ _0x35B
; 0000 00E9 {
; 0000 00EA  if (!menu_active) { // 
	SBRC R3,5
	RJMP _0x35C
; 0000 00EB 
; 0000 00EC     //  ,   
; 0000 00ED             mode_counter++;
	LDS  R30,_mode_counter
	SUBI R30,-LOW(1)
	STS  _mode_counter,R30
; 0000 00EE if (mode_counter>4) mode_counter=0;
	LDS  R26,_mode_counter
	CPI  R26,LOW(0x5)
	BRLO _0x35D
	LDI  R30,LOW(0)
	STS  _mode_counter,R30
; 0000 00EF             search_mode=0;
_0x35D:
	CLT
	BLD  R3,3
; 0000 00F0             clock_mode=0;
	BLD  R3,4
; 0000 00F1             today_doze_mode=0;
	BLD  R2,7
; 0000 00F2             all_doze_mode=0;
	BLD  R3,0
; 0000 00F3             volts_mode=0;
	BLD  R3,1
; 0000 00F4             fon_mode=0;
	BLD  R3,2
; 0000 00F5 switch (mode_counter){
	LDS  R30,_mode_counter
; 0000 00F6   {case 0: fon_mode=1;
	CPI  R30,0
	BRNE _0x361
	SET
	BLD  R3,2
; 0000 00F7         break;}
	RJMP _0x360
; 0000 00F8   {case 1: clock_mode=1;
_0x361:
	CPI  R30,LOW(0x1)
	BRNE _0x362
	SET
	BLD  R3,4
; 0000 00F9         break;}
	RJMP _0x360
; 0000 00FA   {case 2: today_doze_mode=1; scroll=1;
_0x362:
	CPI  R30,LOW(0x2)
	BRNE _0x363
	SET
	BLD  R2,7
	BLD  R3,6
; 0000 00FB         break;}
	RJMP _0x360
; 0000 00FC   {case 3: all_doze_mode=1;  scroll=1;
_0x363:
	CPI  R30,LOW(0x3)
	BRNE _0x364
	SET
	BLD  R3,0
	BLD  R3,6
; 0000 00FD         break;}
	RJMP _0x360
; 0000 00FE   {case 4: volts_mode=1;
_0x364:
	CPI  R30,LOW(0x4)
	BRNE _0x360
	SET
	BLD  R3,1
; 0000 00FF         break;}
; 0000 0100                     }
_0x360:
; 0000 0101         }
; 0000 0102 
; 0000 0103 }
_0x35C:
; 0000 0104 }
_0x35B:
; 0000 0105 else
	RJMP _0x366
_0x345:
; 0000 0106 //poff
; 0000 0107 {
; 0000 0108 
; 0000 0109     while(!key)  //    
_0x367:
	SBIC 0x10,3
	RJMP _0x369
; 0000 010A     {
; 0000 010B         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 010C         // #asm("wdr")
; 0000 010D         if(!key_2) key2_set=1; //  
	SBIC 0x10,5
	RJMP _0x36A
	SET
	BLD  R5,2
; 0000 010E         key_press++;
_0x36A:
	LDI  R26,LOW(_key_press)
	LDI  R27,HIGH(_key_press)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 010F 
; 0000 0110         if((key_press%10)==0)for(i=800;i>0;i--)
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	SBIW R30,0
	BRNE _0x36B
	__GETWRN 16,17,800
_0x36D:
	CLR  R0
	CP   R0,R16
	CPC  R0,R17
	BRGE _0x36E
; 0000 0111         {
; 0000 0112             beep=1;
	SBI  0x18,0
; 0000 0113             delay_us(50);
	__DELAY_USB 133
; 0000 0114             beep=0;
	CBI  0x18,0
; 0000 0115             delay_us(300);
	__DELAY_USW 600
; 0000 0116         }
	__SUBWRN 16,17,1
	RJMP _0x36D
_0x36E:
; 0000 0117 
; 0000 0118 
; 0000 0119         if(key_press>50) //    5- ,   
_0x36B:
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	SBIW R26,51
	BRSH PC+2
	RJMP _0x373
; 0000 011A         {
; 0000 011B         power_on_off=0;
	CLT
	BLD  R4,1
; 0000 011C         power_on_off = 0;
	BLD  R4,1
; 0000 011D         display=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _display,R30
	STS  _display+1,R31
; 0000 011E         display_time=0;
	LDI  R30,LOW(0)
	STS  _display_time,R30
	STS  _display_time+1,R30
; 0000 011F     iv=0;
	STS  _iv,R30
	STS  _iv+1,R30
; 0000 0120     ivc=0;
	STS  _ivc,R30
	STS  _ivc+1,R30
; 0000 0121     peak=0;
	STS  _peak,R30
	STS  _peak+1,R30
; 0000 0122     rcnt=0;
	STS  _rcnt,R30
	STS  _rcnt+1,R30
; 0000 0123     rad=0;
	CLR  R10
	CLR  R11
; 0000 0124     counted=0;
	BLD  R2,0
; 0000 0125     doze=0;
	STS  _doze,R30
	STS  _doze+1,R30
	STS  _doze+2,R30
	STS  _doze+3,R30
; 0000 0126     day_doze=0;
	STS  _day_doze,R30
	STS  _day_doze+1,R30
	STS  _day_doze+2,R30
	STS  _day_doze+3,R30
; 0000 0127     fulldoze=0;
	STS  _fulldoze,R30
	STS  _fulldoze+1,R30
	STS  _fulldoze+2,R30
	STS  _fulldoze+3,R30
; 0000 0128     init_pump();
	RCALL _init_pump
; 0000 0129     hello=1;
	SET
	BLD  R4,0
; 0000 012A         #asm("wdr");
	wdr
; 0000 012B         }
; 0000 012C      }
_0x373:
	RJMP _0x367
_0x369:
; 0000 012D }
_0x366:
; 0000 012E 
; 0000 012F 
; 0000 0130     key_press=0;
	LDI  R30,LOW(0)
	STS  _key_press,R30
	STS  _key_press+1,R30
; 0000 0131     display_time=0;
	STS  _display_time,R30
	STS  _display_time+1,R30
; 0000 0132 #ifdef _OPTIMIZE_SIZE_
; 0000 0133 #pragma optsize+
; 0000 0134 #endif
; 0000 0135 
; 0000 0136 }
	RCALL __LOADLOCR2P
	RJMP _0x4A8
;
;//  ********************************************************************
;
;
;
;interrupt [TIM2_OVF] void timer2_comp_ovf(void)
; 0000 013D {
_timer2_comp_ovf:
	RCALL SUBOPT_0x19
; 0000 013E 
; 0000 013F     search_imp=rad_massive[rad_cnt];
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
	STS  _search_imp,R30
	STS  _search_imp+1,R31
; 0000 0140     //          . 
; 0000 0141     if (rad_cnt == rad_interval) {rad_massive[0]=0; rad_cnt=0; counted=1;} else { rad_massive[rad_cnt+1]=0;  rad_cnt++;}
	RCALL SUBOPT_0x2E
	CP   R8,R26
	CPC  R9,R27
	BRNE _0x374
	LDI  R30,LOW(0)
	STS  _rad_massive,R30
	STS  _rad_massive+1,R30
	RCALL SUBOPT_0x2F
	SET
	BLD  R2,0
	RJMP _0x375
_0x374:
	RCALL SUBOPT_0x2E
	LSL  R26
	ROL  R27
	__ADDW2MN _rad_massive,2
	RCALL SUBOPT_0x14
	ST   X+,R30
	ST   X,R31
	LDI  R26,LOW(_rad_cnt)
	LDI  R27,HIGH(_rad_cnt)
	RCALL SUBOPT_0x12
_0x375:
; 0000 0142     //         
; 0000 0143 
; 0000 0144 
; 0000 0145     if ((alarm_cnt >= alarm_counter)&(counted)&(!user_cancel_alarm)) {beep=1;display=1;alarm=1;search_mode=0;fon_mode=1;}
	LDS  R26,_alarm_cnt
	LDI  R30,LOW(3)
	RCALL __GEB12U
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	AND  R30,R26
	RCALL SUBOPT_0x1C
	BREQ _0x376
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x20
; 0000 0146     //     alarm_counter    - 
; 0000 0147     if ((alarm_cnt < alarm_counter)||(user_cancel_alarm)) {beep=0;alarm=0;} //  -  
_0x376:
	LDS  R26,_alarm_cnt
	CPI  R26,LOW(0x3)
	BRLO _0x37A
	SBRS R2,6
	RJMP _0x379
_0x37A:
	CBI  0x18,0
	CLT
	BLD  R2,5
; 0000 0148     alarm_cnt=0;
_0x379:
	LDI  R30,LOW(0)
	STS  _alarm_cnt,R30
; 0000 0149 
; 0000 014A if (test_fon_timer>6) //0-5=6sec
	LDS  R26,_test_fon_timer
	CPI  R26,LOW(0x7)
	BRSH PC+2
	RJMP _0x37E
; 0000 014B     {
; 0000 014C     test_fon_timer=0;
	STS  _test_fon_timer,R30
; 0000 014D     test_fon=test_fon_counter*6;
	LDS  R30,_test_fon_counter
	LDS  R31,_test_fon_counter+1
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	RCALL __MULW12
	STS  _test_fon,R30
	STS  _test_fon+1,R31
; 0000 014E     test_fon_counter=0;
	LDI  R30,LOW(0)
	STS  _test_fon_counter,R30
	STS  _test_fon_counter+1,R30
; 0000 014F     test_fon_true=1;
	SET
	BLD  R5,0
; 0000 0150 
; 0000 0151 
; 0000 0152 
; 0000 0153 //     ,      
; 0000 0154 if ((test_fon<=70)&&(test_fon_true))
	RCALL SUBOPT_0x30
	BRGE _0x380
	SBRC R5,0
	RJMP _0x381
_0x380:
	RJMP _0x37F
_0x381:
; 0000 0155    {
; 0000 0156    if (!(rad_interval==rad_interval_def))
	__CPWRR 6,7,8,9
	BREQ _0x382
; 0000 0157         {
; 0000 0158         rad_interval=rad_interval_def;
	MOVW R8,R6
; 0000 0159         counted=0;
	RCALL SUBOPT_0x31
; 0000 015A         rad_cnt=0;
; 0000 015B         #asm("wdr");
	wdr
; 0000 015C         }
; 0000 015D    }
_0x382:
; 0000 015E else if ((test_fon>70)&&(test_fon<=100)&&(test_fon_true))
	RJMP _0x383
_0x37F:
	RCALL SUBOPT_0x30
	BRLT _0x385
	RCALL SUBOPT_0x32
	BRGE _0x385
	SBRC R5,0
	RJMP _0x386
_0x385:
	RJMP _0x384
_0x386:
; 0000 015F     {
; 0000 0160    if (!(rad_interval==36))
	LDI  R30,LOW(36)
	LDI  R31,HIGH(36)
	RCALL SUBOPT_0x33
	BREQ _0x387
; 0000 0161         {
; 0000 0162         rad_interval=36;
	LDI  R30,LOW(36)
	LDI  R31,HIGH(36)
	RCALL SUBOPT_0x34
; 0000 0163         counted=0;
; 0000 0164         rad_cnt=0;
; 0000 0165         #asm("wdr");
	wdr
; 0000 0166         }
; 0000 0167     }
_0x387:
; 0000 0168 else if ((test_fon>100)&&(test_fon<=500)&&(test_fon_true))
	RJMP _0x388
_0x384:
	RCALL SUBOPT_0x32
	BRLT _0x38A
	RCALL SUBOPT_0x35
	BRGE _0x38A
	SBRC R5,0
	RJMP _0x38B
_0x38A:
	RJMP _0x389
_0x38B:
; 0000 0169     {
; 0000 016A    if (!(rad_interval==16))
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL SUBOPT_0x33
	BREQ _0x38C
; 0000 016B         {
; 0000 016C         rad_interval=16;
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL SUBOPT_0x34
; 0000 016D         counted=0;
; 0000 016E         rad_cnt=0;
; 0000 016F         }
; 0000 0170     }
_0x38C:
; 0000 0171 else if ((test_fon>500)&&(test_fon<=1000)&&(test_fon_true))
	RJMP _0x38D
_0x389:
	RCALL SUBOPT_0x35
	BRLT _0x38F
	LDS  R26,_test_fon
	LDS  R27,_test_fon+1
	CPI  R26,LOW(0x3E9)
	LDI  R30,HIGH(0x3E9)
	CPC  R27,R30
	BRGE _0x38F
	SBRC R5,0
	RJMP _0x390
_0x38F:
	RJMP _0x38E
_0x390:
; 0000 0172     {
; 0000 0173    if (!(rad_interval==8))
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x33
	BREQ _0x391
; 0000 0174         {
; 0000 0175         rad_interval=8;
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x34
; 0000 0176         counted=0;
; 0000 0177         rad_cnt=0;
; 0000 0178         #asm("wdr");
	wdr
; 0000 0179         }
; 0000 017A     }
_0x391:
; 0000 017B else
	RJMP _0x392
_0x38E:
; 0000 017C     {
; 0000 017D    if (!(rad_interval==3))
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x33
	BREQ _0x393
; 0000 017E         {
; 0000 017F         rad_interval=3;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x34
; 0000 0180         counted=0;
; 0000 0181         rad_cnt=0;
; 0000 0182         #asm("wdr");
	wdr
; 0000 0183         }
; 0000 0184     }
_0x393:
_0x392:
_0x38D:
_0x388:
_0x383:
; 0000 0185 // END
; 0000 0186 
; 0000 0187     }
; 0000 0188 test_fon_timer++;
_0x37E:
	LDS  R30,_test_fon_timer
	SUBI R30,-LOW(1)
	STS  _test_fon_timer,R30
; 0000 0189 
; 0000 018A         // fulldoze = 324; //test only!
; 0000 018B         // day_doze = 5684; //test only!
; 0000 018C         // doze = rad_hour + fulldoze; // test only!!
; 0000 018D     second_tick++;
	RCALL SUBOPT_0x36
	SUBI R30,-LOW(1)
	STS  _second_tick,R30
; 0000 018E     if(second_tick>59)
	LDS  R26,_second_tick
	CPI  R26,LOW(0x3C)
	BRLO _0x394
; 0000 018F     {
; 0000 0190         fon_hour_approx += rad_fon; //   
	MOVW R30,R12
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x11
	STS  _fon_hour_approx,R30
	STS  _fon_hour_approx+1,R31
; 0000 0191         second_tick=0;
	LDI  R30,LOW(0)
	STS  _second_tick,R30
; 0000 0192         minutes++;
	LDS  R30,_minutes
	SUBI R30,-LOW(1)
	STS  _minutes,R30
; 0000 0193         minute_tick++;
	RCALL SUBOPT_0x38
; 0000 0194         check_battery();
	RCALL _check_battery
; 0000 0195         check_sbm20();
	RCALL _check_sbm20
; 0000 0196         if (minute_tick%5==0) user_cancel_alarm=0;
	RCALL SUBOPT_0x39
	LDI  R30,LOW(5)
	RCALL __MODB21U
	CPI  R30,0
	BRNE _0x395
	CLT
	BLD  R2,6
; 0000 0197         //      .   5    .
; 0000 0198     }
_0x395:
; 0000 0199 
; 0000 019A     if(minute_tick>59)
_0x394:
	RCALL SUBOPT_0x39
	CPI  R26,LOW(0x3C)
	BRLO _0x396
; 0000 019B     {
; 0000 019C         rad_hour += fon_hour_approx/60;
	RCALL SUBOPT_0x37
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RCALL __DIVW21U
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x11
	STS  _rad_hour,R30
	STS  _rad_hour+1,R31
; 0000 019D         doze = rad_hour + fulldoze; //      +   
	LDS  R30,_fulldoze
	LDS  R31,_fulldoze+1
	LDS  R22,_fulldoze+2
	LDS  R23,_fulldoze+3
	RCALL SUBOPT_0x3A
	CLR  R24
	CLR  R25
	RCALL __ADDD12
	STS  _doze,R30
	STS  _doze+1,R31
	STS  _doze+2,R22
	STS  _doze+3,R23
; 0000 019E         fon_hour_approx = 0;
	LDI  R30,LOW(0)
	STS  _fon_hour_approx,R30
	STS  _fon_hour_approx+1,R30
; 0000 019F         minute_tick=0;
	STS  _minute_tick,R30
; 0000 01A0         minutes=0;
	STS  _minutes,R30
; 0000 01A1         hours++;
	LDS  R30,_hours
	SUBI R30,-LOW(1)
	STS  _hours,R30
; 0000 01A2         hour_tick++;
	RCALL SUBOPT_0x3B
; 0000 01A3     }
; 0000 01A4     if(hour_tick>23)
_0x396:
	RCALL SUBOPT_0x3C
	CPI  R26,LOW(0x18)
	BRLO _0x397
; 0000 01A5     {
; 0000 01A6         day_doze = rad_hour; rad_hour = 0; //     .   
	LDS  R30,_rad_hour
	LDS  R31,_rad_hour+1
	CLR  R22
	CLR  R23
	STS  _day_doze,R30
	STS  _day_doze+1,R31
	STS  _day_doze+2,R22
	STS  _day_doze+3,R23
	RCALL SUBOPT_0x3D
; 0000 01A7         fulldoze += day_doze; //        
	LDS  R30,_day_doze
	LDS  R31,_day_doze+1
	LDS  R22,_day_doze+2
	LDS  R23,_day_doze+3
	LDS  R26,_fulldoze
	LDS  R27,_fulldoze+1
	LDS  R24,_fulldoze+2
	LDS  R25,_fulldoze+3
	RCALL __ADDD12
	STS  _fulldoze,R30
	STS  _fulldoze+1,R31
	STS  _fulldoze+2,R22
	STS  _fulldoze+3,R23
; 0000 01A8         hour_tick=0;
	LDI  R30,LOW(0)
	STS  _hour_tick,R30
; 0000 01A9         sutki++;
	LDI  R26,LOW(_sutki)
	LDI  R27,HIGH(_sutki)
	RCALL SUBOPT_0x12
; 0000 01AA         hours=0;
	LDI  R30,LOW(0)
	STS  _hours,R30
; 0000 01AB     }
; 0000 01AC 
; 0000 01AD     second++;
_0x397:
	LDS  R30,_second
	SUBI R30,-LOW(1)
	STS  _second,R30
; 0000 01AE 
; 0000 01AF     need_pump=1;
	SET
	BLD  R2,3
; 0000 01B0     //delay_ms(48);
; 0000 01B1     //trans=0;
; 0000 01B2 
; 0000 01B3     // pump();
; 0000 01B4     display_time++;
	LDI  R26,LOW(_display_time)
	LDI  R27,HIGH(_display_time)
	RCALL SUBOPT_0x12
; 0000 01B5 
; 0000 01B6     if (display_time > 254) display_time =210;
	RCALL SUBOPT_0x3E
	CPI  R26,LOW(0xFF)
	LDI  R30,HIGH(0xFF)
	CPC  R27,R30
	BRLT _0x398
	LDI  R30,LOW(210)
	LDI  R31,HIGH(210)
	RCALL SUBOPT_0x3F
; 0000 01B7 
; 0000 01B8     if ((display_time > time_to_display+1)&(!search_mode))
_0x398:
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x3E
	RCALL __GTW12
	MOV  R26,R30
	RCALL SUBOPT_0x41
	BREQ _0x399
; 0000 01B9             {
; 0000 01BA             menu_active=0;
	RCALL SUBOPT_0x42
; 0000 01BB             menu_select=0;
; 0000 01BC             search_mode=0;
; 0000 01BD             clock_mode=0;
	RCALL SUBOPT_0x1F
; 0000 01BE             today_doze_mode=0;
; 0000 01BF             all_doze_mode=0;
; 0000 01C0             volts_mode=0;
; 0000 01C1             fon_mode=1;
	RCALL SUBOPT_0x20
; 0000 01C2             }
; 0000 01C3 
; 0000 01C4 }
_0x399:
_0x4A8:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// *******************************************************************
;void check_key(void)
; 0000 01C8 {
_check_key:
; 0000 01C9  //  2
; 0000 01CA char dr=0, i;
; 0000 01CB if((!key_2)) //     
	RCALL __SAVELOCR2
;	dr -> R17
;	i -> R16
	LDI  R17,0
	SBIC 0x10,5
	RJMP _0x39A
; 0000 01CC {
; 0000 01CD dr=0;
	LDI  R17,LOW(0)
; 0000 01CE for (i=0;i<20;i++)
	LDI  R16,LOW(0)
_0x39C:
	CPI  R16,20
	BRSH _0x39D
; 0000 01CF   { //   
; 0000 01D0    delay_ms(10);
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x28
; 0000 01D1    if(!key_2)
	SBIS 0x10,5
; 0000 01D2    dr++;
	SUBI R17,-1
; 0000 01D3   }
	SUBI R16,-1
	RJMP _0x39C
_0x39D:
; 0000 01D4   beep=1;
	SBI  0x18,0
; 0000 01D5   delay_ms(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x28
; 0000 01D6   beep=0;
	CBI  0x18,0
; 0000 01D7 if(dr > 5)
	CPI  R17,6
	BRLO _0x3A3
; 0000 01D8     {
; 0000 01D9 key_2_pressed=1;
	SET
	BLD  R5,1
; 0000 01DA display_time=0;
	RCALL SUBOPT_0x44
; 0000 01DB     //  , 
; 0000 01DC     }
; 0000 01DD }
_0x3A3:
; 0000 01DE  /// 2
; 0000 01DF     #asm("wdr")
_0x39A:
	wdr
; 0000 01E0 }
	RJMP _0x2060001
;// *******************************************************************
;void off(void)
; 0000 01E3 {
_off:
; 0000 01E4 GICR |= (0<<INT0);
	IN   R30,0x3B
	OUT  0x3B,R30
; 0000 01E5 display=1;
	RCALL SUBOPT_0x45
; 0000 01E6 display_time=0;
; 0000 01E7 rad_hour=0;
	RCALL SUBOPT_0x3D
; 0000 01E8 doze=0;
	LDI  R30,LOW(0)
	STS  _doze,R30
	STS  _doze+1,R30
	STS  _doze+2,R30
	STS  _doze+3,R30
; 0000 01E9 fulldoze=0;
	STS  _fulldoze,R30
	STS  _fulldoze+1,R30
	STS  _fulldoze+2,R30
	STS  _fulldoze+3,R30
; 0000 01EA sutki=0;
	STS  _sutki,R30
	STS  _sutki+1,R30
; 0000 01EB 
; 0000 01EC         clearDisplayBuffer();
	RCALL SUBOPT_0x46
; 0000 01ED         clearDisplay();
; 0000 01EE        delay_ms(320);
; 0000 01EF        shift_in('B',0);
	LDI  R30,LOW(66)
	RCALL SUBOPT_0x47
; 0000 01F0        delay_ms(320);
; 0000 01F1        shift_in('Y',0);
	LDI  R30,LOW(89)
	RCALL SUBOPT_0x47
; 0000 01F2        delay_ms(320);
; 0000 01F3        shift_in('E',0);
	LDI  R30,LOW(69)
	RCALL SUBOPT_0x47
; 0000 01F4        delay_ms(320);
; 0000 01F5        delay_ms(320);
	LDI  R30,LOW(320)
	LDI  R31,HIGH(320)
	RCALL SUBOPT_0x28
; 0000 01F6 
; 0000 01F7         key_press=0;
	LDI  R30,LOW(0)
	STS  _key_press,R30
	STS  _key_press+1,R30
; 0000 01F8         delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x28
; 0000 01F9 
; 0000 01FA         power_on_off=1;
	RCALL SUBOPT_0x48
; 0000 01FB         display=0;
; 0000 01FC         display_time=time_to_display+1;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x3F
; 0000 01FD 
; 0000 01FE         beep=0;
	CBI  0x18,0
; 0000 01FF 
; 0000 0200 
; 0000 0201 }
	RET
;
;void calculate_rad(void)
; 0000 0204 {
_calculate_rad:
; 0000 0205 
; 0000 0206     iv=0;
	RCALL SUBOPT_0x49
; 0000 0207     ivc=0;
	RCALL SUBOPT_0x4A
; 0000 0208     peak=0;
; 0000 0209     rcnt=0;
; 0000 020A     rad=0;
; 0000 020B 
; 0000 020C     //   
; 0000 020D     if (counted) {s=rad_interval+1;} else {s=rad_cnt+1;} //       .  -  
	SBRS R2,0
	RJMP _0x3A6
	MOVW R30,R8
	RJMP _0x49B
_0x3A6:
	RCALL SUBOPT_0x2C
_0x49B:
	ADIW R30,1
	STS  _s,R30
	STS  _s+1,R31
; 0000 020E 
; 0000 020F     for(x=0;x<s;x++) //      .
	RCALL SUBOPT_0x4B
_0x3A9:
	LDS  R30,_s
	LDS  R31,_s+1
	RCALL SUBOPT_0x4C
	BRSH _0x3AA
; 0000 0210     {
; 0000 0211     peak += rad_massive[x];
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x11
	STS  _peak,R30
	STS  _peak+1,R31
; 0000 0212 	rad += rad_massive[x];
	RCALL SUBOPT_0x4D
	__ADDWRR 10,11,30,31
; 0000 0213 if (iv == 35)  // [0-35]  36 
	LDS  R26,_iv
	LDS  R27,_iv+1
	SBIW R26,35
	BRNE _0x3AB
; 0000 0214  {
; 0000 0215  if (peak > alarm_level) alarm_cnt++;
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x4E
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x3AC
	LDS  R30,_alarm_cnt
	SUBI R30,-LOW(1)
	STS  _alarm_cnt,R30
; 0000 0216  rcnt += peak;
_0x3AC:
	LDS  R30,_peak
	LDS  R31,_peak+1
	RCALL SUBOPT_0x4F
	RCALL SUBOPT_0x11
	STS  _rcnt,R30
	STS  _rcnt+1,R31
; 0000 0217  peak=0;
	LDI  R30,LOW(0)
	STS  _peak,R30
	STS  _peak+1,R30
; 0000 0218  ivc++;
	LDI  R26,LOW(_ivc)
	LDI  R27,HIGH(_ivc)
	RCALL SUBOPT_0x12
; 0000 0219  iv=0;
	RCALL SUBOPT_0x49
; 0000 021A  }
; 0000 021B     iv++;
_0x3AB:
	LDI  R26,LOW(_iv)
	LDI  R27,HIGH(_iv)
	RCALL SUBOPT_0x12
; 0000 021C     }
	LDI  R26,LOW(_x)
	LDI  R27,HIGH(_x)
	RCALL SUBOPT_0x12
	RJMP _0x3A9
_0x3AA:
; 0000 021D          if ((counted)&&(rad_interval>36))
	SBRS R2,0
	RJMP _0x3AE
	LDI  R30,LOW(36)
	LDI  R31,HIGH(36)
	RCALL SUBOPT_0x33
	BRLO _0x3AF
_0x3AE:
	RJMP _0x3AD
_0x3AF:
; 0000 021E         {
; 0000 021F         rad_fon = rcnt/ivc; //    36   
	LDS  R30,_ivc
	LDS  R31,_ivc+1
	RCALL SUBOPT_0x4F
	RJMP _0x49C
; 0000 0220 		}
; 0000 0221         else
_0x3AD:
; 0000 0222         {
; 0000 0223 		rad_fon = rad*36/(rad_cnt+1); // 
	MOVW R30,R10
	LDI  R26,LOW(36)
	LDI  R27,HIGH(36)
	RCALL __MULW12U
	MOVW R26,R30
	RCALL SUBOPT_0x2C
	ADIW R30,1
_0x49C:
	RCALL __DIVW21U
	MOVW R12,R30
; 0000 0224 		}
; 0000 0225 
; 0000 0226 
; 0000 0227 
; 0000 0228 }
	RET
;
;void init_pump()
; 0000 022B {
_init_pump:
; 0000 022C int i;
; 0000 022D     GICR=0x00;
	RCALL __SAVELOCR2
;	i -> R16,R17
	LDI  R30,LOW(0)
	OUT  0x3B,R30
; 0000 022E     for(i=0;i<6000;i++)
	__GETWRN 16,17,0
_0x3B2:
	__CPWRN 16,17,6000
	BRGE _0x3B3
; 0000 022F     {
; 0000 0230         i++;
	__ADDWRN 16,17,1
; 0000 0231         trans=1;
	SBI  0x12,7
; 0000 0232         delay_us(3);
	__DELAY_USB 8
; 0000 0233         trans=0;
	CBI  0x12,7
; 0000 0234         delay_us(7);
	__DELAY_USB 19
; 0000 0235         #asm("wdr")
	wdr
; 0000 0236     }
	__ADDWRN 16,17,1
	RJMP _0x3B2
_0x3B3:
; 0000 0237     tem=0;
	LDI  R30,LOW(0)
	STS  _tem,R30
	STS  _tem+1,R30
	STS  _tem+2,R30
	STS  _tem+3,R30
; 0000 0238     GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 0239     delay_ms(600);
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	RCALL SUBOPT_0x28
; 0000 023A for(x=0;x<(rad_interval+1);x++){ rad_massive[x]=0;} //  .     , 
	RCALL SUBOPT_0x4B
_0x3B9:
	MOVW R30,R8
	ADIW R30,1
	RCALL SUBOPT_0x4C
	BRSH _0x3BA
	LDS  R30,_x
	LDS  R31,_x+1
	LDI  R26,LOW(_rad_massive)
	LDI  R27,HIGH(_rad_massive)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x14
	ST   X+,R30
	ST   X,R31
	LDI  R26,LOW(_x)
	LDI  R27,HIGH(_x)
	RCALL SUBOPT_0x12
	RJMP _0x3B9
_0x3BA:
; 0000 023B 
; 0000 023C }
_0x2060001:
	RCALL __LOADLOCR2P
	RET
;// ********************************************************************
;
;
;void main(void)
; 0000 0241 {
_main:
; 0000 0242 unsigned long i=0;
; 0000 0243 wdt_error=0;
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
;	i -> Y+0
	LDI  R26,LOW(_wdt_error)
	LDI  R27,HIGH(_wdt_error)
	RCALL SUBOPT_0x14
	RCALL __EEPROMWRW
; 0000 0244 rad_cnt=0;
	RCALL SUBOPT_0x2F
; 0000 0245 
; 0000 0246 #pragma optsize-
; 0000 0247 if (MCUCSR & 0x08)    //0000 1000
	IN   R30,0x34
	SBRS R30,3
	RJMP _0x3BB
; 0000 0248    {
; 0000 0249    // Watchdog Reset
; 0000 024A    reset_by_wdt = 1;
	SET
	BLD  R2,4
; 0000 024B    wdt_error++;
	LDI  R26,LOW(_wdt_error)
	LDI  R27,HIGH(_wdt_error)
	RCALL __EEPROMRDW
	ADIW R30,1
	RCALL __EEPROMWRW
	SBIW R30,1
; 0000 024C    MCUCSR=0;
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 024D    }
; 0000 024E MCUCSR=0;
_0x3BB:
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 024F 
; 0000 0250 WDTCR=0x1F;
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 0251 WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 0252 #ifdef _OPTIMIZE_SIZE_
; 0000 0253 #pragma optsize+
; 0000 0254 #endif
; 0000 0255 
; 0000 0256 PORTB.0=0; // 
	CBI  0x18,0
; 0000 0257 DDRB.0=1;
	SBI  0x17,0
; 0000 0258 
; 0000 0259 PORTD.4=0; // 
	CBI  0x12,4
; 0000 025A DDRD.4=1;
	SBI  0x11,4
; 0000 025B 
; 0000 025C PORTD.2=1; // IMPULSES
	SBI  0x12,2
; 0000 025D DDRD.2=0;
	CBI  0x11,2
; 0000 025E 
; 0000 025F PORTD.3=1; // BuTT Menu
	SBI  0x12,3
; 0000 0260 DDRD.3=0;
	CBI  0x11,3
; 0000 0261 
; 0000 0262 PORTD.5=1; // BuTT SeT
	SBI  0x12,5
; 0000 0263 DDRD.5=0;
	CBI  0x11,5
; 0000 0264 
; 0000 0265 PORTD.7=0; //    .
	CBI  0x12,7
; 0000 0266 DDRD.7=1;
	SBI  0x11,7
; 0000 0267 
; 0000 0268 
; 0000 0269 PORTB.5=0; // a
	CBI  0x18,5
; 0000 026A DDRB.5=1;
	SBI  0x17,5
; 0000 026B 
; 0000 026C PORTB.1=0; // b
	CBI  0x18,1
; 0000 026D DDRB.1=1;
	SBI  0x17,1
; 0000 026E 
; 0000 026F PORTC.3=0; // c
	CBI  0x15,3
; 0000 0270 DDRC.3=1;
	SBI  0x14,3
; 0000 0271 
; 0000 0272 PORTC.5=0; // d
	CBI  0x15,5
; 0000 0273 DDRC.5=1;
	SBI  0x14,5
; 0000 0274 
; 0000 0275 PORTC.4=0; // e
	CBI  0x15,4
; 0000 0276 DDRC.4=1;
	SBI  0x14,4
; 0000 0277 
; 0000 0278 PORTB.4=0; // f
	CBI  0x18,4
; 0000 0279 DDRB.4=1;
	SBI  0x17,4
; 0000 027A 
; 0000 027B PORTC.2=0; // g
	CBI  0x15,2
; 0000 027C DDRC.2=1;
	SBI  0x14,2
; 0000 027D 
; 0000 027E PORTD.0=0; // dp
	CBI  0x12,0
; 0000 027F DDRD.0=1;
	SBI  0x11,0
; 0000 0280 
; 0000 0281 PORTD.1=0; // rad led
	CBI  0x12,1
; 0000 0282 DDRD.1=1;
	SBI  0x11,1
; 0000 0283 
; 0000 0284 PORTC.0=0; // seg1
	CBI  0x15,0
; 0000 0285 DDRC.0=1;
	SBI  0x14,0
; 0000 0286 
; 0000 0287 PORTB.3=0; // seg2
	CBI  0x18,3
; 0000 0288 DDRB.3=1;
	SBI  0x17,3
; 0000 0289 
; 0000 028A PORTB.2=0; // seg3
	CBI  0x18,2
; 0000 028B DDRB.2=1;
	SBI  0x17,2
; 0000 028C 
; 0000 028D PORTC.1=0; // seg4
	CBI  0x15,1
; 0000 028E DDRC.1=1;
	SBI  0x14,1
; 0000 028F 
; 0000 0290 
; 0000 0291 
; 0000 0292 //TCCR0=0x02;
; 0000 0293 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 0294 TCNT0=0xFF;
	LDI  R30,LOW(255)
	OUT  0x32,R30
; 0000 0295 
; 0000 0296 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 0297 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0298 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0299 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 029A ICR1H=0x00;
	OUT  0x27,R30
; 0000 029B ICR1L=0x00;
	OUT  0x26,R30
; 0000 029C OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 029D OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 029E OCR1BH=0x00;
	OUT  0x29,R30
; 0000 029F OCR1BL=0x00;
	OUT  0x28,R30
; 0000 02A0 
; 0000 02A1 
; 0000 02A2   ASSR = (1<<AS2);
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 02A3      //       
; 0000 02A4   delay_ms(1000);
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x28
; 0000 02A5      // 3.    TCNT2, OCR2x, and TCCR2B.
; 0000 02A6   TCNT2 = 0;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 02A7      /*   = 128
; 0000 02A8        32.768 kHz / 128 / 256 =    . */
; 0000 02A9   TCCR2 |= (1<<CS22) | (1<<CS20);
	IN   R30,0x25
	ORI  R30,LOW(0x5)
	OUT  0x25,R30
; 0000 02AA 
; 0000 02AB 
; 0000 02AC 
; 0000 02AD /*
; 0000 02AE ASSR=0x08;
; 0000 02AF TCCR2=0x07;
; 0000 02B0 TCNT2=0xDF;
; 0000 02B1 OCR2=0x00;
; 0000 02B2 */
; 0000 02B3 
; 0000 02B4 GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 02B5 MCUCR=0xB0;
	LDI  R30,LOW(176)
	OUT  0x35,R30
; 0000 02B6 GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 02B7 
; 0000 02B8 TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 02B9 TIMSK |= (1<<OCIE2); //     2
	IN   R30,0x39
	ORI  R30,0x80
	OUT  0x39,R30
; 0000 02BA 
; 0000 02BB // delay_ms(2);
; 0000 02BC 
; 0000 02BD 
; 0000 02BE if(!key) //     ,    .
	SBIC 0x10,3
	RJMP _0x408
; 0000 02BF {
; 0000 02C0 DDRC.4=0;
	CBI  0x14,4
; 0000 02C1 beep_on_pulse=0;
	LDI  R30,LOW(0)
	STS  _beep_on_pulse,R30
; 0000 02C2 }
; 0000 02C3 
; 0000 02C4 
; 0000 02C5 init_pump();
_0x408:
	RCALL _init_pump
; 0000 02C6 iv=0;
	RCALL SUBOPT_0x49
; 0000 02C7 ivc=0;
	RCALL SUBOPT_0x4A
; 0000 02C8 peak=0;
; 0000 02C9 rcnt=0;
; 0000 02CA rad=0;
; 0000 02CB 
; 0000 02CC     delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x28
; 0000 02CD 
; 0000 02CE 
; 0000 02CF check_battery();
	RCALL _check_battery
; 0000 02D0 
; 0000 02D1 #asm("sei") // 
	sei
; 0000 02D2 
; 0000 02D3 
; 0000 02D4 while (1)
_0x40B:
; 0000 02D5  {
; 0000 02D6 
; 0000 02D7 if (hello) {
	SBRS R4,0
	RJMP _0x40E
; 0000 02D8 hello=0;
	CLT
	BLD  R4,0
; 0000 02D9 display=1;
	RCALL SUBOPT_0x45
; 0000 02DA display_time=0;
; 0000 02DB 
; 0000 02DC         clearDisplayBuffer();
	RCALL SUBOPT_0x46
; 0000 02DD         clearDisplay();
; 0000 02DE        delay_ms(320);
; 0000 02DF        shift_in('H',0);
	LDI  R30,LOW(72)
	RCALL SUBOPT_0x47
; 0000 02E0        delay_ms(320);
; 0000 02E1        shift_in('E',0);
	LDI  R30,LOW(69)
	RCALL SUBOPT_0x47
; 0000 02E2        delay_ms(320);
; 0000 02E3        shift_in('L',0);
	LDI  R30,LOW(76)
	RCALL SUBOPT_0x47
; 0000 02E4        delay_ms(320);
; 0000 02E5        shift_in('L',0);
	LDI  R30,LOW(76)
	RCALL SUBOPT_0x47
; 0000 02E6        delay_ms(320);
; 0000 02E7        shift_in('O',1);
	LDI  R30,LOW(79)
	RCALL SUBOPT_0x51
	RCALL _shift_in
; 0000 02E8        delay_ms(320);
	LDI  R30,LOW(320)
	LDI  R31,HIGH(320)
	RCALL SUBOPT_0x28
; 0000 02E9 }
; 0000 02EA if (scroll_off) { scroll_off=0; off(); }
_0x40E:
	SBRS R3,7
	RJMP _0x40F
	CLT
	BLD  R3,7
	RCALL _off
; 0000 02EB // #asm("wdr")
; 0000 02EC if(power_on_off)
_0x40F:
	SBRS R4,1
	RJMP _0x410
; 0000 02ED     {
; 0000 02EE         beep=0;
	CBI  0x18,0
; 0000 02EF         power_on_off=1;
	RCALL SUBOPT_0x48
; 0000 02F0         display=0;
; 0000 02F1 //        MCUCR |= ((1<<SE)|(0<<SM1)|(1<<SM0)); //  PowerSave mode
; 0000 02F2         // MCUCR|=(1<<SM1)|(0<<SM0)|(1<<SE);
; 0000 02F3 //        #asm("sleep")
; 0000 02F4         #asm("wdr")
	wdr
; 0000 02F5 
; 0000 02F6     }
; 0000 02F7 
; 0000 02F8 
; 0000 02F9 if (!power_on_off) { // ON
_0x410:
	SBRC R4,1
	RJMP _0x413
; 0000 02FA  calculate_rad();
	RCALL _calculate_rad
; 0000 02FB     if (menu_select>5) //   
	RCALL SUBOPT_0x52
	CPI  R26,LOW(0x6)
	BRLO _0x414
; 0000 02FC     {
; 0000 02FD             menu_active=0;
	RCALL SUBOPT_0x42
; 0000 02FE             menu_select=0;
; 0000 02FF             search_mode=0;
; 0000 0300             clock_mode=0;
	RCALL SUBOPT_0x1F
; 0000 0301             today_doze_mode=0;
; 0000 0302             all_doze_mode=0;
; 0000 0303             volts_mode=0;
; 0000 0304             fon_mode=1;
	RCALL SUBOPT_0x20
; 0000 0305     }
; 0000 0306  if(display_time < time_to_display+1)         //time_to_display    
_0x414:
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x3E
	CP   R26,R30
	CPC  R27,R31
	BRLT PC+2
	RJMP _0x415
; 0000 0307    {
; 0000 0308   // check_key();
; 0000 0309 
; 0000 030A   display=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _display,R30
	STS  _display+1,R31
; 0000 030B 
; 0000 030C //  
; 0000 030D if ((!menu_active)&(!search_mode)) {
	LDI  R26,0
	SBRS R3,5
	LDI  R26,1
	RCALL SUBOPT_0x41
	BRNE PC+2
	RJMP _0x416
; 0000 030E  if(today_doze_mode)
	SBRS R2,7
	RJMP _0x417
; 0000 030F  {
; 0000 0310 //    day_doze=4540; //test only
; 0000 0311 //     tem=doze/100;
; 0000 0312     tem=rad_hour/100;
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x53
	RCALL SUBOPT_0x54
; 0000 0313        clearDisplayBuffer();
	RCALL SUBOPT_0x55
; 0000 0314        clearDisplay();
; 0000 0315        if (scroll)
	SBRS R3,6
	RJMP _0x418
; 0000 0316        {
; 0000 0317        delay_ms(120);
	RCALL SUBOPT_0x56
; 0000 0318        shift_in('T',0);
	RCALL SUBOPT_0x57
; 0000 0319        delay_ms(120);
; 0000 031A        shift_in('o',0);
	LDI  R30,LOW(111)
	RCALL SUBOPT_0x58
; 0000 031B        delay_ms(120);
; 0000 031C        shift_in('d',0);
	LDI  R30,LOW(100)
	RCALL SUBOPT_0x58
; 0000 031D        delay_ms(120);
; 0000 031E        shift_in('a',0);
	LDI  R30,LOW(97)
	RCALL SUBOPT_0x58
; 0000 031F        delay_ms(120);
; 0000 0320        shift_in('y',0);
	LDI  R30,LOW(121)
	RCALL SUBOPT_0x58
; 0000 0321        delay_ms(120);
; 0000 0322        shift_in('*',0);
	RCALL SUBOPT_0x59
; 0000 0323        delay_ms(120);
; 0000 0324        shift_in('D',0);
	LDI  R30,LOW(68)
	RCALL SUBOPT_0x58
; 0000 0325        delay_ms(120);
; 0000 0326        shift_in('O',0);
	LDI  R30,LOW(79)
	RCALL SUBOPT_0x58
; 0000 0327        delay_ms(120);
; 0000 0328        shift_in('S',0);
	RCALL SUBOPT_0x5A
; 0000 0329        delay_ms(120);
; 0000 032A        shift_in('E',0);
	LDI  R30,LOW(69)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x5C
; 0000 032B        delay_ms(240);
; 0000 032C        scroll=0;
	RCALL SUBOPT_0x5D
; 0000 032D        }
; 0000 032E        clearDisplayBuffer();
_0x418:
	RCALL SUBOPT_0x55
; 0000 032F        clearDisplay();
; 0000 0330     if(tem>9999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);}
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5F
	BRLO _0x419
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0331        else
	RJMP _0x41A
_0x419:
; 0000 0332        {
; 0000 0333             if ((tem/1000)>0) set_char_at((tem/1000), 0,0); else set_char_at('*', 0,0); // 
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	RCALL __CPD02
	BRSH _0x41B
	RCALL SUBOPT_0x65
	RJMP _0x49D
_0x41B:
	LDI  R30,LOW(42)
_0x49D:
	ST   -Y,R30
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0334             if (((tem%1000)/100)>0) set_char_at(((tem%1000)/100), 1,0); else set_char_at('*', 1,0);
	RCALL SUBOPT_0x67
	RCALL SUBOPT_0x68
	BRSH _0x41D
	RCALL SUBOPT_0x67
	RJMP _0x49E
_0x41D:
	LDI  R30,LOW(42)
_0x49E:
	ST   -Y,R30
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0335             set_char_at(((tem%100)/10), 2,1);
	RCALL SUBOPT_0x69
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x6A
; 0000 0336             set_char_at((tem%10), 3,0);
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0337             #asm("wdr")
	wdr
; 0000 0338 
; 0000 0339        }
_0x41A:
; 0000 033A  }
; 0000 033B else if(all_doze_mode)
	RJMP _0x41F
_0x417:
	SBRS R3,0
	RJMP _0x420
; 0000 033C  {
; 0000 033D //    day_doze=4540; //test only
; 0000 033E //     tem=doze/100;
; 0000 033F     tem=doze/100;
	LDS  R26,_doze
	LDS  R27,_doze+1
	LDS  R24,_doze+2
	LDS  R25,_doze+3
	RCALL SUBOPT_0x6B
	RCALL __DIVD21U
	STS  _tem,R30
	STS  _tem+1,R31
	STS  _tem+2,R22
	STS  _tem+3,R23
; 0000 0340        clearDisplayBuffer();
	RCALL SUBOPT_0x55
; 0000 0341        clearDisplay();
; 0000 0342        if (scroll)
	SBRS R3,6
	RJMP _0x421
; 0000 0343        {
; 0000 0344        delay_ms(120);
	RCALL SUBOPT_0x56
; 0000 0345        shift_in('D',0);
	LDI  R30,LOW(68)
	RCALL SUBOPT_0x58
; 0000 0346        delay_ms(120);
; 0000 0347        shift_in('O',0);
	LDI  R30,LOW(79)
	RCALL SUBOPT_0x58
; 0000 0348        delay_ms(120);
; 0000 0349        shift_in('S',0);
	RCALL SUBOPT_0x5A
; 0000 034A        delay_ms(120);
; 0000 034B        shift_in('E',0);
	RCALL SUBOPT_0x6C
; 0000 034C        delay_ms(120);
; 0000 034D        shift_in('*',0);
	LDI  R30,LOW(42)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x6D
; 0000 034E        delay_ms(180);
; 0000 034F       if (((sutki%1000)/100)>0)
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	BRSH _0x422
; 0000 0350       {
; 0000 0351        shift_in((sutki%1000)/100,0);
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x6D
; 0000 0352        delay_ms(180);
; 0000 0353       }
; 0000 0354       if (((sutki%100)/10)>0)
_0x422:
	RCALL SUBOPT_0x70
	RCALL SUBOPT_0x6F
	BRSH _0x423
; 0000 0355       {
; 0000 0356        shift_in((sutki%100)/10,0);
	RCALL SUBOPT_0x70
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x6D
; 0000 0357        delay_ms(180);
; 0000 0358       }
; 0000 0359        shift_in((sutki%10),0);
_0x423:
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	RCALL SUBOPT_0x43
	RCALL __MODW21U
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x6D
; 0000 035A        delay_ms(180);
; 0000 035B        shift_in('*',0);
	LDI  R30,LOW(42)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x6D
; 0000 035C        delay_ms(180);
; 0000 035D        shift_in('D',0);
	LDI  R30,LOW(68)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x6D
; 0000 035E        delay_ms(180);
; 0000 035F        shift_in('A',0);
	LDI  R30,LOW(65)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x6D
; 0000 0360        delay_ms(180);
; 0000 0361        shift_in('Y',0);
	LDI  R30,LOW(89)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x5C
; 0000 0362        delay_ms(240);
; 0000 0363        scroll=0;
	RCALL SUBOPT_0x5D
; 0000 0364        }
; 0000 0365        clearDisplayBuffer();
_0x421:
	RCALL SUBOPT_0x55
; 0000 0366        clearDisplay();
; 0000 0367     if(tem>9999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);}
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5F
	BRLO _0x424
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0368        else
	RJMP _0x425
_0x424:
; 0000 0369        {
; 0000 036A             if ((tem/1000)>0) set_char_at((tem/1000), 0,0); else set_char_at('*', 0,0); // 
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	BRSH _0x426
	RCALL SUBOPT_0x65
	RJMP _0x49F
_0x426:
	LDI  R30,LOW(42)
_0x49F:
	ST   -Y,R30
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 036B             if (((tem%1000)/100)>0) set_char_at(((tem%1000)/100), 1,0); else set_char_at('*', 1,0);
	RCALL SUBOPT_0x67
	RCALL SUBOPT_0x68
	BRSH _0x428
	RCALL SUBOPT_0x67
	RJMP _0x4A0
_0x428:
	LDI  R30,LOW(42)
_0x4A0:
	ST   -Y,R30
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 036C             set_char_at(((tem%100)/10), 2,1);
	RCALL SUBOPT_0x69
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x6A
; 0000 036D             set_char_at((tem%10), 3,0);
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 036E             #asm("wdr")
	wdr
; 0000 036F 
; 0000 0370        }
_0x425:
; 0000 0371  }
; 0000 0372 else if(clock_mode)
	RJMP _0x42A
_0x420:
	SBRS R3,4
	RJMP _0x42B
; 0000 0373  {
; 0000 0374             set_char_at(((hour_tick%100)/10), 0,0);
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0375 if (second_tick % 2) {
	RCALL SUBOPT_0x72
	BREQ _0x42C
; 0000 0376             set_char_at((hour_tick%10), 1,0);
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0x14
	RJMP _0x4A1
; 0000 0377                      }
; 0000 0378                      else
_0x42C:
; 0000 0379                      {
; 0000 037A             set_char_at((hour_tick%10), 1,1);
	RCALL SUBOPT_0x73
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x4A1:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _set_char_at
; 0000 037B                      }
; 0000 037C             set_char_at(((minute_tick%100)/10), 2,0);
	RCALL SUBOPT_0x74
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x75
; 0000 037D             set_char_at((minute_tick%10), 3,0);
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 037E         #asm("wdr")
	wdr
; 0000 037F  }
; 0000 0380  else if(volts_mode)
	RJMP _0x42E
_0x42B:
	SBRS R3,1
	RJMP _0x42F
; 0000 0381  {
; 0000 0382     if(VoltLevel>999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);}
	RCALL SUBOPT_0x21
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRLO _0x430
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0383        else
	RJMP _0x431
_0x430:
; 0000 0384        {
; 0000 0385             set_char_at('u', 0,0);   //  'u'
	LDI  R30,LOW(117)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0386             set_char_at(((VoltLevel%1000)/100), 1,1);
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x16
	RCALL _set_char_at
; 0000 0387             set_char_at(((VoltLevel%100)/10), 2,0);
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x77
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0388             set_char_at((VoltLevel%10), 3,0);
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x43
	RCALL __MODW21U
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0389         #asm("wdr")
	wdr
; 0000 038A        }
_0x431:
; 0000 038B  }
; 0000 038C else if(fon_mode)
	RJMP _0x432
_0x42F:
	SBRS R3,2
	RJMP _0x433
; 0000 038D   {
; 0000 038E if ((second_tick % 2)||(counted))  //      -  
	RCALL SUBOPT_0x72
	BRNE _0x435
	SBRS R2,0
	RJMP _0x434
_0x435:
; 0000 038F              {
; 0000 0390 
; 0000 0391    if (blink)
	SBRS R2,1
	RJMP _0x437
; 0000 0392    {
; 0000 0393         if (blink_led_on_pulse) { rad_led=1; }
	SBRC R2,2
	SBI  0x12,1
; 0000 0394         delay_ms(16);
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL SUBOPT_0x28
; 0000 0395         if (blink_led_on_pulse) { rad_led=0; }
	SBRC R2,2
	CBI  0x12,1
; 0000 0396     blink=0;
	CLT
	BLD  R2,1
; 0000 0397     }
; 0000 0398 
; 0000 0399 
; 0000 039A    // tem=mode_counter;
; 0000 039B    tem=rad_fon;
_0x437:
	MOVW R30,R12
	RCALL SUBOPT_0x54
; 0000 039C        if(tem>9999)
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5F
	BRLO _0x43E
; 0000 039D        {
; 0000 039E        set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);//    "- - - -"
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 039F        }
; 0000 03A0        else
	RJMP _0x43F
_0x43E:
; 0000 03A1        {
; 0000 03A2             if ((tem/1000)>0) set_char_at((tem/1000), 0,0); else set_char_at('*', 0,0); // 
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	BRSH _0x440
	RCALL SUBOPT_0x65
	RJMP _0x4A2
_0x440:
	LDI  R30,LOW(42)
_0x4A2:
	ST   -Y,R30
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03A3             if (((tem%1000)/100)>0) set_char_at(((tem%1000)/100), 1,0); else set_char_at('*', 1,0);
	RCALL SUBOPT_0x67
	RCALL SUBOPT_0x68
	BRSH _0x442
	RCALL SUBOPT_0x67
	RJMP _0x4A3
_0x442:
	LDI  R30,LOW(42)
_0x4A3:
	ST   -Y,R30
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03A4             if (((tem%100)/10)>0) set_char_at(((tem%100)/10), 2,0); else set_char_at('*', 2,0);
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x68
	BRSH _0x444
	RCALL SUBOPT_0x78
	RJMP _0x4A4
_0x444:
	LDI  R30,LOW(42)
_0x4A4:
	ST   -Y,R30
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03A5             set_char_at((tem%10), 3,0);
	RCALL SUBOPT_0x5E
	__GETD1N 0xA
	RCALL __MODD21U
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03A6             #asm("wdr")
	wdr
; 0000 03A7        }
_0x43F:
; 0000 03A8              } else { display=0; clearDisplayBuffer(); clearDisplay();}
	RJMP _0x446
_0x434:
	RCALL SUBOPT_0x79
	RCALL SUBOPT_0x55
_0x446:
; 0000 03A9    }
; 0000 03AA } //  
_0x433:
_0x432:
_0x42E:
_0x42A:
_0x41F:
; 0000 03AB else if (search_mode)
	RJMP _0x447
_0x416:
	SBRS R3,3
	RJMP _0x448
; 0000 03AC    {
; 0000 03AD    check_key();
	RCALL _check_key
; 0000 03AE if (key_2_pressed)
	SBRS R5,1
	RJMP _0x449
; 0000 03AF     {
; 0000 03B0     if (beep_on_pulse) { beep_on_pulse=0; vib_on_pulse=1; } else { vib_on_pulse=0; beep_on_pulse=1; }
	RCALL SUBOPT_0x7A
	BREQ _0x44A
	LDI  R30,LOW(0)
	STS  _beep_on_pulse,R30
	LDI  R30,LOW(1)
	STS  _vib_on_pulse,R30
	RJMP _0x44B
_0x44A:
	LDI  R30,LOW(0)
	STS  _vib_on_pulse,R30
	LDI  R30,LOW(1)
	STS  _beep_on_pulse,R30
_0x44B:
; 0000 03B1     key_2_pressed=0;
	RCALL SUBOPT_0x7B
; 0000 03B2     }
; 0000 03B3 
; 0000 03B4    clearDisplayBuffer(); clearDisplay();
_0x449:
	RCALL SUBOPT_0x55
; 0000 03B5    if(beep_on_pulse)
	RCALL SUBOPT_0x7A
	BREQ _0x44C
; 0000 03B6    set_char_at('S', 0,0);   //  'S'
	LDI  R30,LOW(83)
	RJMP _0x4A5
; 0000 03B7    else if(vib_on_pulse)
_0x44C:
	LDS  R30,_vib_on_pulse
	CPI  R30,0
	BREQ _0x44E
; 0000 03B8    set_char_at('V', 0,0);   //  'V'
	LDI  R30,LOW(86)
_0x4A5:
	ST   -Y,R30
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03B9 
; 0000 03BA 
; 0000 03BB    if(search_imp>999)
_0x44E:
	RCALL SUBOPT_0x7C
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRLO _0x44F
; 0000 03BC     {
; 0000 03BD     set_char_at('-', 1,0);
	LDI  R30,LOW(45)
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x61
; 0000 03BE     set_char_at('-', 2,0);
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x61
; 0000 03BF     set_char_at('-', 3,0);
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03C0     }
; 0000 03C1        else
	RJMP _0x450
_0x44F:
; 0000 03C2        {
; 0000 03C3             if (((search_imp%1000)/100)>0) set_char_at(((search_imp%1000)/100), 1,0); else set_char_at('*', 1,0);
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x6F
	BRSH _0x451
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x76
	RJMP _0x4A6
_0x451:
	LDI  R30,LOW(42)
_0x4A6:
	ST   -Y,R30
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03C4             if (((search_imp%100)/10)>0) set_char_at(((search_imp%100)/10), 2,0); else set_char_at('*', 2,0);
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x77
	RCALL SUBOPT_0x6F
	BRSH _0x453
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x77
	RJMP _0x4A7
_0x453:
	LDI  R30,LOW(42)
_0x4A7:
	ST   -Y,R30
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03C5             set_char_at((search_imp%10), 3,0);
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x43
	RCALL __MODW21U
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 03C6         #asm("wdr")
	wdr
; 0000 03C7        }
_0x450:
; 0000 03C8 
; 0000 03C9    if (blink)
	SBRS R2,1
	RJMP _0x455
; 0000 03CA    {
; 0000 03CB         if (blink_led_on_pulse) { rad_led=1; }
	SBRC R2,2
	SBI  0x12,1
; 0000 03CC         if (vib_on_pulse) vibra = 1;
	LDS  R30,_vib_on_pulse
	CPI  R30,0
	BREQ _0x459
	SBI  0x12,4
; 0000 03CD         delay_ms(26);
_0x459:
	LDI  R30,LOW(26)
	LDI  R31,HIGH(26)
	RCALL SUBOPT_0x28
; 0000 03CE         if (beep_on_pulse) beep = 1;
	RCALL SUBOPT_0x7A
	BREQ _0x45C
	SBI  0x18,0
; 0000 03CF         delay_ms(3);
_0x45C:
	RCALL SUBOPT_0x18
	RCALL _delay_ms
; 0000 03D0         vibra = 0;
	CBI  0x12,4
; 0000 03D1         beep = 0;
	CBI  0x18,0
; 0000 03D2         if (blink_led_on_pulse) { rad_led=0; }
	SBRC R2,2
	CBI  0x12,1
; 0000 03D3     blink=0;
	CLT
	BLD  R2,1
; 0000 03D4     }
; 0000 03D5    }
_0x455:
; 0000 03D6 
; 0000 03D7 else { //
	RJMP _0x466
_0x448:
; 0000 03D8        clearDisplayBuffer();
	RCALL SUBOPT_0x55
; 0000 03D9        clearDisplay();
; 0000 03DA /*
; 0000 03DB        if (scroll)
; 0000 03DC        {
; 0000 03DD        delay_ms(120);
; 0000 03DE        shift_in('M',0);
; 0000 03DF        delay_ms(120);
; 0000 03E0        shift_in('E',0);
; 0000 03E1        delay_ms(120);
; 0000 03E2        shift_in('N',0);
; 0000 03E3        delay_ms(120);
; 0000 03E4        shift_in('U',0);
; 0000 03E5        delay_ms(220);
; 0000 03E6        }
; 0000 03E7 */
; 0000 03E8 if(menu_select==0)
	LDS  R30,_menu_select
	CPI  R30,0
	BRNE _0x467
; 0000 03E9         {
; 0000 03EA        if (scroll)
	SBRS R3,6
	RJMP _0x468
; 0000 03EB        {
; 0000 03EC        delay_ms(120);
	RCALL SUBOPT_0x56
; 0000 03ED        shift_in('T',0);
	RCALL SUBOPT_0x57
; 0000 03EE        delay_ms(120);
; 0000 03EF        shift_in('I',0);
	RCALL SUBOPT_0x7D
; 0000 03F0        delay_ms(120);
; 0000 03F1        shift_in('M',0);
	RCALL SUBOPT_0x7E
; 0000 03F2        delay_ms(120);
; 0000 03F3        shift_in('E',0);
	RCALL SUBOPT_0x6C
; 0000 03F4        delay_ms(120);
; 0000 03F5        shift_in('*',0);
	RCALL SUBOPT_0x59
; 0000 03F6        delay_ms(120);
; 0000 03F7        shift_in('S',0);
	RCALL SUBOPT_0x5A
; 0000 03F8        delay_ms(120);
; 0000 03F9        shift_in('E',0);
	RCALL SUBOPT_0x6C
; 0000 03FA        delay_ms(120);
; 0000 03FB        shift_in('T',0);
	LDI  R30,LOW(84)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x7F
; 0000 03FC        delay_ms(220);
; 0000 03FD        scroll=0;
	RCALL SUBOPT_0x5D
; 0000 03FE        }
; 0000 03FF    check_key();
_0x468:
	RCALL _check_key
; 0000 0400 if (key_2_pressed)
	SBRS R5,1
	RJMP _0x469
; 0000 0401     {
; 0000 0402     hour_tick++;
	RCALL SUBOPT_0x3B
; 0000 0403     if (hour_tick>23) hour_tick=0;
	RCALL SUBOPT_0x3C
	CPI  R26,LOW(0x18)
	BRLO _0x46A
	LDI  R30,LOW(0)
	STS  _hour_tick,R30
; 0000 0404     key_2_pressed=0;
_0x46A:
	RCALL SUBOPT_0x7B
; 0000 0405    }
; 0000 0406 
; 0000 0407 if (second_tick % 2) {
_0x469:
	RCALL SUBOPT_0x72
	BREQ _0x46B
; 0000 0408             set_char_at(((hour_tick%100)/10), 0,0);
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0409             set_char_at((hour_tick%10), 1,1);
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0x16
	RCALL _set_char_at
; 0000 040A                      }
; 0000 040B             set_char_at(((minute_tick%100)/10), 2,0);
_0x46B:
	RCALL SUBOPT_0x74
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x75
; 0000 040C             set_char_at((minute_tick%10), 3,0);
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 040D         #asm("wdr")
	wdr
; 0000 040E         }
; 0000 040F else if(menu_select==1)
	RJMP _0x46C
_0x467:
	RCALL SUBOPT_0x52
	CPI  R26,LOW(0x1)
	BRNE _0x46D
; 0000 0410         {
; 0000 0411         scroll=0;
	RCALL SUBOPT_0x5D
; 0000 0412    check_key();
	RCALL _check_key
; 0000 0413 if (key_2_pressed)
	SBRS R5,1
	RJMP _0x46E
; 0000 0414     {
; 0000 0415     minute_tick++;
	RCALL SUBOPT_0x38
; 0000 0416     if (minute_tick>59) minute_tick=0;
	RCALL SUBOPT_0x39
	CPI  R26,LOW(0x3C)
	BRLO _0x46F
	LDI  R30,LOW(0)
	STS  _minute_tick,R30
; 0000 0417     second_tick=0;
_0x46F:
	LDI  R30,LOW(0)
	STS  _second_tick,R30
; 0000 0418     key_2_pressed=0;
	RCALL SUBOPT_0x7B
; 0000 0419    }
; 0000 041A 
; 0000 041B             set_char_at(((hour_tick%100)/10), 0,0);
_0x46E:
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 041C             set_char_at((hour_tick%10), 1,1);
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0x16
	RCALL _set_char_at
; 0000 041D if (second_tick % 2) {
	RCALL SUBOPT_0x72
	BREQ _0x470
; 0000 041E             set_char_at(((minute_tick%100)/10), 2,0);
	RCALL SUBOPT_0x74
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x75
; 0000 041F             set_char_at((minute_tick%10), 3,0);
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0420                      }
; 0000 0421         #asm("wdr")
_0x470:
	wdr
; 0000 0422         }
; 0000 0423 else if(menu_select==2) // 
	RJMP _0x471
_0x46D:
	RCALL SUBOPT_0x52
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x472
; 0000 0424         {
; 0000 0425        if (scroll)
	SBRS R3,6
	RJMP _0x473
; 0000 0426        {
; 0000 0427        delay_ms(120);
	RCALL SUBOPT_0x56
; 0000 0428        shift_in('S',0);
	RCALL SUBOPT_0x5A
; 0000 0429        delay_ms(120);
; 0000 042A        shift_in('L',0);
	LDI  R30,LOW(76)
	RCALL SUBOPT_0x58
; 0000 042B        delay_ms(120);
; 0000 042C        shift_in('E',0);
	RCALL SUBOPT_0x6C
; 0000 042D        delay_ms(120);
; 0000 042E        shift_in('E',0);
	RCALL SUBOPT_0x6C
; 0000 042F        delay_ms(120);
; 0000 0430        shift_in('P',0);
	LDI  R30,LOW(80)
	RCALL SUBOPT_0x58
; 0000 0431        delay_ms(120);
; 0000 0432        shift_in('*',0);
	RCALL SUBOPT_0x59
; 0000 0433        delay_ms(120);
; 0000 0434        shift_in('S',0);
	RCALL SUBOPT_0x5A
; 0000 0435        delay_ms(120);
; 0000 0436        shift_in('E',0);
	RCALL SUBOPT_0x6C
; 0000 0437        delay_ms(120);
; 0000 0438        shift_in('T',0);
	LDI  R30,LOW(84)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x7F
; 0000 0439        delay_ms(220);
; 0000 043A        scroll=0;
	RCALL SUBOPT_0x5D
; 0000 043B        }
; 0000 043C    check_key();
_0x473:
	RCALL _check_key
; 0000 043D if (key_2_pressed)
	SBRS R5,1
	RJMP _0x474
; 0000 043E     {
; 0000 043F         if((time_to_display>=60)&(time_to_display<700))time_to_display+=60;
	RCALL SUBOPT_0x80
	RCALL SUBOPT_0x81
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RCALL SUBOPT_0x82
	LDI  R30,LOW(700)
	LDI  R31,HIGH(700)
	RCALL SUBOPT_0x83
	BREQ _0x475
	RCALL SUBOPT_0x80
	ADIW R30,60
	LDI  R26,LOW(_time_to_display)
	LDI  R27,HIGH(_time_to_display)
	RCALL __EEPROMWRW
; 0000 0440         if((time_to_display>=10)&(time_to_display<60))time_to_display+=10;
_0x475:
	RCALL SUBOPT_0x80
	RCALL SUBOPT_0x81
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x82
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RCALL SUBOPT_0x83
	BREQ _0x476
	RCALL SUBOPT_0x80
	ADIW R30,10
	LDI  R26,LOW(_time_to_display)
	LDI  R27,HIGH(_time_to_display)
	RCALL __EEPROMWRW
; 0000 0441         if(time_to_display<10)time_to_display=10;
_0x476:
	RCALL SUBOPT_0x80
	SBIW R30,10
	BRGE _0x477
	RCALL SUBOPT_0x84
; 0000 0442         if(time_to_display>600)time_to_display=10;
_0x477:
	RCALL SUBOPT_0x80
	CPI  R30,LOW(0x259)
	LDI  R26,HIGH(0x259)
	CPC  R31,R26
	BRLT _0x478
	RCALL SUBOPT_0x84
; 0000 0443 
; 0000 0444     key_2_pressed=0;
_0x478:
	RCALL SUBOPT_0x7B
; 0000 0445    }
; 0000 0446             set_char_at(((time_to_display%1000)/100), 1,0);
_0x474:
	RCALL SUBOPT_0x80
	MOVW R26,R30
	RCALL SUBOPT_0x85
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0447             set_char_at(((time_to_display%100)/10), 2,0);
	RCALL SUBOPT_0x80
	RCALL SUBOPT_0x86
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0448             set_char_at((time_to_display%10), 3,0);
	RCALL SUBOPT_0x80
	RCALL SUBOPT_0x87
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0449         #asm("wdr")
	wdr
; 0000 044A         }
; 0000 044B else if(menu_select==3) // 
	RJMP _0x479
_0x472:
	RCALL SUBOPT_0x52
	CPI  R26,LOW(0x3)
	BREQ PC+2
	RJMP _0x47A
; 0000 044C         {
; 0000 044D        if (scroll)
	SBRS R3,6
	RJMP _0x47B
; 0000 044E        {
; 0000 044F        delay_ms(120);
	RCALL SUBOPT_0x56
; 0000 0450        shift_in('A',0);
	LDI  R30,LOW(65)
	RCALL SUBOPT_0x58
; 0000 0451        delay_ms(120);
; 0000 0452        shift_in('L',0);
	LDI  R30,LOW(76)
	RCALL SUBOPT_0x58
; 0000 0453        delay_ms(120);
; 0000 0454        shift_in('A',0);
	LDI  R30,LOW(65)
	RCALL SUBOPT_0x58
; 0000 0455        delay_ms(120);
; 0000 0456        shift_in('R',0);
	LDI  R30,LOW(82)
	RCALL SUBOPT_0x58
; 0000 0457        delay_ms(120);
; 0000 0458        shift_in('M',0);
	RCALL SUBOPT_0x7E
; 0000 0459        delay_ms(120);
; 0000 045A        shift_in('*',0);
	RCALL SUBOPT_0x59
; 0000 045B        delay_ms(120);
; 0000 045C        shift_in('S',0);
	RCALL SUBOPT_0x5A
; 0000 045D        delay_ms(120);
; 0000 045E        shift_in('E',0);
	RCALL SUBOPT_0x6C
; 0000 045F        delay_ms(120);
; 0000 0460        shift_in('T',0);
	LDI  R30,LOW(84)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x7F
; 0000 0461        delay_ms(220);
; 0000 0462        scroll=0;
	RCALL SUBOPT_0x5D
; 0000 0463        }
; 0000 0464    check_key();
_0x47B:
	RCALL _check_key
; 0000 0465 if (key_2_pressed)
	SBRS R5,1
	RJMP _0x47C
; 0000 0466     {
; 0000 0467     if((alarm_level>=1000)&(alarm_level<5999))alarm_level+=1000;
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x81
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x82
	LDI  R30,LOW(5999)
	LDI  R31,HIGH(5999)
	RCALL SUBOPT_0x83
	BREQ _0x47D
	RCALL SUBOPT_0x1B
	SUBI R30,LOW(-1000)
	SBCI R31,HIGH(-1000)
	RCALL SUBOPT_0x88
; 0000 0468     if((alarm_level>=100)&(alarm_level<1000))alarm_level+=100;
_0x47D:
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x81
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x82
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x83
	BREQ _0x47E
	RCALL SUBOPT_0x1B
	SUBI R30,LOW(-100)
	SBCI R31,HIGH(-100)
	RCALL SUBOPT_0x88
; 0000 0469     if(alarm_level<100)alarm_level+=20;
_0x47E:
	RCALL SUBOPT_0x1B
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRGE _0x47F
	RCALL SUBOPT_0x1B
	ADIW R30,20
	RCALL SUBOPT_0x88
; 0000 046A     if(alarm_level>5999)alarm_level=40;
_0x47F:
	RCALL SUBOPT_0x1B
	CPI  R30,LOW(0x1770)
	LDI  R26,HIGH(0x1770)
	CPC  R31,R26
	BRLT _0x480
	LDI  R26,LOW(_alarm_level)
	LDI  R27,HIGH(_alarm_level)
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	RCALL __EEPROMWRW
; 0000 046B     key_2_pressed=0;
_0x480:
	RCALL SUBOPT_0x7B
; 0000 046C    }
; 0000 046D             set_char_at((alarm_level/1000), 0,0);
_0x47C:
	RCALL SUBOPT_0x1B
	MOVW R26,R30
	RCALL SUBOPT_0x50
	RCALL __DIVW21
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 046E             set_char_at(((alarm_level%1000)/100), 1,0);
	RCALL SUBOPT_0x1B
	MOVW R26,R30
	RCALL SUBOPT_0x85
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 046F             set_char_at(((alarm_level%100)/10), 2,0);
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x86
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0470             set_char_at((alarm_level%10), 3,0);
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x87
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0471         #asm("wdr")
	wdr
; 0000 0472         }
; 0000 0473 else if(menu_select==4) //   .
	RJMP _0x481
_0x47A:
	RCALL SUBOPT_0x52
	CPI  R26,LOW(0x4)
	BRNE _0x482
; 0000 0474         {
; 0000 0475        if (scroll)
	SBRS R3,6
	RJMP _0x483
; 0000 0476        {
; 0000 0477        delay_ms(120);
	RCALL SUBOPT_0x56
; 0000 0478        shift_in('I',0);
	RCALL SUBOPT_0x7D
; 0000 0479        delay_ms(120);
; 0000 047A        shift_in('M',0);
	RCALL SUBOPT_0x7E
; 0000 047B        delay_ms(120);
; 0000 047C        shift_in('P',0);
	LDI  R30,LOW(80)
	RCALL SUBOPT_0x58
; 0000 047D        delay_ms(120);
; 0000 047E        shift_in('_',0);
	LDI  R30,LOW(95)
	RCALL SUBOPT_0x58
; 0000 047F        delay_ms(120);
; 0000 0480        shift_in('D',0);
	LDI  R30,LOW(68)
	RCALL SUBOPT_0x58
; 0000 0481        delay_ms(120);
; 0000 0482        shift_in('E',0);
	RCALL SUBOPT_0x6C
; 0000 0483        delay_ms(120);
; 0000 0484        shift_in('F',0);
	LDI  R30,LOW(70)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x7F
; 0000 0485        delay_ms(220);
; 0000 0486        scroll=0;
	RCALL SUBOPT_0x5D
; 0000 0487        }
; 0000 0488    check_key();
_0x483:
	RCALL _check_key
; 0000 0489 if (key_2_pressed)
	SBRS R5,1
	RJMP _0x484
; 0000 048A     {
; 0000 048B         delay_pump_def++;
	RCALL SUBOPT_0x89
	SUBI R30,-LOW(1)
	RCALL __EEPROMWRB
	SUBI R30,LOW(1)
; 0000 048C         if(delay_pump_def>55)delay_pump_def=4;
	RCALL SUBOPT_0x89
	CPI  R30,LOW(0x38)
	BRLO _0x485
	LDI  R26,LOW(_delay_pump_def)
	LDI  R27,HIGH(_delay_pump_def)
	LDI  R30,LOW(4)
	RCALL __EEPROMWRB
; 0000 048D     key_2_pressed=0;
_0x485:
	RCALL SUBOPT_0x7B
; 0000 048E    }
; 0000 048F             set_char_at(((delay_pump_def%100)/10), 2,0);
_0x484:
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x8A
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0490             set_char_at((delay_pump_def%10), 3,0);
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x8B
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 0491         #asm("wdr")
	wdr
; 0000 0492         }
; 0000 0493 else if(menu_select==5) //   .
	RJMP _0x486
_0x482:
	RCALL SUBOPT_0x52
	CPI  R26,LOW(0x5)
	BRNE _0x487
; 0000 0494         {
; 0000 0495        if (scroll)
	SBRS R3,6
	RJMP _0x488
; 0000 0496        {
; 0000 0497        delay_ms(120);
	RCALL SUBOPT_0x56
; 0000 0498        shift_in('I',0);
	RCALL SUBOPT_0x7D
; 0000 0499        delay_ms(120);
; 0000 049A        shift_in('M',0);
	RCALL SUBOPT_0x7E
; 0000 049B        delay_ms(120);
; 0000 049C        shift_in('P',0);
	LDI  R30,LOW(80)
	RCALL SUBOPT_0x58
; 0000 049D        delay_ms(120);
; 0000 049E        shift_in('_',0);
	LDI  R30,LOW(95)
	RCALL SUBOPT_0x58
; 0000 049F        delay_ms(120);
; 0000 04A0        shift_in('I',0);
	RCALL SUBOPT_0x7D
; 0000 04A1        delay_ms(120);
; 0000 04A2        shift_in('M',0);
	RCALL SUBOPT_0x7E
; 0000 04A3        delay_ms(120);
; 0000 04A4        shift_in('P',0);
	LDI  R30,LOW(80)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x7F
; 0000 04A5        delay_ms(220);
; 0000 04A6        scroll=0;
	RCALL SUBOPT_0x5D
; 0000 04A7        }
; 0000 04A8    check_key();
_0x488:
	RCALL _check_key
; 0000 04A9 if (key_2_pressed)
	SBRS R5,1
	RJMP _0x489
; 0000 04AA     {
; 0000 04AB         impulse_pump_def++;
	RCALL SUBOPT_0x23
	SUBI R30,-LOW(1)
	RCALL __EEPROMWRB
	SUBI R30,LOW(1)
; 0000 04AC         if(impulse_pump_def>25)impulse_pump_def=2;
	RCALL SUBOPT_0x23
	CPI  R30,LOW(0x1A)
	BRLO _0x48A
	LDI  R26,LOW(_impulse_pump_def)
	LDI  R27,HIGH(_impulse_pump_def)
	LDI  R30,LOW(2)
	RCALL __EEPROMWRB
; 0000 04AD     key_2_pressed=0;
_0x48A:
	RCALL SUBOPT_0x7B
; 0000 04AE    }
; 0000 04AF             set_char_at(((impulse_pump_def%100)/10), 2,0);
_0x489:
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x8A
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 04B0             set_char_at((impulse_pump_def%10), 3,0);
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x8B
	RCALL SUBOPT_0x64
	RCALL _set_char_at
; 0000 04B1         #asm("wdr")
	wdr
; 0000 04B2         }
; 0000 04B3 
; 0000 04B4 }  //
_0x487:
_0x486:
_0x481:
_0x479:
_0x471:
_0x46C:
_0x466:
_0x447:
; 0000 04B5   } else display=0;
	RJMP _0x48B
_0x415:
	RCALL SUBOPT_0x79
; 0000 04B6 
; 0000 04B7 //       -    .  .
; 0000 04B8 if ((counted)||((rad_interval<37)&&(rad_cnt>7))) alarm_check();
_0x48B:
	SBRC R2,0
	RJMP _0x48D
	LDI  R30,LOW(37)
	LDI  R31,HIGH(37)
	CP   R8,R30
	CPC  R9,R31
	BRSH _0x48E
	RCALL SUBOPT_0x2E
	SBIW R26,8
	BRSH _0x48D
_0x48E:
	RJMP _0x48C
_0x48D:
	RCALL _alarm_check
; 0000 04B9 
; 0000 04BA #asm("wdr");
_0x48C:
	wdr
; 0000 04BB      pump();
	RCALL _pump
; 0000 04BC #asm("wdr");
	wdr
; 0000 04BD 
; 0000 04BE 
; 0000 04BF 
; 0000 04C0 } // ON
; 0000 04C1 // else poweroff();
; 0000 04C2 if ((!display)&(!alarm))
_0x413:
	RCALL SUBOPT_0x1A
	RCALL __LNEGW1
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,5
	LDI  R30,1
	AND  R30,R26
	BREQ _0x491
; 0000 04C3         {
; 0000 04C4         clearDisplay();
	RCALL _clearDisplay
; 0000 04C5         clearDisplayBuffer();
	RCALL _clearDisplayBuffer
; 0000 04C6         #asm("wdr");
	wdr
; 0000 04C7         #asm("sleep");
	sleep
; 0000 04C8         }
; 0000 04C9 
; 0000 04CA  }
_0x491:
	RJMP _0x40B
; 0000 04CB }
_0x492:
	RJMP _0x492
;
;//-------------------------------------------
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.ESEG
_delay_pump_def:
	.DB  0x12
_impulse_pump_def:
	.DB  0xA
_time_to_display:
	.DB  0x3C,0x0
_alarm_level:
	.DB  0x3C,0x0

	.DSEG
_rad_massive:
	.BYTE 0x120
_rad_hour:
	.BYTE 0x2
_fulldoze:
	.BYTE 0x4
_rad_cnt:
	.BYTE 0x2
_fon_hour_approx:
	.BYTE 0x2
_sutki:
	.BYTE 0x2
_hours:
	.BYTE 0x1
_minutes:
	.BYTE 0x1
_doze:
	.BYTE 0x4
_day_doze:
	.BYTE 0x4
_impulse_pump:
	.BYTE 0x2
_delay_pump:
	.BYTE 0x2
_s:
	.BYTE 0x2
_x:
	.BYTE 0x2
_iv:
	.BYTE 0x2
_ivc:
	.BYTE 0x2
_peak:
	.BYTE 0x2
_rcnt:
	.BYTE 0x2

	.ESEG

	.ORG 0x10
_wdt_error:
	.BYTE 0x2

	.ORG 0x6

	.DSEG
_tem:
	.BYTE 0x4
_display:
	.BYTE 0x2
_second:
	.BYTE 0x1
_second_tick:
	.BYTE 0x1
_minute_tick:
	.BYTE 0x1
_hour_tick:
	.BYTE 0x1
_menu_select:
	.BYTE 0x1
_beep_on_pulse:
	.BYTE 0x1
_vib_on_pulse:
	.BYTE 0x1
_search_imp:
	.BYTE 0x2
_key_press:
	.BYTE 0x2
_VoltLevel:
	.BYTE 0x2
_alarm_cnt:
	.BYTE 0x1
_test_fon_counter:
	.BYTE 0x2
_test_fon:
	.BYTE 0x2
_test_fon_timer:
	.BYTE 0x1
_display_time:
	.BYTE 0x2
_error_count:
	.BYTE 0x1
_mode_counter:
	.BYTE 0x1
_data:
	.BYTE 0x4
_dot:
	.BYTE 0x8
_multiplex_counter:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x0:
	SBI  0x18,5
	SBI  0x18,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1:
	SBI  0x15,3
	SBI  0x15,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2:
	SBI  0x15,4
	SBI  0x18,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3:
	CBI  0x18,5
	SBI  0x18,1
	SBI  0x15,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	CBI  0x15,3
	SBI  0x15,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5:
	SBI  0x15,4
	CBI  0x18,4
	SBI  0x15,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	CBI  0x15,5
	CBI  0x15,4
	SBI  0x18,4
	SBI  0x15,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7:
	SBI  0x18,5
	CBI  0x18,1
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	CBI  0x15,4
	SBI  0x18,4
	SBI  0x15,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	CBI  0x15,5
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xA:
	CBI  0x18,5
	CBI  0x18,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	CBI  0x18,5
	SBI  0x18,1
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	CBI  0x15,3
	CBI  0x15,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	STD  Z+0,R26
	STD  Z+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	RCALL SUBOPT_0xE
	LDI  R26,LOW(_dot)
	LDI  R27,HIGH(_dot)
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x10:
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x12:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x13:
	LDS  R26,_multiplex_counter
	LDS  R27,_multiplex_counter+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 143 TIMES, CODE SIZE REDUCTION:140 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 301 TIMES, CODE SIZE REDUCTION:298 WORDS
SUBOPT_0x15:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:44 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:36 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x19:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	LDS  R30,_display
	LDS  R31,_display+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x1B:
	LDI  R26,LOW(_alarm_level)
	LDI  R27,HIGH(_alarm_level)
	RCALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,6
	LDI  R30,1
	AND  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1D:
	SBI  0x18,0
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _display,R30
	STS  _display+1,R31
	SET
	BLD  R2,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	CLT
	BLD  R3,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1F:
	CLT
	BLD  R3,4
	BLD  R2,7
	BLD  R3,0
	BLD  R3,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	SET
	BLD  R3,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x21:
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x22:
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x23:
	LDI  R26,LOW(_impulse_pump_def)
	LDI  R27,HIGH(_impulse_pump_def)
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x24:
	MOV  R26,R30
	MOVW R30,R18
	LDI  R27,0
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x25:
	STS  _impulse_pump,R30
	STS  _impulse_pump+1,R31
	LDI  R26,LOW(_delay_pump_def)
	LDI  R27,HIGH(_delay_pump_def)
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x26:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x27:
	SBI  0x18,0
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	RCALL SUBOPT_0x15
	RCALL _delay_ms
	CBI  0x18,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 94 TIMES, CODE SIZE REDUCTION:91 WORDS
SUBOPT_0x28:
	RCALL SUBOPT_0x15
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x29:
	SBI  0x18,0
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	CBI  0x18,0
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	STS  _VoltLevel,R30
	STS  _VoltLevel+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2C:
	LDS  R30,_rad_cnt
	LDS  R31,_rad_cnt+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2D:
	LDI  R26,LOW(_rad_massive)
	LDI  R27,HIGH(_rad_massive)
	LSL  R30
	ROL  R31
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2E:
	LDS  R26,_rad_cnt
	LDS  R27,_rad_cnt+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x2F:
	LDI  R30,LOW(0)
	STS  _rad_cnt,R30
	STS  _rad_cnt+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x30:
	LDS  R26,_test_fon
	LDS  R27,_test_fon+1
	CPI  R26,LOW(0x47)
	LDI  R30,HIGH(0x47)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x31:
	CLT
	BLD  R2,0
	RJMP SUBOPT_0x2F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x32:
	LDS  R26,_test_fon
	LDS  R27,_test_fon+1
	CPI  R26,LOW(0x65)
	LDI  R30,HIGH(0x65)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x33:
	CP   R30,R8
	CPC  R31,R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x34:
	MOVW R8,R30
	RJMP SUBOPT_0x31

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x35:
	LDS  R26,_test_fon
	LDS  R27,_test_fon+1
	CPI  R26,LOW(0x1F5)
	LDI  R30,HIGH(0x1F5)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x36:
	LDS  R30,_second_tick
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	LDS  R26,_fon_hour_approx
	LDS  R27,_fon_hour_approx+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x38:
	LDS  R30,_minute_tick
	SUBI R30,-LOW(1)
	STS  _minute_tick,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x39:
	LDS  R26,_minute_tick
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3A:
	LDS  R26,_rad_hour
	LDS  R27,_rad_hour+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3B:
	LDS  R30,_hour_tick
	SUBI R30,-LOW(1)
	STS  _hour_tick,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3C:
	LDS  R26,_hour_tick
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3D:
	LDI  R30,LOW(0)
	STS  _rad_hour,R30
	STS  _rad_hour+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3E:
	LDS  R26,_display_time
	LDS  R27,_display_time+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3F:
	STS  _display_time,R30
	STS  _display_time+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x40:
	LDI  R26,LOW(_time_to_display)
	LDI  R27,HIGH(_time_to_display)
	RCALL __EEPROMRDW
	ADIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	LDI  R30,0
	SBRS R3,3
	LDI  R30,1
	AND  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x42:
	CLT
	BLD  R3,5
	LDI  R30,LOW(0)
	STS  _menu_select,R30
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x43:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x44:
	LDI  R30,LOW(0)
	STS  _display_time,R30
	STS  _display_time+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x45:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _display,R30
	STS  _display+1,R31
	RJMP SUBOPT_0x44

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x46:
	RCALL _clearDisplayBuffer
	RCALL _clearDisplay
	LDI  R30,LOW(320)
	LDI  R31,HIGH(320)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x47:
	ST   -Y,R30
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	RCALL _shift_in
	LDI  R30,LOW(320)
	LDI  R31,HIGH(320)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x48:
	SET
	BLD  R4,1
	LDI  R30,LOW(0)
	STS  _display,R30
	STS  _display+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x49:
	LDI  R30,LOW(0)
	STS  _iv,R30
	STS  _iv+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x4A:
	LDI  R30,LOW(0)
	STS  _ivc,R30
	STS  _ivc+1,R30
	STS  _peak,R30
	STS  _peak+1,R30
	STS  _rcnt,R30
	STS  _rcnt+1,R30
	CLR  R10
	CLR  R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4B:
	LDI  R30,LOW(0)
	STS  _x,R30
	STS  _x+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4C:
	LDS  R26,_x
	LDS  R27,_x+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4D:
	LDS  R30,_x
	LDS  R31,_x+1
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4E:
	LDS  R26,_peak
	LDS  R27,_peak+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4F:
	LDS  R26,_rcnt
	LDS  R27,_rcnt+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x50:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x51:
	ST   -Y,R30
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x52:
	LDS  R26,_menu_select
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x53:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x54:
	CLR  R22
	CLR  R23
	STS  _tem,R30
	STS  _tem+1,R31
	STS  _tem+2,R22
	STS  _tem+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x55:
	RCALL _clearDisplayBuffer
	RJMP _clearDisplay

;OPTIMIZER ADDED SUBROUTINE, CALLED 55 TIMES, CODE SIZE REDUCTION:106 WORDS
SUBOPT_0x56:
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x57:
	LDI  R30,LOW(84)
	ST   -Y,R30
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	RCALL _shift_in
	RJMP SUBOPT_0x56

;OPTIMIZER ADDED SUBROUTINE, CALLED 46 TIMES, CODE SIZE REDUCTION:178 WORDS
SUBOPT_0x58:
	ST   -Y,R30
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	RCALL _shift_in
	RJMP SUBOPT_0x56

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x59:
	LDI  R30,LOW(42)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5A:
	LDI  R30,LOW(83)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x5B:
	ST   -Y,R30
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5C:
	RCALL _shift_in
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5D:
	CLT
	BLD  R3,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES, CODE SIZE REDUCTION:145 WORDS
SUBOPT_0x5E:
	LDS  R26,_tem
	LDS  R27,_tem+1
	LDS  R24,_tem+2
	LDS  R25,_tem+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5F:
	__CPD2N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x60:
	LDI  R30,LOW(45)
	RJMP SUBOPT_0x5B

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x61:
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	RCALL _set_char_at
	LDI  R30,LOW(45)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x62:
	ST   -Y,R30
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x63:
	ST   -Y,R30
	RJMP SUBOPT_0x18

;OPTIMIZER ADDED SUBROUTINE, CALLED 46 TIMES, CODE SIZE REDUCTION:43 WORDS
SUBOPT_0x64:
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x65:
	RCALL SUBOPT_0x5E
	__GETD1N 0x3E8
	RCALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x66:
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:53 WORDS
SUBOPT_0x67:
	RCALL SUBOPT_0x5E
	__GETD1N 0x3E8
	RCALL __MODD21U
	RCALL SUBOPT_0x66
	__GETD1N 0x64
	RCALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x68:
	RCALL SUBOPT_0x66
	RCALL __CPD02
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x69:
	RCALL SUBOPT_0x5E
	__GETD1N 0x64
	RCALL __MODD21U
	RCALL SUBOPT_0x66
	__GETD1N 0xA
	RCALL __DIVD21U
	RJMP SUBOPT_0x62

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6A:
	RCALL _set_char_at
	RCALL SUBOPT_0x5E
	__GETD1N 0xA
	RCALL __MODD21U
	RJMP SUBOPT_0x63

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6B:
	__GETD1N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6C:
	LDI  R30,LOW(69)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x6D:
	RCALL _shift_in
	LDI  R30,LOW(180)
	LDI  R31,HIGH(180)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6E:
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	RCALL SUBOPT_0x50
	RCALL __MODW21U
	MOVW R26,R30
	RJMP SUBOPT_0x53

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6F:
	MOVW R26,R30
	RCALL __CPW02
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x70:
	LDS  R26,_sutki
	LDS  R27,_sutki+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x71:
	RCALL SUBOPT_0x3C
	LDI  R30,LOW(100)
	RCALL __MODB21U
	MOV  R26,R30
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	RJMP SUBOPT_0x5B

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x72:
	RCALL SUBOPT_0x36
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x73:
	RCALL SUBOPT_0x3C
	LDI  R30,LOW(10)
	RCALL __MODB21U
	RJMP SUBOPT_0x51

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x74:
	RCALL SUBOPT_0x39
	LDI  R30,LOW(100)
	RCALL __MODB21U
	MOV  R26,R30
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	RJMP SUBOPT_0x62

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x75:
	RCALL _set_char_at
	RCALL SUBOPT_0x39
	LDI  R30,LOW(10)
	RCALL __MODB21U
	RJMP SUBOPT_0x63

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x76:
	RCALL SUBOPT_0x50
	RCALL __MODW21U
	MOVW R26,R30
	RJMP SUBOPT_0x53

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x77:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x78:
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x6B
	RCALL __MODD21U
	RCALL SUBOPT_0x66
	__GETD1N 0xA
	RCALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x79:
	LDI  R30,LOW(0)
	STS  _display,R30
	STS  _display+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7A:
	LDS  R30,_beep_on_pulse
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7B:
	CLT
	BLD  R5,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7C:
	LDS  R26,_search_imp
	LDS  R27,_search_imp+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7D:
	LDI  R30,LOW(73)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7E:
	LDI  R30,LOW(77)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7F:
	RCALL _shift_in
	LDI  R30,LOW(220)
	LDI  R31,HIGH(220)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x80:
	LDI  R26,LOW(_time_to_display)
	LDI  R27,HIGH(_time_to_display)
	RCALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x81:
	MOVW R22,R30
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x82:
	RCALL __GEW12
	MOV  R0,R30
	MOVW R26,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x83:
	RCALL __LTW12
	AND  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x84:
	LDI  R26,LOW(_time_to_display)
	LDI  R27,HIGH(_time_to_display)
	RCALL SUBOPT_0x43
	RCALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x85:
	RCALL SUBOPT_0x50
	RCALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21
	RJMP SUBOPT_0x51

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x86:
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21
	MOVW R26,R30
	RCALL SUBOPT_0x43
	RCALL __DIVW21
	RJMP SUBOPT_0x62

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x87:
	MOVW R26,R30
	RCALL SUBOPT_0x43
	RCALL __MODW21
	RJMP SUBOPT_0x63

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x88:
	LDI  R26,LOW(_alarm_level)
	LDI  R27,HIGH(_alarm_level)
	RCALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x89:
	LDI  R26,LOW(_delay_pump_def)
	LDI  R27,HIGH(_delay_pump_def)
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8A:
	MOV  R26,R30
	LDI  R30,LOW(100)
	RCALL __MODB21U
	MOV  R26,R30
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	RJMP SUBOPT_0x62

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8B:
	MOV  R26,R30
	LDI  R30,LOW(10)
	RCALL __MODB21U
	RJMP SUBOPT_0x63


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

	.equ __w1_port=0x12
	.equ __w1_bit=0x02

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__GEB12U:
	CP   R26,R30
	LDI  R30,1
	BRSH __GEB12U1
	CLR  R30
__GEB12U1:
	RET

__GEW12:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRGE __GEW12T
	CLR  R30
__GEW12T:
	RET

__LTW12:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLT __LTW12T
	CLR  R30
__LTW12T:
	RET

__GTW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLT __GTW12T
	CLR  R30
__GTW12T:
	RET

__LEW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRSH __LEW12UT
	CLR  R30
__LEW12UT:
	RET

__GEW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRSH __GEW12UT
	CLR  R30
__GEW12UT:
	RET

__LTW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLO __LTW12UT
	CLR  R30
__LTW12UT:
	RET

__GTW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLO __GTW12UT
	CLR  R30
__GTW12UT:
	RET

__LNEGW1:
	OR   R30,R31
	LDI  R30,1
	BREQ __LNEGW1F
	LDI  R30,0
__LNEGW1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
