
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _menu_select=R5
	.DEF _impulse_pump=R6
	.DEF _delay_pump=R8
	.DEF _battery_procent=R4
	.DEF _div_gpaph=R10
	.DEF _need_pump_by_impulse=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _voidadc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_table:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x3E,0x51,0x49,0x45,0x3E,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E,0x0,0x36,0x36,0x0,0x0,0x0
	.DB  0x56,0x36,0x0,0x0,0x8,0x14,0x22,0x41
	.DB  0x0,0x14,0x14,0x14,0x14,0x14,0x0,0x41
	.DB  0x22,0x14,0x8,0x2,0x1,0x51,0x9,0x6
	.DB  0x32,0x49,0x79,0x41,0x3E,0x7E,0x11,0x11
	.DB  0x11,0x7E,0x7F,0x49,0x49,0x49,0x36,0x3E
	.DB  0x41,0x41,0x41,0x22,0x7F,0x41,0x41,0x22
	.DB  0x1C,0x7F,0x49,0x49,0x49,0x41,0x7F,0x9
	.DB  0x9,0x9,0x1,0x3E,0x41,0x49,0x49,0x7A
	.DB  0x7F,0x8,0x8,0x8,0x7F,0x0,0x41,0x7F
	.DB  0x41,0x0,0x20,0x40,0x41,0x3F,0x1,0x7F
	.DB  0x8,0x14,0x22,0x41,0x7F,0x40,0x40,0x40
	.DB  0x40,0x7F,0x2,0xC,0x2,0x7F,0x7F,0x4
	.DB  0x8,0x10,0x7F,0x3E,0x41,0x41,0x41,0x3E
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x51
	.DB  0x21,0x5E,0x7F,0x9,0x19,0x29,0x46,0x46
	.DB  0x49,0x49,0x49,0x31,0x1,0x1,0x7F,0x1
	.DB  0x1,0x3F,0x40,0x40,0x40,0x3F,0x1F,0x20
	.DB  0x40,0x20,0x1F,0x3F,0x40,0x38,0x40,0x3F
	.DB  0x63,0x14,0x8,0x14,0x63,0x7,0x8,0x70
	.DB  0x8,0x7,0x61,0x51,0x49,0x45,0x43,0x0
	.DB  0x7F,0x41,0x41,0x0,0x2,0x4,0x8,0x10
	.DB  0x20,0x0,0x41,0x41,0x7F,0x0,0x4,0x2
	.DB  0x1,0x2,0x4,0x40,0x40,0x40,0x40,0x40
	.DB  0x0,0x1,0x2,0x4,0x0,0x20,0x54,0x54
	.DB  0x54,0x78,0x7F,0x48,0x44,0x44,0x38,0x38
	.DB  0x44,0x44,0x44,0x20,0x38,0x44,0x44,0x48
	.DB  0x7F,0x38,0x54,0x54,0x54,0x18,0x8,0x7E
	.DB  0x9,0x1,0x2,0xC,0x52,0x52,0x52,0x3E
	.DB  0x7F,0x8,0x4,0x4,0x78,0x0,0x44,0x7D
	.DB  0x40,0x0,0x20,0x40,0x44,0x3D,0x0,0x7F
	.DB  0x10,0x28,0x44,0x0,0x0,0x41,0x7F,0x40
	.DB  0x0,0x7C,0x4,0x18,0x4,0x78,0x7C,0x8
	.DB  0x4,0x4,0x78,0x38,0x44,0x44,0x44,0x38
	.DB  0x7C,0x14,0x14,0x14,0x8,0x8,0x14,0x14
	.DB  0x18,0x7C,0x7C,0x8,0x4,0x4,0x8,0x8
	.DB  0x54,0x54,0x54,0x20,0x4,0x3F,0x44,0x40
	.DB  0x20,0x3C,0x40,0x40,0x20,0x7C,0x1C,0x20
	.DB  0x40,0x20,0x1C,0x3C,0x40,0x30,0x40,0x3C
	.DB  0x44,0x28,0x10,0x28,0x44,0xC,0x50,0x50
	.DB  0x50,0x3C,0x44,0x64,0x54,0x4C,0x44,0x0
	.DB  0x8,0x36,0x41,0x0,0x0,0x0,0x7F,0x0
	.DB  0x0,0x0,0x41,0x36,0x8,0x0,0x10,0x8
	.DB  0x8,0x10,0x8,0x78,0x46,0x41,0x46,0x78
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x6,0x9,0x9,0x6,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E,0x0,0x36,0x36,0x0,0x0,0x0
	.DB  0x56,0x36,0x0,0x0,0x8,0x14,0x22,0x41
	.DB  0x0,0x14,0x14,0x14,0x14,0x14,0x0,0x41
	.DB  0x22,0x14,0x8,0x2,0x1,0x51,0x9,0x6
	.DB  0x7E,0x11,0x11,0x11,0x7E,0x7F,0x49,0x49
	.DB  0x49,0x31,0x7F,0x49,0x49,0x49,0x36,0x7F
	.DB  0x1,0x1,0x1,0x3,0x60,0x3E,0x21,0x21
	.DB  0x7F,0x7F,0x49,0x49,0x49,0x41,0x77,0x8
	.DB  0x7F,0x8,0x77,0x22,0x41,0x49,0x49,0x36
	.DB  0x7F,0x10,0x8,0x4,0x7F,0x7F,0x10,0x9
	.DB  0x4,0x7F,0x7F,0x8,0x14,0x22,0x41,0x40
	.DB  0x3E,0x1,0x1,0x7F,0x7F,0x2,0xC,0x2
	.DB  0x7F,0x7F,0x8,0x8,0x8,0x7F,0x3E,0x41
	.DB  0x41,0x41,0x3E,0x7F,0x1,0x1,0x1,0x7F
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x41
	.DB  0x41,0x22,0x1,0x1,0x7F,0x1,0x1,0x27
	.DB  0x48,0x48,0x48,0x3F,0x1E,0x21,0x7F,0x21
	.DB  0x1E,0x63,0x14,0x8,0x14,0x63,0x3F,0x20
	.DB  0x20,0x3F,0x60,0x7,0x8,0x8,0x8,0x7F
	.DB  0x7F,0x40,0x7F,0x40,0x7F,0x3F,0x20,0x3F
	.DB  0x20,0x7F,0x1,0x7F,0x48,0x48,0x30,0x7F
	.DB  0x48,0x30,0x0,0x7F,0x0,0x7F,0x48,0x48
	.DB  0x30,0x22,0x41,0x49,0x49,0x3E,0x7F,0x8
	.DB  0x3E,0x41,0x3E,0x46,0x29,0x19,0x9,0x7F
	.DB  0x20,0x54,0x54,0x54,0x78,0x3C,0x4A,0x4A
	.DB  0x4A,0x30,0x7C,0x54,0x54,0x28,0x0,0x7C
	.DB  0x4,0x4,0x4,0x4,0x60,0x38,0x24,0x24
	.DB  0x7C,0x38,0x54,0x54,0x54,0x18,0x6C,0x10
	.DB  0x7C,0x10,0x6C,0x0,0x44,0x54,0x54,0x28
	.DB  0x7C,0x20,0x10,0x8,0x7C,0x7C,0x21,0x12
	.DB  0x9,0x7C,0x7C,0x10,0x28,0x44,0x0,0x40
	.DB  0x38,0x4,0x4,0x7C,0x7C,0x8,0x10,0x8
	.DB  0x7C,0x7C,0x10,0x10,0x10,0x7C,0x38,0x44
	.DB  0x44,0x44,0x38,0x7C,0x4,0x4,0x4,0x7C
	.DB  0x7C,0x14,0x14,0x14,0x8,0x38,0x44,0x44
	.DB  0x44,0x0,0x4,0x4,0x7C,0x4,0x4,0xC
	.DB  0x50,0x50,0x50,0x3C,0x8,0x14,0x7C,0x14
	.DB  0x8,0x44,0x28,0x10,0x28,0x44,0x3C,0x20
	.DB  0x20,0x3C,0x60,0xC,0x10,0x10,0x10,0x7C
	.DB  0x7C,0x40,0x7C,0x40,0x7C,0x3C,0x20,0x3C
	.DB  0x20,0x7C,0x4,0x7C,0x50,0x50,0x20,0x7C
	.DB  0x50,0x20,0x0,0x7C,0x0,0x7C,0x50,0x50
	.DB  0x20,0x28,0x44,0x54,0x54,0x38,0x7C,0x10
	.DB  0x38,0x44,0x38,0x48,0x54,0x34,0x14,0x7C
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0xC000

_0x3:
	.DB  0x3
_0x4:
	.DB  0x3
_0x5:
	.DB  0x2
_0x6:
	.DB  0x5
_0x1A0:
	.DB  0x0,0x1,0x0,0x0,0x0,0x0,0xA,0x0
	.DB  0x0,0x0
_0x0:
	.DB  0x20,0x20,0xC2,0xFB,0xEA,0xEB,0xFE,0xF7
	.DB  0xE5,0xED,0xE8,0xE5,0x20,0x20,0x0,0x20
	.DB  0x20,0xC2,0xEA,0xEB,0xFE,0xF7,0xE5,0xED
	.DB  0xE8,0xE5,0x20,0x20,0x20,0x0,0x20,0x20
	.DB  0x20,0x20,0x20,0xCC,0xE5,0xED,0xFE,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0xD2,0xF0,0xE5
	.DB  0xE2,0xEE,0xE3,0xE0,0x20,0x20,0xEE,0xF2
	.DB  0xEA,0xEB,0x2E,0x0,0xD2,0xF0,0xE5,0xE2
	.DB  0xEE,0xE3,0xE0,0x25,0x34,0x75,0xEC,0xEA
	.DB  0xD0,0x0,0xD1,0xEE,0xED,0x20,0x20,0x20
	.DB  0x20,0x25,0x34,0x75,0xF1,0xE5,0xEA,0x0
	.DB  0xCA,0xEE,0xED,0xF2,0xF0,0xE0,0xF1,0xF2
	.DB  0x20,0x20,0x25,0x33,0x75,0x25,0x25,0x0
	.DB  0xCD,0xE0,0xEA,0xE0,0xF7,0xEA,0xE0,0x20
	.DB  0x25,0x33,0x75,0xE8,0xEC,0xEF,0x0,0x25
	.DB  0x35,0x75,0x0,0xEC,0xEA,0xD0,0xF7,0x0
	.DB  0xC4,0xEE,0xE7,0xE0,0x25,0x35,0x75,0x75
	.DB  0x53,0x76,0x0,0x25,0x30,0x32,0x75,0x64
	.DB  0x20,0x25,0x30,0x32,0x75,0x3A,0x25,0x30
	.DB  0x32,0x75,0x3A,0x25,0x30,0x32,0x75,0x0
	.DB  0x20,0x20,0x20,0xCC,0xE8,0xEA,0xF0,0xEE
	.DB  0xED,0x2D,0x32,0x20,0x20,0x20,0x0,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x46
	.DB  0x57,0x3A,0x31,0x2E,0x30,0x0,0x20,0x20
	.DB  0x20,0x20,0x20,0x62,0x79,0x20,0x53,0x68
	.DB  0x6F,0x64,0x61,0x6E,0x0,0xC7,0xE0,0xE3
	.DB  0xF0,0xF3,0xE7,0xEA,0xE0,0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _temp_control
	.DW  _0x3*2

	.DW  0x01
	.DW  _bias
	.DW  _0x4*2

	.DW  0x01
	.DW  _disp_config
	.DW  _0x5*2

	.DW  0x01
	.DW  _shift
	.DW  _0x6*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x1A0*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#define nusik_fix
;
;#define blink_led_on_pulse //   
;//#define blink_led_on_work  //   
;
;#define impulse_pump_def 13         //              (330 )
;#define delay_pump_timeout 1        //      
;//#define delay_pump_def 100          //           (330 )
;
;eeprom int delay_pump_def=140;     //           (330 )
;//eeprom int volt_max=1500;          //   
;eeprom int sleep_time=30;          //    
;eeprom int alarm_level=50;         //     
;eeprom unsigned char Vop = 80;     //  
;
;char menu_select=1;
;bit menu_active=0;
;
;unsigned int impulse_pump;
;unsigned int delay_pump;
;
;unsigned char battery_procent=0;
;
;unsigned int div_gpaph=10;
;
;bit need_pump=0;
;unsigned int need_pump_by_impulse=0;
;unsigned char tick=0, second=0;
;unsigned long impulse_count=0,doze_count=0;
;
;unsigned char second_tick=0;
;unsigned char minute_tick=0;
;unsigned char hour_tick=0;
;unsigned int day_tick=0;
;
;unsigned int impulse_massive[38];
;unsigned long doze_massive[25];
;
;unsigned int key_press=0;
;
;unsigned int VoltLevel=0;
;
;bit alarm=0;
;bit user_cancel_alarm=0;
;
;bit impulse_recive=0;
;
;//bit ready=0;
;
;int display_time=0;
;
;char error_count=0;
;unsigned char beep_count=0;
;
;bit beep=0;
;bit beep_active=0;
;bit poweroff_bit=0;
;
;bit need_update=0;
;
;void led_refresh(char command);
;
;#define ON  1
;#define OFF  2
;#define NONE  3
;
;#define blue_led_pin  PORTD.5
;#define red_led_pin   PORTD.0
;#define beep_pin      PORTC.1
;#define trans         PORTD.1
;#define key           PIND.2 //(int0)
;#define key_plus      PINC.2 //(key +)
;#define impulse       PIND.3 //(int1)
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;
;#include <n3310lcd.c>
;/**********************************************
;****************PCD8544 Driver*****************
;***********************************************
;
;for original NOKIA 3310 & alternative "chinese" version of display
;
;48x84 dots, 6x14 symbols
;
;**********************************************/
;
;#define china 1		//   -    "" ,  - 
;#define SOFT_SPI 1	//   -   SPI,  - 
;#define reverse_display
;
;#ifndef SOFT_SPI
;static unsigned char SPCR_val = 0x50;	// 
;unsigned char SPSR_val = 0x01;  //  
;#endif
;
;
;#define power_of_display PORTC.0
;#define power_of_display_ddr DDRC.0
;
;//LCD Port & pinout setup. :   ""  (  G  ..)  
;#define LCD_DC_PORT  	PORTB	//  -;    
;#define LCD_DC_DDR 	DDRB
;#define LCD_DC_PIN 	4
;
;#define LCD_CPORT 	PORTB	// Chip-Select;    
;#define LCD_CDDR   	DDRB
;#define LCD_CPIN    	2
;
;#define LCD_RST_PORT 	PORTC	//  ;    
;#define LCD_RST_DDR   	DDRC
;#define LCD_RST_PIN   	3
;
;#define LCD_MOSI_PORT 	PORTB	//   SPI,      SPI,   
;#define LCD_MOSI_DDR	DDRB
;#define LCD_MOSI_PIN    3
;
;#define LCD_CLK_PORT	PORTB	//  SPI,      SPI,   
;#define LCD_CLK_DDR     DDRB
;#define LCD_CLK_PIN     5
;
;#ifndef SOFT_SPI
;#define LCD_SS_PORT	PORTB	// ChipSelect SPI,      SPI    
;#define LCD_SS_DDR     	DDRB
;#define LCD_SS_PIN     	2
;#endif
;
;//***********************************************************
;//        
;//***********************************************************
;
;#pragma used+
;
;unsigned char lcd_buf[15];		//     LCD
;
;bit power_down = 0;			//power-down control: 0 - chip is active, 1 - chip is in PD-mode
;bit addressing = 0;			// : 0 - , 1- 
;//bit instuct_set = 0;			// : 0 - , 1 -  -     
;
;#ifdef china
;bit x_mirror = 0;			//  X: 0 - ., 1 - .
;bit y_mirror = 0;			//  Y: 0 - ., 1 - .
;bit SPI_invert = 0;			//   SPI: 0 - MSB first, 1 - LSB first
;#endif
;
;//unsigned char set_y;			//  , 0..5 -     
;//unsigned char set_x;                 	//  , 0..83 -     
;unsigned char temp_control = 3;  	// , 0..3

	.DSEG
;unsigned char bias = 3;                 //, 0..7
;//unsigned char Vop = 80;			//  LCD, 0..127 ( )
;unsigned char disp_config = 2;		// : 0 - blank, 1 - all on, 2 - normal, 3 - inverse
;
;
;
;#ifdef china
;unsigned char shift = 5;		//0..3F -   ,  
;#endif
;
;#define PIXEL_OFF	0		//   -    
;#define PIXEL_ON	1
;#define PIXEL_XOR	2
;
;#define LCD_X_RES               84	// 
;#define LCD_Y_RES               48
;#define LCD_CACHSIZE          LCD_X_RES*LCD_Y_RES/8
;
;#define Cntr_X_RES              102    	//  -  -  ))
;#define Cntr_Y_RES              64
;#define Cntr_buf_size           Cntr_X_RES*Cntr_Y_RES/8
;
;unsigned char  LcdCache [LCD_CACHSIZE];	//Cache buffer in SRAM 84*48 bits or 504 bytes
;unsigned int   LcdCacheIdx;              	//Cache index
;
;#define LCD_CMD         0
;#define LCD_DATA        1
;
;//***************************************************
;//**************** ******************
;//***************************************************
;void LcdSend (unsigned char data, unsigned char cmd);    			//Sends data to display controller
;void LcdUpdate (void);   							//Copies the LCD cache into the device RAM
;void LcdClear (void);    							//Clears the display
;void LcdInit ( void );								// SPI  
;void LcdContrast (unsigned char contrast); 					//contrast -> Contrast value from 0x00 to 0x7F
;void LcdMode (unsigned char mode); 						// : 0 - blank, 1 - all on, 2 - normal, 3 - inverse
;void LcdPwrMode (void);								//  / 
;void LcdPwrOff (void);								// 
;void LcdPwrOn (void);								// 
;void LcdImage (flash unsigned char *imageData);					// 
;void LcdPixel (unsigned char x, unsigned char y, unsigned char mode);     	//Displays a pixel at given absolute (x, y) location, mode -> Off, On or Xor
;void LcdLine (int x1, int y1, int x2, int y2, unsigned char mode);  		//Draws a line between two points on the display
;void LcdCircle(char x, char y, char radius, unsigned char mode);		//      
;void LcdBatt(int x1, int y1, int x2, int y2, unsigned char persent);		//      %
;void LcdGotoXYFont (unsigned char x, unsigned char y);   			//Sets cursor location to xy location. Range: 1,1 .. 14,6
;void clean_lcd_buf (void);							//  
;void LcdChr (int ch);								//Displays a character at current cursor location and increment cursor location
;void LcdString (unsigned char x, unsigned char y);				//Displays a string at current cursor location
;void LcdChrBold (int ch);							//    ,   )
;void LcdStringBold (unsigned char x, unsigned char y);				//    
;void LcdChrBig (int ch);							//    , 
;void LcdStringBig (unsigned char x, unsigned char y);				//  
;//***************************************************
;// UPDATE ##1
;void LcdBar(int x1, int y1, int x2, int y2, unsigned char persent);		//  -     ""
;void LcdBarLine(unsigned char line, unsigned char persent);			//  -   
;void LcdStringInv (unsigned char x, unsigned char y);                           //      (  )
;//ASCII
;flash char table[0x0500] =
;{
;0x00, 0x00, 0x00, 0x00, 0x00,// 00
;0x00, 0x00, 0x5F, 0x00, 0x00,// 01
;0x00, 0x07, 0x00, 0x07, 0x00,// 02
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 03
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 04
;0x23, 0x13, 0x08, 0x64, 0x62,// 05
;0x36, 0x49, 0x55, 0x22, 0x50,// 06
;0x00, 0x05, 0x03, 0x00, 0x00,// 07
;0x00, 0x1C, 0x22, 0x41, 0x00,// 08
;0x00, 0x41, 0x22, 0x1C, 0x00,// 09
;0x14, 0x08, 0x3E, 0x08, 0x14,// 0A
;0x08, 0x08, 0x3E, 0x08, 0x08,// 0B
;0x00, 0x50, 0x30, 0x00, 0x00,// 0C
;0x08, 0x08, 0x08, 0x08, 0x08,// 0D
;0x00, 0x60, 0x60, 0x00, 0x00,// 0E
;0x20, 0x10, 0x08, 0x04, 0x02,// 0F
;0x00, 0x00, 0x00, 0x00, 0x00,// 10
;0x00, 0x00, 0x5F, 0x00, 0x00,// 11
;0x00, 0x07, 0x00, 0x07, 0x00,// 12
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 13
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 14
;0x23, 0x13, 0x08, 0x64, 0x62,// 15
;0x36, 0x49, 0x55, 0x22, 0x50,// 16
;0x00, 0x05, 0x03, 0x00, 0x00,// 17
;0x00, 0x1C, 0x22, 0x41, 0x00,// 18
;0x00, 0x41, 0x22, 0x1C, 0x00,// 19
;0x14, 0x08, 0x3E, 0x08, 0x14,// 1A
;0x08, 0x08, 0x3E, 0x08, 0x08,// 1B
;0x00, 0x50, 0x30, 0x00, 0x00,// 1C
;0x08, 0x08, 0x08, 0x08, 0x08,// 1D
;0x00, 0x60, 0x60, 0x00, 0x00,// 1E
;0x20, 0x10, 0x08, 0x04, 0x02,// 1F
;0x00, 0x00, 0x00, 0x00, 0x00,// 20 space
;0x00, 0x00, 0x5F, 0x00, 0x00,// 21 !
;0x00, 0x07, 0x00, 0x07, 0x00,// 22 "
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 23 #
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 24 $
;0x23, 0x13, 0x08, 0x64, 0x62,// 25 %
;0x36, 0x49, 0x55, 0x22, 0x50,// 26 &
;0x00, 0x05, 0x03, 0x00, 0x00,// 27 '
;0x00, 0x1C, 0x22, 0x41, 0x00,// 28 (
;0x00, 0x41, 0x22, 0x1C, 0x00,// 29 )
;0x14, 0x08, 0x3E, 0x08, 0x14,// 2a *
;0x08, 0x08, 0x3E, 0x08, 0x08,// 2b +
;0x00, 0x50, 0x30, 0x00, 0x00,// 2c ,
;0x08, 0x08, 0x08, 0x08, 0x08,// 2d -
;0x00, 0x60, 0x60, 0x00, 0x00,// 2e .
;0x20, 0x10, 0x08, 0x04, 0x02,// 2f /
;0x3E, 0x51, 0x49, 0x45, 0x3E,// 30 0
;0x00, 0x42, 0x7F, 0x40, 0x00,// 31 1
;0x42, 0x61, 0x51, 0x49, 0x46,// 32 2
;0x21, 0x41, 0x45, 0x4B, 0x31,// 33 3
;0x18, 0x14, 0x12, 0x7F, 0x10,// 34 4
;0x27, 0x45, 0x45, 0x45, 0x39,// 35 5
;0x3C, 0x4A, 0x49, 0x49, 0x30,// 36 6
;0x01, 0x71, 0x09, 0x05, 0x03,// 37 7
;0x36, 0x49, 0x49, 0x49, 0x36,// 38 8
;0x06, 0x49, 0x49, 0x29, 0x1E,// 39 9
;0x00, 0x36, 0x36, 0x00, 0x00,// 3a :
;0x00, 0x56, 0x36, 0x00, 0x00,// 3b ;
;0x08, 0x14, 0x22, 0x41, 0x00,// 3c <
;0x14, 0x14, 0x14, 0x14, 0x14,// 3d =
;0x00, 0x41, 0x22, 0x14, 0x08,// 3e >
;0x02, 0x01, 0x51, 0x09, 0x06,// 3f ?
;0x32, 0x49, 0x79, 0x41, 0x3E,// 40 @
;0x7E, 0x11, 0x11, 0x11, 0x7E,// 41 A
;0x7F, 0x49, 0x49, 0x49, 0x36,// 42 B
;0x3E, 0x41, 0x41, 0x41, 0x22,// 43 C
;0x7F, 0x41, 0x41, 0x22, 0x1C,// 44 D
;0x7F, 0x49, 0x49, 0x49, 0x41,// 45 E
;0x7F, 0x09, 0x09, 0x09, 0x01,// 46 F
;0x3E, 0x41, 0x49, 0x49, 0x7A,// 47 G
;0x7F, 0x08, 0x08, 0x08, 0x7F,// 48 H
;0x00, 0x41, 0x7F, 0x41, 0x00,// 49 I
;0x20, 0x40, 0x41, 0x3F, 0x01,// 4a J
;0x7F, 0x08, 0x14, 0x22, 0x41,// 4b K
;0x7F, 0x40, 0x40, 0x40, 0x40,// 4c L
;0x7F, 0x02, 0x0C, 0x02, 0x7F,// 4d M
;0x7F, 0x04, 0x08, 0x10, 0x7F,// 4e N
;0x3E, 0x41, 0x41, 0x41, 0x3E,// 4f O
;0x7F, 0x09, 0x09, 0x09, 0x06,// 50 P
;0x3E, 0x41, 0x51, 0x21, 0x5E,// 51 Q
;0x7F, 0x09, 0x19, 0x29, 0x46,// 52 R
;0x46, 0x49, 0x49, 0x49, 0x31,// 53 S
;0x01, 0x01, 0x7F, 0x01, 0x01,// 54 T
;0x3F, 0x40, 0x40, 0x40, 0x3F,// 55 U
;0x1F, 0x20, 0x40, 0x20, 0x1F,// 56 V
;0x3F, 0x40, 0x38, 0x40, 0x3F,// 57 W
;0x63, 0x14, 0x08, 0x14, 0x63,// 58 X
;0x07, 0x08, 0x70, 0x08, 0x07,// 59 Y
;0x61, 0x51, 0x49, 0x45, 0x43,// 5a Z
;0x00, 0x7F, 0x41, 0x41, 0x00,// 5b [
;0x02, 0x04, 0x08, 0x10, 0x20,// 5c Yen Currency Sign
;0x00, 0x41, 0x41, 0x7F, 0x00,// 5d ]
;0x04, 0x02, 0x01, 0x02, 0x04,// 5e ^
;0x40, 0x40, 0x40, 0x40, 0x40,// 5f _
;0x00, 0x01, 0x02, 0x04, 0x00,// 60 `
;0x20, 0x54, 0x54, 0x54, 0x78,// 61 a
;0x7F, 0x48, 0x44, 0x44, 0x38,// 62 b
;0x38, 0x44, 0x44, 0x44, 0x20,// 63 c
;0x38, 0x44, 0x44, 0x48, 0x7F,// 64 d
;0x38, 0x54, 0x54, 0x54, 0x18,// 65 e
;0x08, 0x7E, 0x09, 0x01, 0x02,// 66 f
;0x0C, 0x52, 0x52, 0x52, 0x3E,// 67 g
;0x7F, 0x08, 0x04, 0x04, 0x78,// 68 h
;0x00, 0x44, 0x7D, 0x40, 0x00,// 69 i
;0x20, 0x40, 0x44, 0x3D, 0x00,// 6a j
;0x7F, 0x10, 0x28, 0x44, 0x00,// 6b k
;0x00, 0x41, 0x7F, 0x40, 0x00,// 6c l
;0x7C, 0x04, 0x18, 0x04, 0x78,// 6d m
;0x7C, 0x08, 0x04, 0x04, 0x78,// 6e n
;0x38, 0x44, 0x44, 0x44, 0x38,// 6f o
;0x7C, 0x14, 0x14, 0x14, 0x08,// 70 p
;0x08, 0x14, 0x14, 0x18, 0x7C,// 71 q
;0x7C, 0x08, 0x04, 0x04, 0x08,// 72 r
;0x08, 0x54, 0x54, 0x54, 0x20,// 73 s
;0x04, 0x3F, 0x44, 0x40, 0x20,// 74 t
;0x3C, 0x40, 0x40, 0x20, 0x7C,// 75 u
;0x1C, 0x20, 0x40, 0x20, 0x1C,// 76 v
;0x3C, 0x40, 0x30, 0x40, 0x3C,// 77 w
;0x44, 0x28, 0x10, 0x28, 0x44,// 78 x
;0x0C, 0x50, 0x50, 0x50, 0x3C,// 79 y
;0x44, 0x64, 0x54, 0x4C, 0x44,// 7a z
;0x00, 0x08, 0x36, 0x41, 0x00,// 7b <
;0x00, 0x00, 0x7F, 0x00, 0x00,// 7c |
;0x00, 0x41, 0x36, 0x08, 0x00,// 7d >
;0x10, 0x08, 0x08, 0x10, 0x08,// 7e Right Arrow ->
;0x78, 0x46, 0x41, 0x46, 0x78,// 7f Left Arrow <-
;0x00, 0x00, 0x00, 0x00, 0x00,// 80
;0x00, 0x00, 0x5F, 0x00, 0x00,// 81
;0x00, 0x07, 0x00, 0x07, 0x00,// 82
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 83
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 84
;0x23, 0x13, 0x08, 0x64, 0x62,// 85
;0x36, 0x49, 0x55, 0x22, 0x50,// 86
;0x00, 0x05, 0x03, 0x00, 0x00,// 87
;0x00, 0x1C, 0x22, 0x41, 0x00,// 88
;0x00, 0x41, 0x22, 0x1C, 0x00,// 89
;0x14, 0x08, 0x3E, 0x08, 0x14,// 8A
;0x08, 0x08, 0x3E, 0x08, 0x08,// 8B
;0x00, 0x50, 0x30, 0x00, 0x00,// 8C
;0x08, 0x08, 0x08, 0x08, 0x08,// 8D
;0x00, 0x60, 0x60, 0x00, 0x00,// 8E
;0x20, 0x10, 0x08, 0x04, 0x02,// 8F
;0x00, 0x00, 0x00, 0x00, 0x00,// 90
;0x00, 0x00, 0x5F, 0x00, 0x00,// 91
;0x00, 0x07, 0x00, 0x07, 0x00,// 92
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 93
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 94
;0x23, 0x13, 0x08, 0x64, 0x62,// 95
;0x36, 0x49, 0x55, 0x22, 0x50,// 96
;0x00, 0x05, 0x03, 0x00, 0x00,// 97
;0x00, 0x1C, 0x22, 0x41, 0x00,// 98
;0x00, 0x41, 0x22, 0x1C, 0x00,// 99
;0x14, 0x08, 0x3E, 0x08, 0x14,// 9A
;0x08, 0x08, 0x3E, 0x08, 0x08,// 9B
;0x00, 0x50, 0x30, 0x00, 0x00,// 9C
;0x08, 0x08, 0x08, 0x08, 0x08,// 9D
;0x00, 0x60, 0x60, 0x00, 0x00,// 9E
;0x20, 0x10, 0x08, 0x04, 0x02,// 9F
;0x00, 0x00, 0x00, 0x00, 0x00,// A0
;0x00, 0x00, 0x5F, 0x00, 0x00,// A1
;0x00, 0x07, 0x00, 0x07, 0x00,// A2
;0x14, 0x7F, 0x14, 0x7F, 0x14,// A3
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// A4
;0x23, 0x13, 0x08, 0x64, 0x62,// A5
;0x36, 0x49, 0x55, 0x22, 0x50,// A6
;0x00, 0x05, 0x03, 0x00, 0x00,// A7
;0x00, 0x1C, 0x22, 0x41, 0x00,// A8
;0x00, 0x41, 0x22, 0x1C, 0x00,// A9
;0x14, 0x08, 0x3E, 0x08, 0x14,// AA
;0x08, 0x08, 0x3E, 0x08, 0x08,// AB
;0x00, 0x50, 0x30, 0x00, 0x00,// AC
;0x08, 0x08, 0x08, 0x08, 0x08,// AD
;0x00, 0x60, 0x60, 0x00, 0x00,// AE
;0x20, 0x10, 0x08, 0x04, 0x02,// AF
;//0x3E, 0x51, 0x49, 0x45, 0x3E,// B0
;0x00, 0x06, 0x09, 0x09, 0x06,
;0x00, 0x42, 0x7F, 0x40, 0x00,// B1
;0x42, 0x61, 0x51, 0x49, 0x46,// B2
;0x21, 0x41, 0x45, 0x4B, 0x31,// B3
;0x18, 0x14, 0x12, 0x7F, 0x10,// B4
;0x27, 0x45, 0x45, 0x45, 0x39,// B5
;0x3C, 0x4A, 0x49, 0x49, 0x30,// B6
;0x01, 0x71, 0x09, 0x05, 0x03,// B7
;0x36, 0x49, 0x49, 0x49, 0x36,// B8
;0x06, 0x49, 0x49, 0x29, 0x1E,// B9
;0x00, 0x36, 0x36, 0x00, 0x00,// BA
;0x00, 0x56, 0x36, 0x00, 0x00,// BB
;0x08, 0x14, 0x22, 0x41, 0x00,// BC
;0x14, 0x14, 0x14, 0x14, 0x14,// BD
;0x00, 0x41, 0x22, 0x14, 0x08,// BE
;0x02, 0x01, 0x51, 0x09, 0x06,// BF
;0x7E, 0x11, 0x11, 0x11, 0x7E,// C0 
;0x7F, 0x49, 0x49, 0x49, 0x31,// C1 
;0x7F, 0x49, 0x49, 0x49, 0x36,// C2 
;0x7F, 0x01, 0x01, 0x01, 0x03,// C3 
;0x60, 0x3E, 0x21, 0x21, 0x7F,// C4 
;0x7F, 0x49, 0x49, 0x49, 0x41,// C5 
;0x77, 0x08, 0x7F, 0x08, 0x77,// C6 
;0x22, 0x41, 0x49, 0x49, 0x36,// C7 
;0x7F, 0x10, 0x08, 0x04, 0x7F,// C8 
;0x7F, 0x10, 0x09, 0x04, 0x7F,// C9 
;0x7F, 0x08, 0x14, 0x22, 0x41,// CA 
;0x40, 0x3E, 0x01, 0x01, 0x7F,// CB 
;0x7F, 0x02, 0x0C, 0x02, 0x7F,// CC 
;0x7F, 0x08, 0x08, 0x08, 0x7F,// CD 
;0x3E, 0x41, 0x41, 0x41, 0x3E,// CE 
;0x7F, 0x01, 0x01, 0x01, 0x7F,// CF 
;0x7F, 0x09, 0x09, 0x09, 0x06,// D0 
;0x3E, 0x41, 0x41, 0x41, 0x22,// D1 
;0x01, 0x01, 0x7F, 0x01, 0x01,// D2 
;0x27, 0x48, 0x48, 0x48, 0x3F,// D3 
;0x1E, 0x21, 0x7F, 0x21, 0x1E,// D4 
;0x63, 0x14, 0x08, 0x14, 0x63,// D5 
;0x3F, 0x20, 0x20, 0x3F, 0x60,// D6 
;0x07, 0x08, 0x08, 0x08, 0x7F,// D7 
;0x7F, 0x40, 0x7F, 0x40, 0x7F,// D8 
;0x3F, 0x20, 0x3F, 0x20, 0x7F,// D9 
;0x01, 0x7F, 0x48, 0x48, 0x30,// DA 
;0x7F, 0x48, 0x30, 0x00, 0x7F,// DB 
;0x00, 0x7F, 0x48, 0x48, 0x30,// DC 
;0x22, 0x41, 0x49, 0x49, 0x3E,// DD 
;0x7F, 0x08, 0x3E, 0x41, 0x3E,// DE 
;0x46, 0x29, 0x19, 0x09, 0x7F,// DF 
;0x20, 0x54, 0x54, 0x54, 0x78,// E0 
;0x3C, 0x4A, 0x4A, 0x4A, 0x30,// E1 
;0x7C, 0x54, 0x54, 0x28, 0x00,// E2 
;0x7C, 0x04, 0x04, 0x04, 0x04,// E3 
;0x60, 0x38, 0x24, 0x24, 0x7C,// E4 
;0x38, 0x54, 0x54, 0x54, 0x18,// E5 
;0x6C, 0x10, 0x7C, 0x10, 0x6C,// E6 
;0x00, 0x44, 0x54, 0x54, 0x28,// E7 
;0x7C, 0x20, 0x10, 0x08, 0x7C,// E8 
;0x7C, 0x21, 0x12, 0x09, 0x7C,// E9 
;0x7C, 0x10, 0x28, 0x44, 0x00,// EA 
;0x40, 0x38, 0x04, 0x04, 0x7C,// EB 
;0x7C, 0x08, 0x10, 0x08, 0x7C,// EC 
;0x7C, 0x10, 0x10, 0x10, 0x7C,// ED 
;0x38, 0x44, 0x44, 0x44, 0x38,// EE 
;0x7C, 0x04, 0x04, 0x04, 0x7C,// EF 
;0x7C, 0x14, 0x14, 0x14, 0x08,// F0 
;0x38, 0x44, 0x44, 0x44, 0x00,// F1 
;0x04, 0x04, 0x7C, 0x04, 0x04,// F2 
;0x0C, 0x50, 0x50, 0x50, 0x3C,// F3 
;0x08, 0x14, 0x7C, 0x14, 0x08,// F4 
;0x44, 0x28, 0x10, 0x28, 0x44,// F5 
;0x3C, 0x20, 0x20, 0x3C, 0x60,// F6 
;0x0C, 0x10, 0x10, 0x10, 0x7C,// F7 
;0x7C, 0x40, 0x7C, 0x40, 0x7C,// F8 
;0x3C, 0x20, 0x3C, 0x20, 0x7C,// F9 
;0x04, 0x7C, 0x50, 0x50, 0x20,// FA 
;0x7C, 0x50, 0x20, 0x00, 0x7C,// FB 
;0x00, 0x7C, 0x50, 0x50, 0x20,// FC 
;0x28, 0x44, 0x54, 0x54, 0x38,// FD 
;0x7C, 0x10, 0x38, 0x44, 0x38,// FE 
;0x48, 0x54, 0x34, 0x14, 0x7C // FF 
;};
;
;void LcdSend (unsigned char data, unsigned char cmd)    //Sends data to display controller
; 0000 004F         {

	.CSEG
_LcdSend:
;        #ifdef SOFT_SPI
;        unsigned char i, mask = 128;
;        #endif
;
;        LCD_CPORT.LCD_CPIN = 0;                //Enable display controller (active low)
	RCALL __SAVELOCR2
;	data -> Y+3
;	cmd -> Y+2
;	i -> R17
;	mask -> R16
	LDI  R16,128
	CBI  0x18,2
;        if (cmd) LCD_DC_PORT.LCD_DC_PIN = 1;	//   
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x9
	SBI  0x18,4
;                else LCD_DC_PORT.LCD_DC_PIN = 0;
	RJMP _0xC
_0x9:
	CBI  0x18,4
;        #ifdef SOFT_SPI
;        if(cmd==LCD_DATA)
_0xC:
	LDD  R26,Y+2
	CPI  R26,LOW(0x1)
	BRNE _0xF
;        {
;        #ifdef reverse_display
;        mask = 1;
	LDI  R16,LOW(1)
;        for (i=0;i<8;i++)
	LDI  R17,LOW(0)
_0x11:
	CPI  R17,8
	BRSH _0x12
;        	{
;        	if ((data&mask)!=0) LCD_MOSI_PORT.LCD_MOSI_PIN = 1;
	MOV  R30,R16
	LDD  R26,Y+3
	AND  R30,R26
	BREQ _0x13
	SBI  0x18,3
;                	else LCD_MOSI_PORT.LCD_MOSI_PIN = 0;
	RJMP _0x16
_0x13:
	CBI  0x18,3
;        	mask = mask*2;
_0x16:
	LSL  R16
;        	LCD_CLK_PORT.LCD_CLK_PIN = 1;
	SBI  0x18,5
;                LCD_CLK_PORT.LCD_CLK_PIN = 0;
	CBI  0x18,5
;            }
	SUBI R17,-1
	RJMP _0x11
_0x12:
;        #else
;        for (i=0;i<8;i++)
;        	{
;        	if ((data&mask)!=0) LCD_MOSI_PORT.LCD_MOSI_PIN = 1;
;                	else LCD_MOSI_PORT.LCD_MOSI_PIN = 0;
;        	mask = mask/2;
;        	LCD_CLK_PORT.LCD_CLK_PIN = 1;
;                LCD_CLK_PORT.LCD_CLK_PIN = 0;
;            }
;        #endif
;        }
;        else
	RJMP _0x1D
_0xF:
;        {
;        for (i=0;i<8;i++)
	LDI  R17,LOW(0)
_0x1F:
	CPI  R17,8
	BRSH _0x20
;        	{
;        	if ((data&mask)!=0) LCD_MOSI_PORT.LCD_MOSI_PIN = 1;
	MOV  R30,R16
	LDD  R26,Y+3
	AND  R30,R26
	BREQ _0x21
	SBI  0x18,3
;                	else LCD_MOSI_PORT.LCD_MOSI_PIN = 0;
	RJMP _0x24
_0x21:
	CBI  0x18,3
;        	mask = mask/2;
_0x24:
	MOV  R26,R16
	RCALL SUBOPT_0x0
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL __DIVW21
	MOV  R16,R30
;        	LCD_CLK_PORT.LCD_CLK_PIN = 1;
	SBI  0x18,5
;                LCD_CLK_PORT.LCD_CLK_PIN = 0;
	CBI  0x18,5
;            }
	SUBI R17,-1
	RJMP _0x1F
_0x20:
;        }
_0x1D:
;        #endif
;
;        #ifndef SOFT_SPI
;        SPDR = data;                            //Send data to display controller
;        while ( (SPSR & 0x80) != 0x80 );        //Wait until Tx register empty
;        #endif
;
;        LCD_CPORT.LCD_CPIN = 1;                //Disable display controller
	SBI  0x18,2
;
;        }
	RCALL __LOADLOCR2
	RJMP _0x2060005
;
;void LcdUpdate (void)   //Copies the LCD cache into the device RAM
;        {
_LcdUpdate:
;        int i;
;	#ifdef china
;	char j;
;	#endif
;
;        LcdSend(0x80, LCD_CMD);		//      0,0
	RCALL __SAVELOCR4
;	i -> R16,R17
;	j -> R19
	LDI  R30,LOW(128)
	RCALL SUBOPT_0x1
;        LcdSend(0x40, LCD_CMD);
	LDI  R30,LOW(64)
	RCALL SUBOPT_0x1
;
;        #ifdef china                    		//   -   
;		for (j = Cntr_X_RES; j>0; j--) LcdSend(0, LCD_DATA);
	LDI  R19,LOW(102)
_0x2E:
	CPI  R19,1
	BRLO _0x2F
	RCALL SUBOPT_0x2
	SUBI R19,1
	RJMP _0x2E
_0x2F:
	__GETWRN 16,17,503
_0x31:
	TST  R17
	BRMI _0x32
;        #else
;        for (i = 0; i < LCD_CACHSIZE; i++)		// 
;        #endif
;                {
;                LcdSend(LcdCache[i], LCD_DATA);
	RCALL SUBOPT_0x3
	LD   R30,X
	RCALL SUBOPT_0x4
	RCALL _LcdSend
;		#ifdef china				//   -       
;		if (++j == LCD_X_RES)
	SUBI R19,-LOW(1)
	CPI  R19,84
	BRNE _0x33
;			{
;			for (j = (Cntr_X_RES-LCD_X_RES); j>0; j--) LcdSend(0, LCD_DATA);
	LDI  R19,LOW(18)
_0x35:
	CPI  R19,1
	BRLO _0x36
	RCALL SUBOPT_0x2
	SUBI R19,1
	RJMP _0x35
_0x36:
	LDI  R19,LOW(0)
;			}
;		#endif
;                }
_0x33:
	__SUBWRN 16,17,1
	RJMP _0x31
_0x32:
;        }
	RJMP _0x2060004
;
;void LcdClear (void)    //Clears the display
;        {
_LcdClear:
;        int i;
;
;	for (i = 0; i < LCD_CACHSIZE; i++) LcdCache[i] = 0;	//   0
	RCALL __SAVELOCR2
;	i -> R16,R17
	RCALL SUBOPT_0x5
_0x38:
	__CPWRN 16,17,504
	BRGE _0x39
	RCALL SUBOPT_0x3
	LDI  R30,LOW(0)
	ST   X,R30
	__ADDWRN 16,17,1
	RJMP _0x38
_0x39:
	RJMP _0x2060003
;        }
;
;void LcdClear_massive (void)    //Clears the display
;        {
_LcdClear_massive:
;        int i;
;
;	for (i = 0; i < LCD_CACHSIZE; i++) LcdCache[i] = 0;	//   0
	RCALL __SAVELOCR2
;	i -> R16,R17
	RCALL SUBOPT_0x5
_0x3B:
	__CPWRN 16,17,504
	BRGE _0x3C
	RCALL SUBOPT_0x3
	LDI  R30,LOW(0)
	ST   X,R30
	__ADDWRN 16,17,1
	RJMP _0x3B
_0x3C:
	RJMP _0x2060002
;
;void LcdInit ( void )	// SPI  
;        {
_LcdInit:
;        LCD_RST_PORT.LCD_RST_PIN = 1;       //  /
	SBI  0x15,3
;        LCD_RST_DDR.LCD_RST_PIN = LCD_DC_DDR.LCD_DC_PIN = LCD_CDDR.LCD_CPIN = LCD_MOSI_DDR.LCD_MOSI_PIN = LCD_CLK_DDR.LCD_CLK_PIN = 1;
	SBI  0x17,5
	SBI  0x17,3
	SBI  0x17,2
	SBI  0x17,4
	SBI  0x14,3
;        LCD_CLK_PORT.LCD_CLK_PIN = 0;
	CBI  0x18,5
;        	#ifndef SOFT_SPI
;        LCD_SS_DDR.LCD_SS_PIN = 1;
;        LCD_SS_PORT.LCD_SS_PIN = 0;
;        	#endif
;        delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x6
;        	#ifndef SOFT_SPI
;        //SPCR = SPCR_val;
;        //SPSR = SPSR_val;
;        	#endif
;        LCD_RST_PORT.LCD_RST_PIN = 0;       // 
	CBI  0x15,3
;        delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x6
;        LCD_RST_PORT.LCD_RST_PIN = 1;
	SBI  0x15,3
;                            //Enable SPI port: No interrupt, MSBit first, Master mode, CPOL->0, CPHA->0, Clk/4
;
;        LCD_CPORT.LCD_CPIN = 1;        //Disable LCD controller
	SBI  0x18,2
;
;        LcdSend( 0b00100001, LCD_CMD ); 						//LCD Extended Commands
	LDI  R30,LOW(33)
	RCALL SUBOPT_0x1
;        LcdSend( 0b00000100+temp_control, LCD_CMD ); 					//Set Temp coefficent
	LDS  R30,_temp_control
	SUBI R30,-LOW(4)
	RCALL SUBOPT_0x1
;        	#ifdef china
;        LcdSend( 0b00001000|SPI_invert<<3, LCD_CMD ); 					//   SPI
	LDI  R26,0
	SBRC R3,5
	LDI  R26,1
	RCALL SUBOPT_0x7
	ORI  R30,8
	RCALL SUBOPT_0x1
;		#endif
;        LcdSend( 0b00010000+bias, LCD_CMD ); 						//LCD bias mode 1:48
	LDS  R30,_bias
	SUBI R30,-LOW(16)
	RCALL SUBOPT_0x1
;        	#ifdef china
;        LcdSend( 0b01000000+shift, LCD_CMD ); 						//   ,   
	LDS  R30,_shift
	SUBI R30,-LOW(64)
	RCALL SUBOPT_0x1
;		#endif
;	LcdSend( 0b10000000+Vop, LCD_CMD ); 						//Set LCD Vop (Contrast)
	RCALL SUBOPT_0x8
	SUBI R30,-LOW(128)
	RCALL SUBOPT_0x1
;
;		#ifdef china
;	LcdSend( 0x20|x_mirror<<4|y_mirror<<3|power_down<<2, LCD_CMD );			//LCD Standard Commands
	LDI  R26,0
	SBRC R3,3
	LDI  R26,1
	MOV  R30,R26
	SWAP R30
	ANDI R30,0xF0
	ORI  R30,0x20
	MOV  R0,R30
	LDI  R26,0
	SBRC R3,4
	LDI  R26,1
	RCALL SUBOPT_0x7
	OR   R0,R30
	RCALL SUBOPT_0x9
	OR   R30,R0
	RCALL SUBOPT_0x1
;        	#endif
;        LcdSend( 0x20|power_down<<2|addressing<<1, LCD_CMD );	//XXXX			//LCD Standard Commands
	RCALL SUBOPT_0x9
	ORI  R30,0x20
	MOV  R0,R30
	LDI  R26,0
	SBRC R3,2
	LDI  R26,1
	MOV  R30,R26
	LSL  R30
	OR   R30,R0
	RCALL SUBOPT_0x1
;        LcdSend( 0b00001000|((disp_config<<1|disp_config)&0b00000101), LCD_CMD ); 	//LCD mode
	LDS  R30,_disp_config
	LSL  R30
	LDS  R26,_disp_config
	OR   R30,R26
	ANDI R30,LOW(0x5)
	ORI  R30,8
	RCALL SUBOPT_0x1
;        LcdClear();
	RCALL _LcdClear
;        }
	RET
;
;void LcdContrast (unsigned char contrast) 	//contrast -> Contrast value from 0x00 to 0x7F
;        {
_LcdContrast:
;        if (contrast > 0x7F) return;
;	contrast -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x80)
	BRLO _0x51
	RJMP _0x2060007
;        LcdSend( 0x21, LCD_CMD );               //LCD Extended Commands
_0x51:
	LDI  R30,LOW(33)
	RCALL SUBOPT_0x1
;        LcdSend( 0x80 | contrast, LCD_CMD );    //Set LCD Vop (Contrast)
	LD   R30,Y
	ORI  R30,0x80
	RCALL SUBOPT_0x1
;        LcdSend( 0x20, LCD_CMD );               //LCD Standard Commands,Horizontal addressing mode
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x1
;        }
	RJMP _0x2060007
;
;
;void LcdMode (unsigned char mode) 		// : 0 - blank, 1 - all on, 2 - normal, 3 - inverse
;        {
;        if (mode > 3) return;
;	mode -> Y+0
;        LcdSend( 0b00001000|((mode<<1|mode)&0b00000101), LCD_CMD ); 	//LCD mode
;        }
;
;void LcdPwrMode (void) 				//  / 
;        {
;        power_down = ~power_down;
;        	#ifdef china
;	LcdSend( 0x20|x_mirror<<4|y_mirror<<3|power_down<<2|addressing<<1, LCD_CMD );			//LCD Standard Commands
;        	#else
;        //LcdSend( 0x20|0<<2|addressing<<1, LCD_CMD );
;                  LcdSend( 0x20|power_down<<2|addressing<<1, LCD_CMD );			//LCD Standard Commands
;                //LcdSend( 0x20|power_down<<3, LCD_CMD );
;                    #endif
;        }
;
;void Lcd_off (void) 				// 
;        {
;        	#ifdef china
;	LcdSend( 0x20|x_mirror<<4|y_mirror<<3|1<<2|addressing<<1, LCD_CMD );			//LCD Standard Commands
;        	#else
;        LcdSend( 0x20|1<<2|addressing<<1, LCD_CMD );
;                #endif
;        }
;
;void Lcd_on (void) 				// 
;        {
;        	#ifdef china
;	LcdSend( 0x20|x_mirror<<4|y_mirror<<3|0<<2|addressing<<1, LCD_CMD );			//LCD Standard Commands
;        	#else
;        LcdSend( 0x20|0<<2|addressing<<1, LCD_CMD );
;                #endif
;        }
;
;void LcdImage (flash unsigned char *imageData)	// 
;        {
;        unsigned int i;
;
;        LcdSend(0x80, LCD_CMD);		//   0,0
;	*imageData -> Y+2
;	i -> R16,R17
;        LcdSend(0x40, LCD_CMD);
;        for (i = 0; i < LCD_CACHSIZE; i++) LcdCache[i] = imageData[i];	// 
;
;void LcdPixel (unsigned char x, unsigned char y, unsigned char mode)     //Displays a pixel at given absolute (x, y) location, mode -> Off, On or Xor
;        {
_LcdPixel:
;        int index;
;        unsigned char offset, data;
;
;        if ( x > LCD_X_RES ) return;	//     - 
	RCALL __SAVELOCR4
;	x -> Y+6
;	y -> Y+5
;	mode -> Y+4
;	index -> R16,R17
;	offset -> R19
;	data -> R18
	LDD  R26,Y+6
	CPI  R26,LOW(0x55)
	BRSH _0x206000C
;        if ( y > LCD_Y_RES ) return;
	LDD  R26,Y+5
	CPI  R26,LOW(0x31)
	BRSH _0x206000C
;
;        index = (((int)(y)/8)*84)+x;    //      
	RCALL SUBOPT_0xA
	LDI  R26,LOW(84)
	LDI  R27,HIGH(84)
	RCALL SUBOPT_0xB
	LDD  R30,Y+6
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	MOVW R16,R30
;        offset  = y-((y/8)*8);          //     
	LDD  R22,Y+5
	CLR  R23
	RCALL SUBOPT_0xA
	RCALL __LSLW3
	MOVW R26,R30
	MOVW R30,R22
	RCALL SUBOPT_0xE
	MOV  R19,R30
;
;        data = LcdCache[index];         //    
	RCALL SUBOPT_0x3
	LD   R18,X
;
;        if ( mode == PIXEL_OFF ) data &= ( ~( 0x01 << offset ) );	//    
	LDD  R30,Y+4
	CPI  R30,0
	BRNE _0x58
	RCALL SUBOPT_0xF
	COM  R30
	AND  R18,R30
;                else if ( mode == PIXEL_ON ) data |= ( 0x01 << offset );
	RJMP _0x59
_0x58:
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BRNE _0x5A
	RCALL SUBOPT_0xF
	OR   R18,R30
;                        else if ( mode  == PIXEL_XOR ) data ^= ( 0x01 << offset );
	RJMP _0x5B
_0x5A:
	LDD  R26,Y+4
	CPI  R26,LOW(0x2)
	BRNE _0x5C
	RCALL SUBOPT_0xF
	EOR  R18,R30
;
;        LcdCache[index] = data;		//  
_0x5C:
_0x5B:
_0x59:
	MOVW R30,R16
	RCALL SUBOPT_0x10
	ST   Z,R18
;        }
_0x206000C:
	RCALL __LOADLOCR4
	ADIW R28,7
	RET
;
;void LcdLine (int x1, int y1, int x2, int y2, unsigned char mode)  	//Draws a line between two points on the display -  
;        {
_LcdLine:
;        signed int dy = 0;
;        signed int dx = 0;
;        signed int stepx = 0;
;        signed int stepy = 0;
;        signed int fraction = 0;
;
;        if (x1>LCD_X_RES || x2>LCD_X_RES || y1>LCD_Y_RES || y2>LCD_Y_RES) return;
	RCALL SUBOPT_0x11
	RCALL __SAVELOCR6
;	x1 -> Y+17
;	y1 -> Y+15
;	x2 -> Y+13
;	y2 -> Y+11
;	mode -> Y+10
;	dy -> R16,R17
;	dx -> R18,R19
;	stepx -> R20,R21
;	stepy -> Y+8
;	fraction -> Y+6
	RCALL SUBOPT_0x5
	__GETWRN 18,19,0
	__GETWRN 20,21,0
	RCALL SUBOPT_0x12
	CPI  R26,LOW(0x55)
	LDI  R30,HIGH(0x55)
	CPC  R27,R30
	BRGE _0x5E
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	CPI  R26,LOW(0x55)
	LDI  R30,HIGH(0x55)
	CPC  R27,R30
	BRGE _0x5E
	RCALL SUBOPT_0x13
	SBIW R26,49
	BRGE _0x5E
	LDD  R26,Y+11
	LDD  R27,Y+11+1
	SBIW R26,49
	BRLT _0x5D
_0x5E:
	RJMP _0x206000B
;
;        dy = y2 - y1;
_0x5D:
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0xE
	MOVW R16,R30
;        dx = x2 - x1;
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xE
	MOVW R18,R30
;        if (dy < 0)
	TST  R17
	BRPL _0x60
;                {
;                dy = -dy;
	MOVW R30,R16
	RCALL __ANEGW1
	MOVW R16,R30
;                stepy = -1;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x199
;                }
;                else stepy = 1;
_0x60:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x199:
	STD  Y+8,R30
	STD  Y+8+1,R31
;        if (dx < 0)
	TST  R19
	BRPL _0x62
;                {
;                dx = -dx;
	MOVW R30,R18
	RCALL __ANEGW1
	MOVW R18,R30
;                stepx = -1;
	__GETWRN 20,21,-1
;                }
;                else stepx = 1;
	RJMP _0x63
_0x62:
	__GETWRN 20,21,1
;        dy <<= 1;
_0x63:
	LSL  R16
	ROL  R17
;        dx <<= 1;
	LSL  R18
	ROL  R19
;        LcdPixel(x1,y1,mode);
	RCALL SUBOPT_0x16
;        if (dx > dy)
	__CPWRR 16,17,18,19
	BRGE _0x64
;                {
;                fraction = dy - (dx >> 1);
	MOVW R30,R18
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R16
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x17
;                while (x1 != x2)
_0x65:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x12
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x67
;                        {
;                        if (fraction >= 0)
	LDD  R26,Y+7
	TST  R26
	BRMI _0x68
;                                {
;                                y1 += stepy;
	RCALL SUBOPT_0x18
;                                fraction -= dx;
	RCALL SUBOPT_0x19
	SUB  R30,R18
	SBC  R31,R19
	RCALL SUBOPT_0x17
;                                }
;                        x1 += stepx;
_0x68:
	RCALL SUBOPT_0x1A
;                        fraction += dy;
	MOVW R30,R16
	RCALL SUBOPT_0x1B
;                        LcdPixel(x1,y1,mode);
;                        }
	RJMP _0x65
_0x67:
;                }
;                else
	RJMP _0x69
_0x64:
;                        {
;                        fraction = dx - (dy >> 1);
	MOVW R30,R16
	ASR  R31
	ROR  R30
	MOVW R26,R30
	MOVW R30,R18
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x17
;                        while (y1 != y2)
_0x6A:
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x13
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x6C
;                                {
;                                if (fraction >= 0)
	LDD  R26,Y+7
	TST  R26
	BRMI _0x6D
;                                        {
;                                        x1 += stepx;
	RCALL SUBOPT_0x1A
;                                        fraction -= dy;
	RCALL SUBOPT_0x19
	SUB  R30,R16
	SBC  R31,R17
	RCALL SUBOPT_0x17
;                                        }
;                                y1 += stepy;
_0x6D:
	RCALL SUBOPT_0x18
;                                fraction += dx;
	MOVW R30,R18
	RCALL SUBOPT_0x1B
;                                LcdPixel(x1,y1,mode);
;                                }
	RJMP _0x6A
_0x6C:
;                        }
_0x69:
;        }
_0x206000B:
	RCALL __LOADLOCR6
	ADIW R28,19
	RET
;
;void LcdCircle(char x, char y, char radius, unsigned char mode)		//      -  
;        {
;        signed char xc = 0;
;        signed char yc = 0;
;        signed char p = 0;
;
;        if (x>LCD_X_RES || y>LCD_Y_RES) return;
;	x -> Y+7
;	y -> Y+6
;	radius -> Y+5
;	mode -> Y+4
;	xc -> R17
;	yc -> R16
;	p -> R19
;
;        yc=radius;
;        p = 3 - (radius<<1);
;        while (xc <= yc)
;                {
;                LcdPixel(x + xc, y + yc, mode);
;                LcdPixel(x + xc, y - yc, mode);
;                LcdPixel(x - xc, y + yc, mode);
;                LcdPixel(x - xc, y - yc, mode);
;                LcdPixel(x + yc, y + xc, mode);
;                LcdPixel(x + yc, y - xc, mode);
;                LcdPixel(x - yc, y + xc, mode);
;                LcdPixel(x - yc, y - xc, mode);
;                if (p < 0) p += (xc++ << 2) + 6;
;                        else p += ((xc++ - yc--)<<2) + 10;
;                }
;        }
;
;void LcdBatt(int x1, int y1, int x2, int y2, unsigned char persent)	//     %
;        {
_LcdBatt:
;        unsigned char horizon_line,horizon_line2,i;
;        if(persent>100)return;
	RCALL __SAVELOCR4
;	x1 -> Y+11
;	y1 -> Y+9
;	x2 -> Y+7
;	y2 -> Y+5
;	persent -> Y+4
;	horizon_line -> R17
;	horizon_line2 -> R16
;	i -> R19
	LDD  R26,Y+4
	CPI  R26,LOW(0x65)
	BRSH _0x206000A
;        LcdLine(x1,y2,x2,y2,1);  //down
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1E
;        LcdLine(x2,y1,x2,y2,1);  //right
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1E
;	LcdLine(x1,y1,x1,y2,1);  //left
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1E
;	LcdLine(x1,y1,x2,y1,1);  //up
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1E
;	LcdLine(x1+7,y1-1,x2-7,y1-1,1);
	RCALL SUBOPT_0x20
	SBIW R30,1
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x22
	SBIW R30,1
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x1E
;	LcdLine(x1+7,y1-2,x2-7,y1-2,1);
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x1E
;
;        horizon_line=persent*(y2-y1-3)/100;
	LDD  R0,Y+4
	CLR  R1
	RCALL SUBOPT_0x24
	MOVW R26,R0
	RCALL SUBOPT_0xB
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21
	MOV  R17,R30
;        for(i=0;i<horizon_line;i++) LcdLine(x1+2,y2-2-i,x2-2,y2-2-i,1);
	LDI  R19,LOW(0)
_0x78:
	CP   R19,R17
	BRSH _0x79
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1E
	SUBI R19,-1
	RJMP _0x78
_0x79:
	RCALL SUBOPT_0x24
	MOV  R16,R30
;        for(i=horizon_line2;i>horizon_line;i--) LcdLine(x1+2,y2-2-i,x2-2,y2-2-i,0);
	MOV  R19,R16
_0x7B:
	CP   R17,R19
	BRSH _0x7C
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _LcdLine
	SUBI R19,1
	RJMP _0x7B
_0x7C:
_0x206000A:
	RCALL __LOADLOCR4
	ADIW R28,13
	RET
;
;void LcdBar(int x1, int y1, int x2, int y2, unsigned char persent)	// -
;        {
;        unsigned char line;
;        if(persent>100)return;
;	x1 -> Y+8
;	y1 -> Y+6
;	x2 -> Y+4
;	y2 -> Y+2
;	persent -> Y+1
;	line -> R17
;        LcdLine(x1+2,y2,x2-2,y2,1);  //down
;        LcdLine(x2-2,y1,x2-2,y2,1);  //right
;	LcdLine(x1+2,y1,x1+2,y2,1);  //left
;	LcdLine(x1+2,y1,x2-2,y1,1);  //up
;
;        LcdLine(x2-1,y1+1,x2-1,y2-1,1);  //right
;	LcdLine(x1+1,y1+1,x1+1,y2-1,1);  //left
;
;        LcdLine(x2,y1+2,x2,y2-2,1);  //right
;	LcdLine(x1,y1+2,x1,y2-2,1);  //left
;
;        line=persent*(x2-x1-7)/100-1;
;        LcdLine(x1+4,y1+2,x2-4,y2-2,0);
;        LcdLine(x1+4,y1+2,x1+4+line,y2-2,1);
;	}
;
;void LcdBarLine(unsigned char line, unsigned char persent)	// -
;        {
;        LcdBar(0, (line-1)*7+1, 83, (line-1)*7+5, persent);
;	line -> Y+1
;	persent -> Y+0
;        }
;
;void LcdGotoXYFont (unsigned char x, unsigned char y)   //Sets cursor location to xy location. Range: 1,1 .. 14,6
;        {
_LcdGotoXYFont:
;        if (x <= 14 && y <= 6) LcdCacheIdx = ( (int)(y) - 1 ) * 84 + ( (int)(x) - 1 ) * 6;
;	x -> Y+1
;	y -> Y+0
	LDD  R26,Y+1
	CPI  R26,LOW(0xF)
	BRSH _0x7F
	LD   R26,Y
	CPI  R26,LOW(0x7)
	BRLO _0x80
_0x7F:
	RJMP _0x7E
_0x80:
	LD   R30,Y
	RCALL SUBOPT_0xC
	SBIW R30,1
	LDI  R26,LOW(84)
	LDI  R27,HIGH(84)
	RCALL __MULW12
	MOVW R22,R30
	LDD  R30,Y+1
	RCALL SUBOPT_0xC
	SBIW R30,1
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	RCALL __MULW12
	ADD  R30,R22
	ADC  R31,R23
	RCALL SUBOPT_0x27
;        }
_0x7E:
	ADIW R28,2
	RET
;
;void clean_lcd_buf (void)	//  
;	{
_clean_lcd_buf:
;	char i;
;
;	for (i=0; i<14; i++) lcd_buf[i] = 0;
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x82:
	CPI  R17,14
	BRSH _0x83
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x2A
	SUBI R17,-1
	RJMP _0x82
_0x83:
	RJMP _0x2060006
;
;void LcdChr (int ch)	//Displays a character at current cursor location and increment cursor location
; 	{
_LcdChr:
;     	unsigned char i;
;
;        for ( i = 0; i < 5; i++ ) LcdCache[LcdCacheIdx++] = table[(ch*5+i)];	// -       - 5 
	ST   -Y,R17
;	ch -> Y+1
;	i -> R17
	LDI  R17,LOW(0)
_0x85:
	CPI  R17,5
	BRSH _0x86
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x2D
	MOVW R26,R22
	ST   X,R30
	SUBI R17,-1
	RJMP _0x85
_0x86:
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2A
; 	}
	RJMP _0x2060008
;
;void LcdChrInv (int ch)	//Displays a character at current cursor location and increment cursor location
; 	{
_LcdChrInv:
;     	unsigned char i;
;
;        for ( i = 0; i < 5; i++ ) LcdCache[LcdCacheIdx++] = ~(table[(ch*5+i)]);	// -       - 5 
	ST   -Y,R17
;	ch -> Y+1
;	i -> R17
	LDI  R17,LOW(0)
_0x88:
	CPI  R17,5
	BRSH _0x89
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x2D
	COM  R30
	MOVW R26,R22
	ST   X,R30
	SUBI R17,-1
	RJMP _0x88
_0x89:
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2E
; 	}
	RJMP _0x2060008
;
;void LcdString (unsigned char x, unsigned char y)	//Displays a string at current cursor location
;	{
_LcdString:
;	unsigned char i;
;
;	if (x > 14 || y > 6) return;
	ST   -Y,R17
;	x -> Y+2
;	y -> Y+1
;	i -> R17
	LDD  R26,Y+2
	CPI  R26,LOW(0xF)
	BRSH _0x8B
	LDD  R26,Y+1
	CPI  R26,LOW(0x7)
	BRLO _0x8A
_0x8B:
	RJMP _0x2060008
;	LcdGotoXYFont (x, y);
_0x8A:
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x2F
	RCALL _LcdGotoXYFont
;	for ( i = 0; i < 15-x; i++ ) if (lcd_buf[i]) LcdChr (lcd_buf[i]);
	LDI  R17,LOW(0)
_0x8E:
	RCALL SUBOPT_0x30
	BRGE _0x8F
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x31
	CPI  R30,0
	BREQ _0x90
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x21
	RCALL _LcdChr
;	clean_lcd_buf();
_0x90:
	SUBI R17,-1
	RJMP _0x8E
_0x8F:
	RJMP _0x2060009
;	}
;
;void LcdStringInv (unsigned char x, unsigned char y)	//Displays a string at current cursor location
;	{
_LcdStringInv:
;	unsigned char i;
;
;	if (x > 14 || y > 6) return;
	ST   -Y,R17
;	x -> Y+2
;	y -> Y+1
;	i -> R17
	LDD  R26,Y+2
	CPI  R26,LOW(0xF)
	BRSH _0x92
	LDD  R26,Y+1
	CPI  R26,LOW(0x7)
	BRLO _0x91
_0x92:
	RJMP _0x2060008
;	LcdGotoXYFont (x, y);
_0x91:
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x2F
	RCALL _LcdGotoXYFont
;	for ( i = 0; i < 15-x; i++ ) if (lcd_buf[i]) LcdChrInv (lcd_buf[i]);
	LDI  R17,LOW(0)
_0x95:
	RCALL SUBOPT_0x30
	BRGE _0x96
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x31
	CPI  R30,0
	BREQ _0x97
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x21
	RCALL _LcdChrInv
;	clean_lcd_buf();
_0x97:
	SUBI R17,-1
	RJMP _0x95
_0x96:
	RJMP _0x2060009
;	}
;
;void LcdChrBold (int ch)	//Displays a bold character at current cursor location and increment cursor location
; 	{
_LcdChrBold:
;     	unsigned char i;
;     	unsigned char a = 0, b = 0, c = 0;
;
;     	for ( i = 0; i < 5; i++ )
	RCALL __SAVELOCR4
;	ch -> Y+4
;	i -> R17
;	a -> R16
;	b -> R19
;	c -> R18
	LDI  R16,0
	LDI  R19,0
	LDI  R18,0
	LDI  R17,LOW(0)
_0x99:
	CPI  R17,5
	BRLO PC+2
	RJMP _0x9A
;     	        {
;     	        c = table[(ch*5+i)];		//   
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0xD
	SUBI R30,LOW(-_table*2)
	SBCI R31,HIGH(-_table*2)
	LPM  R18,Z
;
;     	        b =  (c & 0x01) * 3;            //""    
	RCALL SUBOPT_0x32
	MOV  R19,R0
;              	b |= (c & 0x02) * 6;
	RCALL SUBOPT_0x33
	OR   R19,R30
;              	b |= (c & 0x04) * 12;
	RCALL SUBOPT_0x34
	OR   R19,R30
;              	b |= (c & 0x08) * 24;
	RCALL SUBOPT_0x35
	OR   R19,R30
;
;              	c >>= 4;
	MOV  R30,R18
	RCALL SUBOPT_0xC
	RCALL __ASRW4
	MOV  R18,R30
;              	a =  (c & 0x01) * 3;
	RCALL SUBOPT_0x32
	MOV  R16,R0
;              	a |= (c & 0x02) * 6;
	RCALL SUBOPT_0x33
	OR   R16,R30
;              	a |= (c & 0x04) * 12;
	RCALL SUBOPT_0x34
	OR   R16,R30
;              	a |= (c & 0x08) * 24;
	RCALL SUBOPT_0x35
	OR   R16,R30
;
;if(alarm)
	SBRS R2,2
	RJMP _0x9B
;{
;    	        LcdCache[LcdCacheIdx] = ~b;	//    
	LDS  R26,_LcdCacheIdx
	LDS  R27,_LcdCacheIdx+1
	SUBI R26,LOW(-_LcdCache)
	SBCI R27,HIGH(-_LcdCache)
	RCALL SUBOPT_0x36
;     	        LcdCache[LcdCacheIdx+1] = ~b;    //    
	__ADDW1MN _LcdCache,1
	MOVW R26,R30
	RCALL SUBOPT_0x36
;     	        LcdCache[LcdCacheIdx+84] = ~a;
	__ADDW1MN _LcdCache,84
	RCALL SUBOPT_0x37
;     	        LcdCache[LcdCacheIdx+85] = ~a;
	RCALL SUBOPT_0x38
	__ADDW1MN _LcdCache,85
	RCALL SUBOPT_0x37
;     	        LcdCacheIdx = LcdCacheIdx+2;
	RJMP _0x19B
;}
;else
_0x9B:
;{
;    	        LcdCache[LcdCacheIdx] = b;	//    
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x10
	ST   Z,R19
;     	        LcdCache[LcdCacheIdx+1] = b;    //    
	RCALL SUBOPT_0x38
	__ADDW1MN _LcdCache,1
	ST   Z,R19
;     	        LcdCache[LcdCacheIdx+84] = a;
	RCALL SUBOPT_0x38
	__ADDW1MN _LcdCache,84
	ST   Z,R16
;     	        LcdCache[LcdCacheIdx+85] = a;
	RCALL SUBOPT_0x38
	__ADDW1MN _LcdCache,85
	ST   Z,R16
;     	        LcdCacheIdx = LcdCacheIdx+2;
_0x19B:
	LDS  R30,_LcdCacheIdx
	LDS  R31,_LcdCacheIdx+1
	ADIW R30,2
	RCALL SUBOPT_0x27
;}
;     	        }
	SUBI R17,-1
	RJMP _0x99
_0x9A:
;if(alarm)
	SBRS R2,2
	RJMP _0x9D
;{
;
;     	LcdCache[LcdCacheIdx+84] = 0xFF;	//   
	RCALL SUBOPT_0x38
	__ADDW1MN _LcdCache,84
	RCALL SUBOPT_0x2E
;     	LcdCache[LcdCacheIdx+85] = 0xFF;
	RCALL SUBOPT_0x38
	__ADDW1MN _LcdCache,85
	RCALL SUBOPT_0x2E
;        LcdCache[LcdCacheIdx] = 0xFF;
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x2E
;     	LcdCache[LcdCacheIdx+1] = 0xFF;
	RCALL SUBOPT_0x38
	__ADDW1MN _LcdCache,1
	RCALL SUBOPT_0x2E
;        LcdCacheIdx+=2;
	RCALL SUBOPT_0x38
	ADIW R30,2
	RCALL SUBOPT_0x27
;}
;else
	RJMP _0x9E
_0x9D:
;{
;     	LcdCache[LcdCacheIdx++] = 0x00;	//   
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2A
;     	LcdCache[LcdCacheIdx++] = 0x00;
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2A
;}
_0x9E:
; 	}
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
;
;void LcdStringBold (unsigned char x, unsigned char y)	//Displays a string at current cursor location
;	{
_LcdStringBold:
;	unsigned char i;
;
;	if (x > 13 || y > 5) return;
	ST   -Y,R17
;	x -> Y+2
;	y -> Y+1
;	i -> R17
	LDD  R26,Y+2
	CPI  R26,LOW(0xE)
	BRSH _0xA0
	LDD  R26,Y+1
	CPI  R26,LOW(0x6)
	BRLO _0x9F
_0xA0:
	RJMP _0x2060008
;	LcdGotoXYFont (x, y);
_0x9F:
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x2F
	RCALL _LcdGotoXYFont
;	for ( i = 0; i < 14-x; i++ ) if (lcd_buf[i]) LcdChrBold (lcd_buf[i]);
	LDI  R17,LOW(0)
_0xA3:
	LDD  R30,Y+2
	RCALL SUBOPT_0xC
	LDI  R26,LOW(14)
	LDI  R27,HIGH(14)
	RCALL __SWAPW12
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x39
	BRGE _0xA4
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x31
	CPI  R30,0
	BREQ _0xA5
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x21
	RCALL _LcdChrBold
;	clean_lcd_buf();
_0xA5:
	SUBI R17,-1
	RJMP _0xA3
_0xA4:
_0x2060009:
	RCALL _clean_lcd_buf
;	}
_0x2060008:
	LDD  R17,Y+0
	ADIW R28,3
	RET
;
;void LcdChrBig (int ch)	//Displays a character at current cursor location and increment cursor location
; 	{
;     	unsigned char i;
;     	unsigned char a = 0, b = 0, c = 0;
;
;     	for ( i = 0; i < 5; i++ )
;	ch -> Y+4
;	i -> R17
;	a -> R16
;	b -> R19
;	c -> R18
;     	        {
;     	        c = table[(ch*5+i)];		//   
;
;     	        b =  (c & 0x01) * 3;            //""    
;              	b |= (c & 0x02) * 6;
;              	b |= (c & 0x04) * 12;
;              	b |= (c & 0x08) * 24;
;
;              	c >>= 4;
;              	a =  (c & 0x01) * 3;
;              	a |= (c & 0x02) * 6;
;              	a |= (c & 0x04) * 12;
;              	a |= (c & 0x08) * 24;
;     	        LcdCache[LcdCacheIdx] = b;
;     	        LcdCache[LcdCacheIdx+84] = a;
;     	        LcdCacheIdx = LcdCacheIdx+1;
;     	        }
;
;     	LcdCache[LcdCacheIdx++] = 0x00;
;     	}
;
;void LcdStringBig (unsigned char x, unsigned char y)	//Displays a string at current cursor location
;	{
;	unsigned char i;
;
;	if (x > 14 || y > 5) return;
;	x -> Y+2
;	y -> Y+1
;	i -> R17
;	LcdGotoXYFont (x, y);
;	for ( i = 0; i < 15-x; i++ ) if (lcd_buf[i]) LcdChrBig (lcd_buf[i]);
;	clean_lcd_buf();
;	}
;
;void LcdPwrOff(void)
;{
_LcdPwrOff:
;if(!power_down)
	SBRC R3,1
	RJMP _0xB0
;{
;
;beep=0;
	RCALL SUBOPT_0x3A
;TIMSK=0x40;
	RCALL SUBOPT_0x3B
;beep_pin=0;
	CBI  0x15,1
;
;menu_active=0;
	CLT
	BLD  R2,0
;
;power_down=1;
	SET
	RCALL SUBOPT_0x3C
;led_refresh(NONE);
;
;    power_of_display=0;
	CBI  0x15,0
;    power_of_display_ddr=0;
	CBI  0x14,0
;
;LCD_DC_PORT.LCD_DC_PIN=0;
	CBI  0x18,4
;LCD_DC_DDR.LCD_DC_PIN=0;
	CBI  0x17,4
;
;LCD_CPORT.LCD_CPIN=0;
	CBI  0x18,2
;LCD_CDDR.LCD_CPIN=0;
	CBI  0x17,2
;
;LCD_RST_PORT.LCD_RST_PIN=0;
	CBI  0x15,3
;LCD_RST_DDR.LCD_RST_PIN=0;
	CBI  0x14,3
;
;LCD_MOSI_PORT.LCD_MOSI_PIN=0;
	CBI  0x18,3
;LCD_MOSI_DDR.LCD_MOSI_PIN=0;
	CBI  0x17,3
;
;LCD_CLK_PORT.LCD_CLK_PIN=0;
	CBI  0x18,5
;LCD_CLK_DDR.LCD_CLK_PIN=0;
	CBI  0x17,5
;}
;}
_0xB0:
	RET
;
;void LcdPwrOn(void)
;{
_LcdPwrOn:
;if(power_down)
	SBRS R3,1
	RJMP _0xCB
;{
;
; power_of_display=1;
	SBI  0x15,0
; power_of_display_ddr=1;
	SBI  0x14,0
;
; power_down=0;
	CLT
	RCALL SUBOPT_0x3C
; led_refresh(NONE);
; LcdInit();
	RCALL _LcdInit
; LcdUpdate();
	RCALL _LcdUpdate
;}
;
;}
_0xCB:
	RET
;
;#pragma used-
;
;#include <microdozik.h>
_poweroff:
	RCALL SUBOPT_0x3D
	__POINTW1FN _0x0,0
	RCALL SUBOPT_0x3E
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x6
	LDI  R30,LOW(31)
	OUT  0x21,R30
	LDI  R30,LOW(0)
	OUT  0x21,R30
	sei
	LDI  R30,LOW(64)
	OUT  0x3B,R30
	LDI  R30,LOW(160)
	OUT  0x35,R30
	LDI  R30,LOW(0)
	OUT  0x17,R30
	OUT  0x14,R30
	OUT  0x11,R30
	OUT  0x18,R30
	OUT  0x15,R30
	OUT  0x12,R30
	RCALL SUBOPT_0x3F
	LDI  R30,LOW(0)
	OUT  0x22,R30
	OUT  0x25,R30
	OUT  0x24,R30
	OUT  0x23,R30
	OUT  0x39,R30
	SBI  0x12,2
	CBI  0x11,2
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x6
	sei
	CLT
	BLD  R2,7
_0xD4:
	SBRC R2,7
	RJMP _0xD6
	sleep
	RJMP _0xD4
_0xD6:
	RCALL _LcdInit
	RCALL SUBOPT_0x3D
	__POINTW1FN _0x0,15
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x40
	LDI  R30,LOW(31)
	OUT  0x21,R30
	LDI  R30,LOW(15)
	OUT  0x21,R30
_0xD7:
	sleep
	RJMP _0xD7
_led_refresh:
;	command -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRNE _0xDA
	CBI  0x12,5
	CBI  0x12,0
	RJMP _0x2060007
_0xDA:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0xDF
	SBRC R3,6
	RJMP _0xE0
	CBI  0x12,5
	RJMP _0xE1
_0xE0:
	SBI  0x12,5
_0xE1:
	SBRC R3,7
	RJMP _0xE2
	CBI  0x12,0
	RJMP _0xE3
_0xE2:
	SBI  0x12,0
_0xE3:
	RJMP _0x2060007
_0xDF:
	SBRC R3,1
	RJMP _0xE4
	SBRS R2,2
	RJMP _0xE5
	CBI  0x12,5
	CLT
	BLD  R3,6
	SBI  0x12,0
	SET
	RJMP _0x19C
_0xE5:
	SBI  0x12,5
	SET
	BLD  R3,6
	CBI  0x12,0
	CLT
_0x19C:
	BLD  R3,7
	RJMP _0xEF
_0xE4:
	CBI  0x12,5
	CLT
	BLD  R3,6
	CBI  0x12,0
	BLD  R3,7
_0xEF:
_0x2060007:
	ADIW R28,1
	RET
_pump:
	RCALL __SAVELOCR2
;	i -> R16,R17
	SBRS R2,1
	RJMP _0xF4
	LDI  R30,LOW(0)
	OUT  0x3B,R30
	RCALL SUBOPT_0x41
	RCALL _led_refresh
	RCALL SUBOPT_0x5
_0xF6:
	__CPWRR 16,17,8,9
	BRSH _0xF7
	RCALL SUBOPT_0x42
	__DELAY_USB 27
	wdr
	__ADDWRN 16,17,1
	RJMP _0xF6
_0xF7:
	__DELAY_USB 67
	RCALL SUBOPT_0x43
	RCALL _led_refresh
	CLT
	BLD  R2,1
	LDI  R30,LOW(192)
	OUT  0x3B,R30
_0xF4:
	RJMP _0x2060002
_calc_counters:
	ST   -Y,R17
;	i -> R17
	LDI  R30,LOW(0)
	STS  _impulse_count,R30
	STS  _impulse_count+1,R30
	STS  _impulse_count+2,R30
	STS  _impulse_count+3,R30
	LDI  R17,LOW(0)
_0xFD:
	CPI  R17,37
	BRSH _0xFE
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	CLR  R22
	CLR  R23
	RCALL __ADDD12
	STS  _impulse_count,R30
	STS  _impulse_count+1,R31
	STS  _impulse_count+2,R22
	STS  _impulse_count+3,R23
	SUBI R17,-1
	RJMP _0xFD
_0xFE:
	CLT
	BLD  R2,4
	wdr
	LDS  R26,_second
	CPI  R26,LOW(0x25)
	BRLO _0xFF
	RCALL _check_sbm20
	LDI  R30,LOW(0)
	STS  _second,R30
	STS  _impulse_massive,R30
	STS  _impulse_massive+1,R30
_0xFF:
_0x2060006:
	LD   R17,Y+
	RET
_alarm_check:
	RCALL SUBOPT_0x46
	RCALL __GTD12U
	MOV  R26,R30
	RCALL SUBOPT_0x47
	MOV  R0,R30
	MOV  R30,R1
	MOV  R31,R31
	MOVW R26,R30
	RCALL SUBOPT_0x48
	RCALL __GTW12
	AND  R30,R0
	BREQ _0x100
	RCALL SUBOPT_0x49
	RCALL _LcdPwrOn
	SET
	BLD  R2,2
_0x100:
	RCALL SUBOPT_0x46
	RCALL __LTD12U
	MOV  R0,R30
	MOV  R30,R1
	MOV  R31,R31
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	RCALL __EQW12
	OR   R30,R0
	BREQ _0x101
	SBRS R2,2
	RJMP _0x102
	CLT
	BLD  R2,2
	BLD  R2,3
_0x102:
_0x101:
	RET
_check_battery:
	RCALL _read_adc
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	MOVW R6,R30
	RCALL SUBOPT_0x4A
	MOVW R8,R30
	RCALL SUBOPT_0x4B
	CPI  R26,LOW(0x8D)
	LDI  R30,HIGH(0x8D)
	CPC  R27,R30
	BRLO _0x103
	LDI  R30,LOW(140)
	LDI  R31,HIGH(140)
	RCALL SUBOPT_0x4C
_0x103:
	RCALL SUBOPT_0x4B
	CPI  R26,LOW(0x5A)
	LDI  R30,HIGH(0x5A)
	CPC  R27,R30
	BRSH _0x104
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	RCALL SUBOPT_0x4C
_0x104:
	RCALL SUBOPT_0x4D
	SUBI R30,LOW(90)
	SBCI R31,HIGH(90)
	LSL  R30
	MOV  R4,R30
	RCALL SUBOPT_0x4B
	CPI  R26,LOW(0x5F)
	LDI  R30,HIGH(0x5F)
	CPC  R27,R30
	BRSH _0x105
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x3B
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x3B
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x3B
	CBI  0x15,1
	wdr
_0x105:
	RET
_check_sbm20:
	RCALL SUBOPT_0x4F
	RCALL __CPD10
	BRNE _0x108
	LDS  R30,_error_count
	SUBI R30,-LOW(1)
	RJMP _0x19D
_0x108:
	LDI  R30,LOW(0)
_0x19D:
	STS  _error_count,R30
	LDS  R26,_error_count
	CPI  R26,LOW(0x6)
	BRLO _0x10A
	RCALL SUBOPT_0x50
	wdr
	RCALL SUBOPT_0x3B
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	RCALL SUBOPT_0x6
	wdr
	RCALL SUBOPT_0x50
	wdr
	RCALL SUBOPT_0x3B
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	RCALL SUBOPT_0x6
	wdr
	RCALL SUBOPT_0x50
	wdr
	RCALL SUBOPT_0x3B
	CBI  0x15,1
_0x10A:
	RET
_read_adc:
	RCALL __SAVELOCR4
;	tmpv -> R16,R17
;	ixi -> R19
;	MCUCR_def -> R18
	RCALL SUBOPT_0x5
	LDI  R19,64
	sei
	LDI  R30,LOW(231)
	OUT  0x7,R30
	LDI  R30,LOW(159)
	OUT  0x6,R30
	IN   R18,53
	LDI  R30,LOW(144)
	OUT  0x35,R30
	__DELAY_USW 250
	LDI  R30,LOW(0)
	OUT  0x39,R30
_0x10D:
	CPI  R19,1
	BRLO _0x10F
	sleep
	wdr
	RCALL SUBOPT_0x4D
	__ADDWRR 16,17,30,31
	SUBI R19,1
	RJMP _0x10D
_0x10F:
	RCALL SUBOPT_0x3B
	CBI  0x15,1
	OUT  0x35,R18
	LDI  R30,LOW(0)
	OUT  0x6,R30
	OUT  0x8,R30
	OUT  0x7,R30
	MOVW R26,R16
	LDI  R30,LOW(6)
	RCALL __LSRW12
	RCALL SUBOPT_0x4C
_0x2060004:
	RCALL __LOADLOCR4
_0x2060005:
	ADIW R28,4
	RET
;#include <display_data.h>
_menu_modification_check:
	LDI  R26,0
	SBIS 0x13,2
	LDI  R26,1
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	AND  R30,R26
	BRNE PC+2
	RJMP _0x112
	MOV  R30,R5
	RCALL SUBOPT_0xC
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x116
	RCALL SUBOPT_0x51
	MOVW R22,R30
	MOVW R26,R30
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __GEW12
	MOV  R0,R30
	MOVW R26,R22
	LDI  R30,LOW(9999)
	LDI  R31,HIGH(9999)
	RCALL __LTW12
	AND  R30,R0
	BREQ _0x117
	RCALL SUBOPT_0x51
	SUBI R30,LOW(-500)
	SBCI R31,HIGH(-500)
	RCALL SUBOPT_0x52
_0x117:
	RCALL SUBOPT_0x51
	MOVW R22,R30
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __GEW12
	MOV  R0,R30
	MOVW R26,R22
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __LTW12
	AND  R30,R0
	BREQ _0x118
	RCALL SUBOPT_0x51
	SUBI R30,LOW(-100)
	SBCI R31,HIGH(-100)
	RCALL SUBOPT_0x52
_0x118:
	RCALL SUBOPT_0x51
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRGE _0x119
	RCALL SUBOPT_0x51
	ADIW R30,25
	RCALL SUBOPT_0x52
_0x119:
	RCALL SUBOPT_0x51
	CPI  R30,LOW(0x2710)
	LDI  R26,HIGH(0x2710)
	CPC  R31,R26
	BRLT _0x11A
	LDI  R26,LOW(_alarm_level)
	LDI  R27,HIGH(_alarm_level)
	RCALL SUBOPT_0x48
	RCALL __EEPROMWRW
_0x11A:
	RJMP _0x115
_0x116:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x11B
	RCALL SUBOPT_0x53
	RCALL __EEPROMRDW
	ADIW R30,10
	RCALL SUBOPT_0x53
	RCALL __EEPROMWRW
	RCALL SUBOPT_0x53
	RCALL __EEPROMRDW
	CPI  R30,LOW(0x259)
	LDI  R26,HIGH(0x259)
	CPC  R31,R26
	BRLT _0x11C
	RCALL SUBOPT_0x53
	RCALL SUBOPT_0x54
	RCALL __EEPROMWRW
_0x11C:
	RJMP _0x115
_0x11B:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x11D
	RCALL SUBOPT_0x8
	SUBI R30,-LOW(10)
	LDI  R26,LOW(_Vop)
	LDI  R27,HIGH(_Vop)
	RCALL __EEPROMWRB
	RCALL SUBOPT_0x8
	CPI  R30,LOW(0x79)
	BRLO _0x11E
	LDI  R26,LOW(_Vop)
	LDI  R27,HIGH(_Vop)
	LDI  R30,LOW(10)
	RCALL __EEPROMWRB
_0x11E:
	RCALL SUBOPT_0x8
	ST   -Y,R30
	RCALL _LcdContrast
	RJMP _0x115
_0x11D:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x115
	RCALL SUBOPT_0x4A
	ADIW R30,10
	LDI  R26,LOW(_delay_pump_def)
	LDI  R27,HIGH(_delay_pump_def)
	RCALL __EEPROMWRW
	RCALL SUBOPT_0x4A
	CPI  R30,LOW(0x12D)
	LDI  R26,HIGH(0x12D)
	CPC  R31,R26
	BRLT _0x120
	LDI  R26,LOW(_delay_pump_def)
	LDI  R27,HIGH(_delay_pump_def)
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __EEPROMWRW
_0x120:
_0x115:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	RCALL SUBOPT_0x6
_0x112:
	RET
_menu:
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,30
	RCALL SUBOPT_0x56
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x4
	RCALL _LcdStringInv
	RCALL SUBOPT_0x51
	SBIW R30,0
	BRNE _0x121
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,45
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x57
	BRNE _0x122
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x58
	RCALL _LcdStringInv
	RJMP _0x123
_0x122:
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x58
	RCALL _LcdString
_0x123:
	RJMP _0x124
_0x121:
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,60
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x57
	BRNE _0x125
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x58
	RCALL _LcdStringInv
	RJMP _0x126
_0x125:
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x58
	RCALL _LcdString
_0x126:
_0x124:
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,74
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x53
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x59
	LDI  R30,LOW(2)
	CP   R30,R5
	BRNE _0x127
	RCALL SUBOPT_0x43
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x5A
	RJMP _0x128
_0x127:
	RCALL SUBOPT_0x43
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x5B
_0x128:
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,88
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5D
	LDI  R30,LOW(3)
	CP   R30,R5
	BRNE _0x129
	RCALL SUBOPT_0x43
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x5A
	RJMP _0x12A
_0x129:
	RCALL SUBOPT_0x43
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x5B
_0x12A:
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,104
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x59
	LDI  R30,LOW(4)
	CP   R30,R5
	BRNE _0x12B
	RCALL SUBOPT_0x43
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x5A
	RJMP _0x12C
_0x12B:
	RCALL SUBOPT_0x43
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x5B
_0x12C:
	RCALL _LcdUpdate
	RET
_main_window_draw:
	RCALL __SAVELOCR2
;	i -> R17
;	j -> R16
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,119
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x4F
	RCALL __PUTPARD1
	RCALL SUBOPT_0x5D
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x4
	RCALL _LcdStringBold
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,123
	RCALL SUBOPT_0x56
	LDI  R30,LOW(11)
	ST   -Y,R30
	RCALL SUBOPT_0x41
	RCALL _LcdString
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	MOVW R10,R30
	LDI  R17,LOW(0)
_0x12E:
	CPI  R17,37
	BRSH _0x12F
	RCALL SUBOPT_0x44
	CP   R10,R30
	CPC  R11,R31
	BRSH _0x130
	MOV  R30,R17
	RCALL SUBOPT_0x5E
	LD   R10,X+
	LD   R11,X
_0x130:
	SUBI R17,-1
	RJMP _0x12E
_0x12F:
	LDI  R16,LOW(0)
	LDS  R17,_second
_0x132:
	CPI  R17,1
	BRLO _0x133
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x60
	SUBI R16,-1
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x60
	SUBI R16,-1
	SUBI R17,1
	RJMP _0x132
_0x133:
	LDI  R17,LOW(36)
_0x135:
	RCALL SUBOPT_0x61
	CP   R30,R17
	BRSH _0x136
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x60
	SUBI R16,-1
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x60
	SUBI R16,-1
	SUBI R17,1
	RJMP _0x135
_0x136:
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x54
	RCALL SUBOPT_0x21
	LDI  R30,LOW(36)
	LDI  R31,HIGH(36)
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x54
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,128
	RCALL SUBOPT_0x21
	LDS  R30,_doze_count
	LDS  R31,_doze_count+1
	LDS  R22,_doze_count+2
	LDS  R23,_doze_count+3
	RCALL __PUTPARD1
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x43
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,139
	RCALL SUBOPT_0x21
	LDS  R30,_day_tick
	LDS  R31,_day_tick+1
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x5C
	LDS  R30,_minute_tick
	RCALL SUBOPT_0x5C
	LDS  R30,_second_tick
	RCALL SUBOPT_0x5C
	LDI  R24,16
	RCALL _sprintf
	ADIW R28,20
	RCALL SUBOPT_0x43
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x5B
	LDI  R30,LOW(73)
	LDI  R31,HIGH(73)
	RCALL SUBOPT_0x21
	LDI  R30,LOW(33)
	LDI  R31,HIGH(33)
	RCALL SUBOPT_0x21
	LDI  R30,LOW(83)
	LDI  R31,HIGH(83)
	RCALL SUBOPT_0x21
	LDI  R30,LOW(47)
	LDI  R31,HIGH(47)
	RCALL SUBOPT_0x21
	ST   -Y,R4
	RCALL _LcdBatt
_0x2060003:
	RCALL _LcdUpdate
_0x2060002:
	RCALL __LOADLOCR2P
	RET
;
;
;//********************************************************************
;void check_battery();
;
;//--------------------------------- --------------------------//
;interrupt [ADC_INT] void voidadc_isr(void)
; 0000 005A {
_voidadc_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 005B 	VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
	IN   R30,0x5
	RCALL SUBOPT_0xC
	SBIW R30,1
	LSL  R30
	ROL  R31
	RCALL SUBOPT_0x4C
; 0000 005C }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;//********************************************************************
;
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 0061 {
_ext_int1_isr:
	RCALL SUBOPT_0x63
; 0000 0062 unsigned char i;
; 0000 0063 
; 0000 0064     #asm("wdr")
	ST   -Y,R17
;	i -> R17
	wdr
; 0000 0065     led_refresh(OFF);
	RCALL SUBOPT_0x41
	RCALL _led_refresh
; 0000 0066     need_update=1;
	RCALL SUBOPT_0x64
; 0000 0067     impulse_recive=1;
	SET
	BLD  R2,4
; 0000 0068 //    beep_pin=1;
; 0000 0069     trans=0; //      
	CBI  0x12,1
; 0000 006A     impulse_massive[second]++;
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x65
; 0000 006B     doze_massive[hour_tick]++;
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x67
; 0000 006C     need_pump_by_impulse++;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
; 0000 006D     tick=0;
	LDI  R30,LOW(0)
	STS  _tick,R30
; 0000 006E     impulse_count++;
	LDI  R26,LOW(_impulse_count)
	LDI  R27,HIGH(_impulse_count)
	RCALL SUBOPT_0x67
; 0000 006F     for(i=0;i<impulse_pump;i++)
	LDI  R17,LOW(0)
_0x13A:
	MOVW R30,R6
	RCALL SUBOPT_0x39
	BRSH _0x13B
; 0000 0070     {
; 0000 0071         trans=1;
	RCALL SUBOPT_0x42
; 0000 0072         delay_us(2);
; 0000 0073         trans=0;
; 0000 0074         delay_us(5);
	__DELAY_USB 13
; 0000 0075         #asm("wdr")
	wdr
; 0000 0076     }
	SUBI R17,-1
	RJMP _0x13A
_0x13B:
; 0000 0077 //    beep_pin=0;
; 0000 0078 if(!power_down)
	SBRC R3,1
	RJMP _0x140
; 0000 0079 {
; 0000 007A     beep=1;
	RCALL SUBOPT_0x49
; 0000 007B     TIMSK=0x41;
; 0000 007C     led_refresh(ON);
	RCALL SUBOPT_0x43
	RCALL _led_refresh
; 0000 007D 
; 0000 007E }
; 0000 007F 
; 0000 0080 }
_0x140:
	LD   R17,Y+
	RJMP _0x19F
;
;//********************************************************************
;
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0085 {
_timer0_ovf_isr:
	RCALL SUBOPT_0x63
; 0000 0086 TCNT0=0xFF;
	LDI  R30,LOW(255)
	OUT  0x32,R30
; 0000 0087 if(!beep)
	SBRC R2,5
	RJMP _0x141
; 0000 0088 {
; 0000 0089     TIMSK=0x40;
	RCALL SUBOPT_0x3B
; 0000 008A     beep_pin=0;
	RCALL SUBOPT_0x68
; 0000 008B     led_refresh(ON);
	RCALL _led_refresh
; 0000 008C }
; 0000 008D else
	RJMP _0x144
_0x141:
; 0000 008E {
; 0000 008F     if(beep_count<250)
	LDS  R26,_beep_count
	CPI  R26,LOW(0xFA)
	BRSH _0x145
; 0000 0090     {
; 0000 0091         beep_count++;
	LDS  R30,_beep_count
	SUBI R30,-LOW(1)
	STS  _beep_count,R30
; 0000 0092         if(!beep_active)
	SBRC R2,6
	RJMP _0x146
; 0000 0093         {
; 0000 0094             beep_pin=0;
	RCALL SUBOPT_0x68
; 0000 0095             led_refresh(ON);
	RCALL _led_refresh
; 0000 0096             beep_active=1;
	SET
	RJMP _0x19E
; 0000 0097         }
; 0000 0098         else
_0x146:
; 0000 0099         {
; 0000 009A             led_refresh(OFF);
	RCALL SUBOPT_0x41
	RCALL _led_refresh
; 0000 009B             beep_pin=1;
	SBI  0x15,1
; 0000 009C             beep_active=0;
	CLT
_0x19E:
	BLD  R2,6
; 0000 009D         }
; 0000 009E     }
; 0000 009F     else
	RJMP _0x14C
_0x145:
; 0000 00A0     {
; 0000 00A1 
; 0000 00A2         if(alarm&(!user_cancel_alarm))
	RCALL SUBOPT_0x69
	BREQ _0x14D
; 0000 00A3         {
; 0000 00A4             beep_count=0;
	LDI  R30,LOW(0)
	STS  _beep_count,R30
; 0000 00A5         }
; 0000 00A6         else
	RJMP _0x14E
_0x14D:
; 0000 00A7         {
; 0000 00A8             beep_pin=0;
	RCALL SUBOPT_0x68
; 0000 00A9             led_refresh(ON);
	RCALL _led_refresh
; 0000 00AA             beep_count=0;
	LDI  R30,LOW(0)
	STS  _beep_count,R30
; 0000 00AB             TIMSK=0x40;
	RCALL SUBOPT_0x3B
; 0000 00AC             beep=0;
	RCALL SUBOPT_0x3A
; 0000 00AD         }
_0x14E:
; 0000 00AE 
; 0000 00AF     }
_0x14C:
; 0000 00B0 }
_0x144:
; 0000 00B1 }
	RJMP _0x19F
;//********************************************************************
;
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 00B5 {
_ext_int0_isr:
	RCALL SUBOPT_0x63
; 0000 00B6 bit key2_pressed=0;
; 0000 00B7 need_update=1;
;	key2_pressed -> R15.0
	CLR  R15
	RCALL SUBOPT_0x64
; 0000 00B8 
; 0000 00B9 if(!power_down)
	SBRC R3,1
	RJMP _0x151
; 0000 00BA   {
; 0000 00BB     if(alarm&(!user_cancel_alarm))
	RCALL SUBOPT_0x69
	BREQ _0x152
; 0000 00BC     {
; 0000 00BD         user_cancel_alarm=1;
	SET
	BLD  R2,3
; 0000 00BE         beep=0;
	RCALL SUBOPT_0x3A
; 0000 00BF         beep_pin=0;
	RCALL SUBOPT_0x68
; 0000 00C0         led_refresh(ON);
	RCALL _led_refresh
; 0000 00C1         TIMSK=0x40;
	RCALL SUBOPT_0x3B
; 0000 00C2     }
; 0000 00C3     else
	RJMP _0x155
_0x152:
; 0000 00C4     {
; 0000 00C5         if(menu_active)
	SBRS R2,0
	RJMP _0x156
; 0000 00C6         {
; 0000 00C7            menu_select++;
	INC  R5
; 0000 00C8            if(menu_select>4){menu_active=0;menu_select=1;}
	LDI  R30,LOW(4)
	CP   R30,R5
	BRSH _0x157
	CLT
	BLD  R2,0
	LDI  R30,LOW(1)
	MOV  R5,R30
; 0000 00C9         }
_0x157:
; 0000 00CA     }
_0x156:
_0x155:
; 0000 00CB   }
; 0000 00CC 
; 0000 00CD     display_time=0;
_0x151:
	LDI  R30,LOW(0)
	STS  _display_time,R30
	STS  _display_time+1,R30
; 0000 00CE     LcdPwrOn();
	RCALL _LcdPwrOn
; 0000 00CF     while((!key)&(!poweroff_bit))  //    
_0x158:
	LDI  R26,0
	SBIS 0x10,2
	LDI  R26,1
	LDI  R30,0
	SBRS R2,7
	LDI  R30,1
	AND  R30,R26
	BREQ _0x15A
; 0000 00D0     {
; 0000 00D1         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x6
; 0000 00D2         #asm("wdr")
	wdr
; 0000 00D3         if(!key_plus)key2_pressed=1;
	SBIC 0x13,2
	RJMP _0x15B
	SET
	BLD  R15,0
; 0000 00D4         key_press++;
_0x15B:
	LDI  R26,LOW(_key_press)
	LDI  R27,HIGH(_key_press)
	RCALL SUBOPT_0x65
	SBIW R30,1
; 0000 00D5         if(key_press>50) //    5- ,   
	RCALL SUBOPT_0x6A
	SBIW R26,51
	BRLO _0x15C
; 0000 00D6         {
; 0000 00D7         poweroff_bit=1;
	SET
	BLD  R2,7
; 0000 00D8         GICR=0x00;
	LDI  R30,LOW(0)
	OUT  0x3B,R30
; 0000 00D9         }
; 0000 00DA     }
_0x15C:
	RJMP _0x158
_0x15A:
; 0000 00DB     if((key_press>=10)&(key_press<=50)&key2_pressed)
	RCALL SUBOPT_0x6A
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __GEW12U
	MOV  R0,R30
	RCALL SUBOPT_0x6A
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __LEW12U
	AND  R30,R0
	MOV  R26,R30
	LDI  R30,0
	SBRC R15,0
	LDI  R30,1
	AND  R30,R26
	BREQ _0x15D
; 0000 00DC     {
; 0000 00DD         if(menu_active==0)
	SBRC R2,0
	RJMP _0x15E
; 0000 00DE             {
; 0000 00DF                 menu_active=1;
	SET
	BLD  R2,0
; 0000 00E0             }
; 0000 00E1     }
_0x15E:
; 0000 00E2     key_press=0;
_0x15D:
	LDI  R30,LOW(0)
	STS  _key_press,R30
	STS  _key_press+1,R30
; 0000 00E3 
; 0000 00E4 }
	RJMP _0x19F
;
;//********************************************************************
;
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 00E9 {
_timer2_ovf_isr:
	RCALL SUBOPT_0x63
; 0000 00EA char i;
; 0000 00EB long doze=0;
; 0000 00EC     TIFR |= (1<<TOV2);
	RCALL SUBOPT_0x11
	ST   -Y,R17
;	i -> R17
;	doze -> Y+1
	IN   R30,0x38
	ORI  R30,0x40
	OUT  0x38,R30
; 0000 00ED     TCNT2=0xDF;
	LDI  R30,LOW(223)
	OUT  0x24,R30
; 0000 00EE 
; 0000 00EF     need_update=1;
	RCALL SUBOPT_0x64
; 0000 00F0 
; 0000 00F1     second_tick++;
	LDS  R30,_second_tick
	SUBI R30,-LOW(1)
	STS  _second_tick,R30
; 0000 00F2     if(second_tick>59)
	LDS  R26,_second_tick
	CPI  R26,LOW(0x3C)
	BRLO _0x15F
; 0000 00F3     {
; 0000 00F4         second_tick=0;
	LDI  R30,LOW(0)
	STS  _second_tick,R30
; 0000 00F5         minute_tick++;
	LDS  R30,_minute_tick
	SUBI R30,-LOW(1)
	STS  _minute_tick,R30
; 0000 00F6         check_battery();
	RCALL _check_battery
; 0000 00F7 
; 0000 00F8         for(i=0;i<24;i++)doze+=doze_massive[i]/100; // .
	LDI  R17,LOW(0)
_0x161:
	CPI  R17,24
	BRSH _0x162
	MOV  R30,R17
	LDI  R26,LOW(_doze_massive)
	LDI  R27,HIGH(_doze_massive)
	RCALL SUBOPT_0xC
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x6B
	RCALL __DIVD21U
	RCALL SUBOPT_0x6C
	RCALL __ADDD12
	__PUTD1S 1
	SUBI R17,-1
	RJMP _0x161
_0x162:
; 0000 00F9 doze_count=doze/100;
	RCALL SUBOPT_0x6C
	RCALL SUBOPT_0x6B
	RCALL __DIVD21
	STS  _doze_count,R30
	STS  _doze_count+1,R31
	STS  _doze_count+2,R22
	STS  _doze_count+3,R23
; 0000 00FA     }
; 0000 00FB 
; 0000 00FC     if(minute_tick>59)
_0x15F:
	LDS  R26,_minute_tick
	CPI  R26,LOW(0x3C)
	BRLO _0x163
; 0000 00FD     {
; 0000 00FE         minute_tick=0;
	LDI  R30,LOW(0)
	STS  _minute_tick,R30
; 0000 00FF         hour_tick++;
	RCALL SUBOPT_0x62
	SUBI R30,-LOW(1)
	STS  _hour_tick,R30
; 0000 0100         doze_massive[hour_tick]=0;
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x6D
; 0000 0101     }
; 0000 0102     if(hour_tick>23)
_0x163:
	LDS  R26,_hour_tick
	CPI  R26,LOW(0x18)
	BRLO _0x164
; 0000 0103     {
; 0000 0104         hour_tick=0;
	LDI  R30,LOW(0)
	STS  _hour_tick,R30
; 0000 0105         doze_massive[hour_tick]=0;
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x6D
; 0000 0106         day_tick++;
	LDI  R26,LOW(_day_tick)
	LDI  R27,HIGH(_day_tick)
	RCALL SUBOPT_0x65
; 0000 0107     }
; 0000 0108 
; 0000 0109 
; 0000 010A     #asm("wdr")
_0x164:
	wdr
; 0000 010B 
; 0000 010C     second++;
	RCALL SUBOPT_0x61
	SUBI R30,-LOW(1)
	STS  _second,R30
; 0000 010D     impulse_massive[second]=0;
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x48
	ST   X+,R30
	ST   X,R31
; 0000 010E     if(display_time<1000)display_time++;
	RCALL SUBOPT_0x6E
	CPI  R26,LOW(0x3E8)
	LDI  R30,HIGH(0x3E8)
	CPC  R27,R30
	BRGE _0x165
	LDI  R26,LOW(_display_time)
	LDI  R27,HIGH(_display_time)
	RCALL SUBOPT_0x65
; 0000 010F     need_pump=1;
_0x165:
	SET
	BLD  R2,1
; 0000 0110     if((display_time>sleep_time)&(!alarm))LcdPwrOff();
	RCALL SUBOPT_0x53
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x6E
	RCALL __GTW12
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,2
	LDI  R30,1
	AND  R30,R26
	BREQ _0x166
	RCALL _LcdPwrOff
; 0000 0111 
; 0000 0112 }
_0x166:
	LDD  R17,Y+0
	ADIW R28,5
_0x19F:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;//********************************************************************
;
;  void main(void)
; 0000 0117 {
_main:
; 0000 0118 long i,j;
; 0000 0119 
; 0000 011A #pragma optsize-
; 0000 011B WDTCR=0x1F;
	SBIW R28,8
;	i -> Y+4
;	j -> Y+0
	LDI  R30,LOW(31)
	OUT  0x21,R30
; 0000 011C WDTCR=0x0F;
	LDI  R30,LOW(15)
	OUT  0x21,R30
; 0000 011D #ifdef _OPTIMIZE_SIZE_
; 0000 011E #pragma optsize+
; 0000 011F #endif
; 0000 0120 
; 0000 0121 
; 0000 0122 TCCR0=0x05;
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x3F
; 0000 0123 TCNT0=0xFF;
; 0000 0124 
; 0000 0125 TCCR1A=0x00;
; 0000 0126 TCCR1B=0x00;
; 0000 0127 TCNT1H=0x00;
; 0000 0128 TCNT1L=0x00;
; 0000 0129 ICR1H=0x00;
; 0000 012A ICR1L=0x00;
; 0000 012B OCR1AH=0x00;
; 0000 012C OCR1AL=0x00;
; 0000 012D OCR1BH=0x00;
; 0000 012E OCR1BL=0x00;
; 0000 012F 
; 0000 0130 ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 0131 TCCR2=0x07;
	LDI  R30,LOW(7)
	OUT  0x25,R30
; 0000 0132 TCNT2=0xDF;
	LDI  R30,LOW(223)
	OUT  0x24,R30
; 0000 0133 OCR2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 0134 
; 0000 0135 TIMSK=0x40;
	RCALL SUBOPT_0x3B
; 0000 0136 
; 0000 0137 
; 0000 0138 GICR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
; 0000 0139 MCUCR=0xB0;
	LDI  R30,LOW(176)
	OUT  0x35,R30
; 0000 013A GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 013B 
; 0000 013C PORTD.3=0; //   
	CBI  0x12,3
; 0000 013D DDRD.3=0;
	CBI  0x11,3
; 0000 013E 
; 0000 013F PORTD.2=1; //   
	SBI  0x12,2
; 0000 0140 DDRD.2=0;
	CBI  0x11,2
; 0000 0141 
; 0000 0142 PORTC.2=1; //    "+"
	SBI  0x15,2
; 0000 0143 DDRC.2=0;
	CBI  0x14,2
; 0000 0144 
; 0000 0145 PORTC.1=0; // 
	CBI  0x15,1
; 0000 0146 DDRC.1=1;
	SBI  0x14,1
; 0000 0147 
; 0000 0148 PORTD.0=0; //  
	CBI  0x12,0
; 0000 0149 DDRD.0=1;
	SBI  0x11,0
; 0000 014A 
; 0000 014B PORTD.5=0; //  
	CBI  0x12,5
; 0000 014C DDRD.5=1;
	SBI  0x11,5
; 0000 014D 
; 0000 014E PORTD.1=0; //    .
	CBI  0x12,1
; 0000 014F DDRD.1=1;
	SBI  0x11,1
; 0000 0150 
; 0000 0151 
; 0000 0152 
; 0000 0153 LcdPwrOn();
	RCALL _LcdPwrOn
; 0000 0154 LcdInit();
	RCALL _LcdInit
; 0000 0155 
; 0000 0156 led_refresh(ON);
	RCALL SUBOPT_0x43
	RCALL _led_refresh
; 0000 0157 
; 0000 0158 	LcdClear();
	RCALL SUBOPT_0x3D
; 0000 0159 
; 0000 015A 	sprintf (lcd_buf, "   -2   ");
	__POINTW1FN _0x0,160
	RCALL SUBOPT_0x56
; 0000 015B 	LcdStringInv(1,1);
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x4
	RCALL _LcdStringInv
; 0000 015C     sprintf (lcd_buf, "        FW:1.0");
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,175
	RCALL SUBOPT_0x56
; 0000 015D 	LcdString(1,2);
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x41
	RCALL _LcdString
; 0000 015E     sprintf (lcd_buf, "     by Shodan");
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,190
	RCALL SUBOPT_0x56
; 0000 015F 	LcdString(1,3);
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x58
	RCALL _LcdString
; 0000 0160     LcdUpdate();
	RCALL _LcdUpdate
; 0000 0161 
; 0000 0162     delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x6
; 0000 0163 
; 0000 0164     sprintf(lcd_buf, "");
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,205
	RCALL SUBOPT_0x56
; 0000 0165 	LcdStringInv(1,5);
	RCALL SUBOPT_0x43
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x5A
; 0000 0166 	LcdUpdate();
	RCALL _LcdUpdate
; 0000 0167 
; 0000 0168 check_battery();
	RCALL _check_battery
; 0000 0169 
; 0000 016A {
; 0000 016B #asm("cli")
	cli
; 0000 016C     j=0;
	RCALL SUBOPT_0x6F
; 0000 016D 
; 0000 016E     //while(1)
; 0000 016F     for(i=0;i<60000;i++) //  
	LDI  R30,LOW(0)
	__CLRD1S 4
_0x184:
	RCALL SUBOPT_0x70
	__CPD2N 0xEA60
	BRGE _0x185
; 0000 0170     {
; 0000 0171         j++;
	RCALL __GETD1S0
	RCALL SUBOPT_0x71
	RCALL __PUTD1S0
; 0000 0172         trans=1;
	RCALL SUBOPT_0x42
; 0000 0173         delay_us(2);
; 0000 0174         trans=0;
; 0000 0175         delay_us(40);
	__DELAY_USB 107
; 0000 0176         #asm("wdr")
	wdr
; 0000 0177         if(j==10000)
	RCALL __GETD2S0
	__CPD2N 0x2710
	BRNE _0x18A
; 0000 0178         {
; 0000 0179         j=0;
	RCALL SUBOPT_0x6F
; 0000 017A             sprintf (lcd_buf, ".");
	RCALL SUBOPT_0x55
	__POINTW1FN _0x0,58
	RCALL SUBOPT_0x56
; 0000 017B 	        LcdStringInv(9+(i/10000),5);
	RCALL SUBOPT_0x70
	__GETD1N 0x2710
	RCALL __DIVD21
	SUBI R30,-LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x5A
; 0000 017C 	        LcdUpdate();
	RCALL _LcdUpdate
; 0000 017D         }
; 0000 017E 
; 0000 017F     }
_0x18A:
	__GETD1S 4
	RCALL SUBOPT_0x71
	__PUTD1S 4
	RJMP _0x184
_0x185:
; 0000 0180     delay_ms(2);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x6
; 0000 0181 }
; 0000 0182 #asm("sei") // 
	sei
; 0000 0183 
; 0000 0184 LcdClear();
	RCALL _LcdClear
; 0000 0185 ///////////////////////////////////////////////////////////
; 0000 0186 while (1)
_0x18B:
; 0000 0187 {
; 0000 0188 if(need_update)
	SBRS R3,0
	RJMP _0x18E
; 0000 0189 {
; 0000 018A     need_update=0;
	CLT
	BLD  R3,0
; 0000 018B 
; 0000 018C     calc_counters();
	RCALL _calc_counters
; 0000 018D     #asm("wdr")
	wdr
; 0000 018E 
; 0000 018F     if(poweroff_bit)
	SBRS R2,7
	RJMP _0x18F
; 0000 0190     {
; 0000 0191         TIMSK=0x40;
	RCALL SUBOPT_0x3B
; 0000 0192         beep=0;
	RCALL SUBOPT_0x3A
; 0000 0193         beep_pin=0;
	CBI  0x15,1
; 0000 0194         poweroff();
	RCALL _poweroff
; 0000 0195     }
; 0000 0196 
; 0000 0197     alarm_check();
_0x18F:
	RCALL _alarm_check
; 0000 0198     #asm("wdr")
	wdr
; 0000 0199 
; 0000 019A     menu_modification_check();
	RCALL _menu_modification_check
; 0000 019B     #asm("wdr")
	wdr
; 0000 019C 
; 0000 019D     led_refresh(NONE);
	RCALL SUBOPT_0x58
	RCALL _led_refresh
; 0000 019E 
; 0000 019F     if(!power_down)
	SBRC R3,1
	RJMP _0x192
; 0000 01A0     {
; 0000 01A1         LcdClear_massive();
	RCALL _LcdClear_massive
; 0000 01A2         #asm("wdr")
	wdr
; 0000 01A3         if(menu_active)
	SBRS R2,0
	RJMP _0x193
; 0000 01A4         {menu();}
	RCALL _menu
; 0000 01A5         else
	RJMP _0x194
_0x193:
; 0000 01A6         {main_window_draw();}
	RCALL _main_window_draw
_0x194:
; 0000 01A7     }
; 0000 01A8 
; 0000 01A9 }
_0x192:
; 0000 01AA 
; 0000 01AB pump();
_0x18E:
	RCALL _pump
; 0000 01AC 
; 0000 01AD #asm("wdr")
	wdr
; 0000 01AE 
; 0000 01AF if(!menu_active)
	SBRC R2,0
	RJMP _0x195
; 0000 01B0 {
; 0000 01B1     if(!beep)
	SBRC R2,5
	RJMP _0x196
; 0000 01B2     {
; 0000 01B3         //led_refresh(ON);
; 0000 01B4         #asm("sleep")
	sleep
; 0000 01B5     }
; 0000 01B6     #asm("wdr")
_0x196:
	wdr
; 0000 01B7 }
; 0000 01B8 else
	RJMP _0x197
_0x195:
; 0000 01B9 {
; 0000 01BA     need_update=1;
	RCALL SUBOPT_0x64
; 0000 01BB }
_0x197:
; 0000 01BC 
; 0000 01BD };
	RJMP _0x18B
; 0000 01BE }
_0x198:
	RJMP _0x198
;
;//-------------------------------------------
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x72
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x73
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	RCALL SUBOPT_0x72
	ADIW R26,2
	RCALL SUBOPT_0x65
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	RCALL SUBOPT_0x72
	RCALL __GETW1P
	TST  R31
	BRMI _0x2000014
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x65
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	RCALL SUBOPT_0x72
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	RCALL __LOADLOCR2
	ADIW R28,5
	RET
__print_G100:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL SUBOPT_0x48
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	RCALL SUBOPT_0x74
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	RCALL SUBOPT_0x74
	RJMP _0x20000C9
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	RCALL SUBOPT_0x75
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x75
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x77
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x79
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x21
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x79
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x21
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	RCALL SUBOPT_0x17
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	RCALL SUBOPT_0x17
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x79
	RCALL SUBOPT_0x7A
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x7A
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x79
	RCALL SUBOPT_0x7A
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	RCALL SUBOPT_0x74
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	RCALL SUBOPT_0x19
	LPM  R18,Z+
	RCALL SUBOPT_0x17
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	RCALL SUBOPT_0x74
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	RCALL SUBOPT_0x19
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	RCALL SUBOPT_0x19
	ADIW R30,2
	RCALL SUBOPT_0x17
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x7A
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CA
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x77
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	RCALL SUBOPT_0x74
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x77
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000C9:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x7B
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2060001
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	RCALL SUBOPT_0x7B
	RCALL SUBOPT_0x17
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x21
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	RCALL SUBOPT_0x21
	MOVW R30,R28
	ADIW R30,10
	RCALL SUBOPT_0x21
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2060001:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.ESEG
_delay_pump_def:
	.DW  0x8C
_sleep_time:
	.DW  0x1E
_alarm_level:
	.DW  0x32
_Vop:
	.DB  0x50

	.DSEG
_tick:
	.BYTE 0x1
_second:
	.BYTE 0x1
_impulse_count:
	.BYTE 0x4
_doze_count:
	.BYTE 0x4
_second_tick:
	.BYTE 0x1
_minute_tick:
	.BYTE 0x1
_hour_tick:
	.BYTE 0x1
_day_tick:
	.BYTE 0x2
_impulse_massive:
	.BYTE 0x4C
_doze_massive:
	.BYTE 0x64
_key_press:
	.BYTE 0x2
_VoltLevel:
	.BYTE 0x2
_display_time:
	.BYTE 0x2
_error_count:
	.BYTE 0x1
_beep_count:
	.BYTE 0x1
_lcd_buf:
	.BYTE 0xF
_temp_control:
	.BYTE 0x1
_bias:
	.BYTE 0x1
_disp_config:
	.BYTE 0x1
_shift:
	.BYTE 0x1
_LcdCache:
	.BYTE 0x1F8
_LcdCacheIdx:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x0:
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _LcdSend

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _LcdSend

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3:
	LDI  R26,LOW(_LcdCache)
	LDI  R27,HIGH(_LcdCache)
	ADD  R26,R16
	ADC  R27,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	__GETWRN 16,17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	MOV  R30,R26
	LSL  R30
	LSL  R30
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x8:
	LDI  R26,LOW(_Vop)
	LDI  R27,HIGH(_Vop)
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	LDI  R26,0
	SBRC R3,1
	LDI  R26,1
	MOV  R30,R26
	LSL  R30
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	LDD  R26,Y+5
	RCALL SUBOPT_0x0
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB:
	RCALL __MULW12
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 43 TIMES, CODE SIZE REDUCTION:82 WORDS
SUBOPT_0xC:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xD:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xE:
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	MOV  R30,R19
	LDI  R26,LOW(1)
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x10:
	SUBI R30,LOW(-_LcdCache)
	SBCI R31,HIGH(-_LcdCache)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x11:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13:
	LDD  R26,Y+15
	LDD  R27,Y+15+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x14:
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x15:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x16:
	LDD  R30,Y+17
	ST   -Y,R30
	LDD  R30,Y+16
	ST   -Y,R30
	LDD  R30,Y+12
	ST   -Y,R30
	RJMP _LcdPixel

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x17:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0xD
	STD  Y+15,R30
	STD  Y+15+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x19:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	MOVW R30,R20
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0xD
	STD  Y+17,R30
	STD  Y+17+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x17
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x1C:
	RCALL SUBOPT_0x14
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1D:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x1C

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _LcdLine

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x20:
	RCALL SUBOPT_0x14
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 80 TIMES, CODE SIZE REDUCTION:77 WORDS
SUBOPT_0x21:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x22:
	RCALL SUBOPT_0x14
	SBIW R30,7
	RCALL SUBOPT_0x21
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	SBIW R30,2
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x24:
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	RCALL SUBOPT_0xE
	SBIW R30,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x25:
	RCALL SUBOPT_0x14
	ADIW R30,2
	RCALL SUBOPT_0x21
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	MOV  R30,R19
	RCALL SUBOPT_0xC
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x23

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x26:
	LDD  R26,Y+11
	LDD  R27,Y+11+1
	SBIW R26,2
	MOV  R30,R19
	RCALL SUBOPT_0xC
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x27:
	STS  _LcdCacheIdx,R30
	STS  _LcdCacheIdx+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x28:
	MOV  R30,R17
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x29:
	SUBI R30,LOW(-_lcd_buf)
	SBCI R31,HIGH(-_lcd_buf)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0x2B:
	LDI  R26,LOW(_LcdCacheIdx)
	LDI  R27,HIGH(_LcdCacheIdx)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2C:
	MOVW R22,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2D:
	RCALL SUBOPT_0xD
	SUBI R30,LOW(-_table*2)
	SBCI R31,HIGH(-_table*2)
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2E:
	LDI  R26,LOW(255)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2F:
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x30:
	LDD  R30,Y+2
	RCALL SUBOPT_0xC
	LDI  R26,LOW(15)
	LDI  R27,HIGH(15)
	RCALL __SWAPW12
	RCALL SUBOPT_0xE
	MOV  R26,R17
	RCALL SUBOPT_0x0
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	RCALL SUBOPT_0x29
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x32:
	MOV  R30,R18
	ANDI R30,LOW(0x1)
	LDI  R26,LOW(3)
	MULS R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x33:
	MOV  R30,R18
	ANDI R30,LOW(0x2)
	LDI  R26,LOW(6)
	MULS R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x34:
	MOV  R30,R18
	ANDI R30,LOW(0x4)
	LDI  R26,LOW(12)
	MULS R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x35:
	MOV  R30,R18
	ANDI R30,LOW(0x8)
	LDI  R26,LOW(24)
	MULS R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x36:
	MOV  R30,R19
	COM  R30
	ST   X,R30
	LDS  R30,_LcdCacheIdx
	LDS  R31,_LcdCacheIdx+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	MOVW R26,R30
	MOV  R30,R16
	COM  R30
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x38:
	LDS  R30,_LcdCacheIdx
	LDS  R31,_LcdCacheIdx+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x39:
	MOV  R26,R17
	RCALL SUBOPT_0x0
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3A:
	CLT
	BLD  R2,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x3B:
	LDI  R30,LOW(64)
	OUT  0x39,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3C:
	BLD  R3,1
	LDI  R30,LOW(3)
	ST   -Y,R30
	RJMP _led_refresh

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3D:
	RCALL _LcdClear
	LDI  R30,LOW(_lcd_buf)
	LDI  R31,HIGH(_lcd_buf)
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3E:
	RCALL SUBOPT_0x21
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _LcdStringInv
	RJMP _LcdUpdate

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x3F:
	OUT  0x33,R30
	LDI  R30,LOW(255)
	OUT  0x32,R30
	LDI  R30,LOW(0)
	OUT  0x2F,R30
	OUT  0x2E,R30
	OUT  0x2D,R30
	OUT  0x2C,R30
	OUT  0x27,R30
	OUT  0x26,R30
	OUT  0x2B,R30
	OUT  0x2A,R30
	OUT  0x29,R30
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x40:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x41:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x42:
	SBI  0x12,1
	__DELAY_USB 5
	CBI  0x12,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x43:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0x44:
	MOV  R30,R17
	LDI  R26,LOW(_impulse_massive)
	LDI  R27,HIGH(_impulse_massive)
	RCALL SUBOPT_0xC
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x45:
	LDS  R26,_impulse_count
	LDS  R27,_impulse_count+1
	LDS  R24,_impulse_count+2
	LDS  R25,_impulse_count+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x46:
	LDI  R26,LOW(_alarm_level)
	LDI  R27,HIGH(_alarm_level)
	RCALL __EEPROMRDW
	MOV  R1,R30
	MOV  R31,R31
	RCALL SUBOPT_0x45
	RCALL __CWD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x47:
	LDI  R30,0
	SBRS R2,3
	LDI  R30,1
	AND  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x48:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x49:
	SET
	BLD  R2,5
	LDI  R30,LOW(65)
	OUT  0x39,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4A:
	LDI  R26,LOW(_delay_pump_def)
	LDI  R27,HIGH(_delay_pump_def)
	RCALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4B:
	LDS  R26,_VoltLevel
	LDS  R27,_VoltLevel+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4C:
	STS  _VoltLevel,R30
	STS  _VoltLevel+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4D:
	LDS  R30,_VoltLevel
	LDS  R31,_VoltLevel+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4E:
	LDI  R30,LOW(65)
	OUT  0x39,R30
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4F:
	LDS  R30,_impulse_count
	LDS  R31,_impulse_count+1
	LDS  R22,_impulse_count+2
	LDS  R23,_impulse_count+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x50:
	LDI  R30,LOW(65)
	OUT  0x39,R30
	RJMP SUBOPT_0x40

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x51:
	LDI  R26,LOW(_alarm_level)
	LDI  R27,HIGH(_alarm_level)
	RCALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x52:
	LDI  R26,LOW(_alarm_level)
	LDI  R27,HIGH(_alarm_level)
	RCALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x53:
	LDI  R26,LOW(_sleep_time)
	LDI  R27,HIGH(_sleep_time)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x54:
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x55:
	LDI  R30,LOW(_lcd_buf)
	LDI  R31,HIGH(_lcd_buf)
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x56:
	RCALL SUBOPT_0x21
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x57:
	RCALL __CWD1
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(1)
	CP   R30,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x58:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x59:
	RCALL __CWD1
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5A:
	ST   -Y,R30
	RJMP _LcdStringInv

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5B:
	ST   -Y,R30
	RJMP _LcdString

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5C:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5D:
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5E:
	LDI  R26,LOW(_impulse_massive)
	LDI  R27,HIGH(_impulse_massive)
	RCALL SUBOPT_0xC
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x5F:
	MOV  R30,R16
	RCALL SUBOPT_0xC
	MOVW R26,R30
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x54
	RCALL SUBOPT_0x21
	MOVW R30,R26
	RCALL SUBOPT_0x21
	RJMP SUBOPT_0x44

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x60:
	RCALL __LSLW4
	MOVW R26,R30
	MOVW R30,R10
	RCALL __DIVW21U
	LDI  R26,LOW(30)
	LDI  R27,HIGH(30)
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x61:
	LDS  R30,_second
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x62:
	LDS  R30,_hour_tick
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x63:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x64:
	SET
	BLD  R3,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x65:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x66:
	RCALL SUBOPT_0x62
	LDI  R26,LOW(_doze_massive)
	LDI  R27,HIGH(_doze_massive)
	RCALL SUBOPT_0xC
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x67:
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x68:
	CBI  0x15,1
	RJMP SUBOPT_0x43

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x69:
	LDI  R26,0
	SBRC R2,2
	LDI  R26,1
	RJMP SUBOPT_0x47

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6A:
	LDS  R26,_key_press
	LDS  R27,_key_press+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6B:
	__GETD1N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6C:
	__GETD2S 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6D:
	__GETD1N 0x0
	RCALL __PUTDP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6E:
	LDS  R26,_display_time
	LDS  R27,_display_time+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6F:
	LDI  R30,LOW(0)
	RCALL __CLRD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x70:
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x71:
	__SUBD1N -1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x72:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x73:
	ADIW R26,4
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x74:
	ST   -Y,R18
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x21
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x75:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x76:
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x77:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x21
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x78:
	RCALL SUBOPT_0x75
	RJMP SUBOPT_0x76

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x79:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	RJMP SUBOPT_0x73

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7A:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7B:
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

	.equ __w1_port=0x12
	.equ __w1_bit=0x02

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BREQ __EQW12T
	CLR  R30
__EQW12T:
	RET

__GEW12:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRGE __GEW12T
	CLR  R30
__GEW12T:
	RET

__LTW12:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLT __LTW12T
	CLR  R30
__LTW12T:
	RET

__GTW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLT __GTW12T
	CLR  R30
__GTW12T:
	RET

__LEW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRSH __LEW12UT
	CLR  R30
__LEW12UT:
	RET

__GEW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRSH __GEW12UT
	CLR  R30
__GEW12UT:
	RET

__LTD12U:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	LDI  R30,1
	BRLO __LTD12UT
	CLR  R30
__LTD12UT:
	RET

__GTD12U:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	LDI  R30,1
	BRLO __GTD12UT
	CLR  R30
__GTD12UT:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__CLRD1S0:
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
